      program casread
c
c     reads in a cascade file and write to screen
c

      implicit none

      include 'version.inc' 
      include 'bdate.inc' 
      include 'ctrlblk.inc' 
      
      character file*40, fcas*40, window*8, windowrr*8, stime*19
      character line*80, hash*1, dbase*3
      integer instr1, instr2, nchan2, nchan1, npt
      integer m, kspecy, kspecz, i, azimuth
      integer getnarg, narg
      character*2 cprint
      character*4 casver
      real samp
      real lat1, long1, elev1
      real lat2, long2, elev2
      real y(49), z(49)
      logical HEADER
      integer*4 lnblnk

      character*6 progprec, dataprec
      logical SINGLE




      call precision( SINGLE )
      if( SINGLE ) then
        progprec = 'SINGLE'
      else
        progprec = 'DOUBLE'
      endif


      narg = getnarg()
      if( narg.ge.1 ) then
        call getcmdarg( 1, cprint) 
        read(cprint,'(i2)') iprint
      else
        iprint = 0
      end if
      call iin( 'Give print level (-1/0/1/2/3)',iprint)

      if( iprint.ge.0 ) then
        write(*,*)' '
        write(*,*)' >>>>>>>>>>>>> CASREAD <<<<<<<<<<<<<<<<<<<'
        write(*,*)' '
        write(*,*)'           version = ', ver
        write(*,*)'build date = ', bdate
        write(*,*)' '
        write(*,*)'It is assumed that this program is being run from'
        write(*,*)'the database directory of the project '
        write(*,*)'(e.g. /local/mt/lims/nod)  '
        write(*,*)'and that all data files reside in subdirectories'
        write(*,*)'with the respective station names '
        write(*,*)'(e.g. /local/mt/lims/nod/nod001 nod002 etc.)'
        write(*,*)' '
        write(*,*)'windows and hardware database files are required'
        write(*,*)'(e.g. windows.nod & hardware.nod) '
        write(*,*)' '
      end if

      dbase = 'tho'
      call tin( 'Give database namename', dbase )

      file = '.cas'
10    call tin( 'Give cascade filename (no extension)', file )
      if( index(file,'.cas').eq.0 ) then
        fcas = dbase//file(1:3)//'/'//file(1:8)//'.cas'
      else
        fcas = dbase//file(1:3)//'/'//file
      endif
      write(*,*)'Opening file: ', fcas(1:lnblnk(fcas))
      open(unit=4,file=fcas,form='UNFORMATTED',status='old',err=20)
      goto 30

20    write(*,*)'Error opening file with name >',file
      goto 10

c...read comment block information
30    read(4) hash
      do while( hash.eq.'#' )
        backspace(4)
        read(4) line
        write(*,*)'Comment: ',line(1:lnblnk(line))
        read(4) hash
      enddo
      backspace(4)

c...read in header information
      read(4) casver
      read(4) dataprec

      write(*,'(2a)')'Cascade version =', casver
      write(*,'(a)') dataprec//' precision cascade file'

      if( casver.ne.ver ) then
        write(*,*)'Cascade file with different version'
        write(*,*)'Program version =',ver,'   Cascade file =',casver
        write(*,*)'Re-run tscascade'
        stop
      endif

      if( progprec.ne.dataprec ) then
        write(*,*)'Cascade file with different precision'
        write(*,*)'Program version ='//progprec//'   Cascade file ='//
     &            dataprec
        stop
      endif


      read(4) window,   instr1, nchan1, lat1, long1, elev1
      read(4) windowrr, instr2, nchan2, lat2, long2, elev2
      read(4) stime, samp, npt, azimuth

      write(*,'(5a,2i3,a,2i2)')' window=', window,'  remote=',
     &           windowrr,' instruments = ', instr1, instr2,
     &           ' channels=', nchan1, nchan2
      write(*,'(a,i4.3)') '      azimuth=',azimuth
      write(*,'(a,a19)') '      start     =',stime

      HEADER = .TRUE.
      call lin( 'Headers only? ', HEADER )

   11 read(4,end=50) m, kspecy, (y(i),i=1,49),
     &                  kspecz, (z(i),i=1,49)
      write(*,*) 'm, kspecy, kspecz = ', m, kspecy, kspecz
      if( .not.HEADER ) then
        do i = 1, 49
          write(*,*) 'i, y, z = ', i, y(i), z(i)
        end do
        call pause('Paused...')
      endif
      goto 11

   50 stop
      end

