      include 'fgraph.fi'
c-------------------------------------------------------------------
      subroutine endplt
c-------------------------------------------------------------------
      include   'fgraph.fd'
      real      lastx, lasty, psscale
      integer*4 lout, iold, icount
      logical   ps
      record /rccoord/ curpos
      common /output/ lout, ps, iold, lastx, lasty, psscale, icount
c
      call settextposition(1,1,curpos)
      call pcolor( 1 )
      call outtext('Press <RET> to continue')
      read(*,*)
c
c Close the postscript file
c
      if(ps) then
        write(lout,1) 
1       format('showpage')
        close(unit=lout)
      end if
c
c Reset the video mode
c
      dummy = setvideomode( $defaultmode )
      call unregisterfonts()
      return
      end 
c-------------------------------------------------------------------
      subroutine opnplt(terminal)
c-------------------------------------------------------------------
c Assumptions: All plotting is in mm. Subroutine SCALE converts from 
c              user units to mm. All postscript output in points.
c
      character terminal*(*), a*1
      real      xorg, yorg, scfact, xmax, ymax, lastx, lasty, psscale
      integer   lout, iold, icount
      integer*2 maxx, maxy
      logical   ps
c
      common /screensize/ maxx, maxy, xmax, ymax
      common /output/ lout, ps, iold, lastx, lasty, psscale, icount
      common /origin/ xorg, yorg, scfact
c
c Dummy use of dead variable TERMINAL - to maintain compatibility with SUNS
c
      a = terminal(1:1)
c
c Set up output for ascii postscript file to unit 1
c
      lout = 1
      iold = 0
      ps   = .true.
c
      call graphics_mode()
c
c Origin is at the lower left corner of the screen
c
      xorg = 0.0
      yorg = 0.0
c
c Estimated size (in mm) of output device (PC screens)
c
      xmax = 250.0
      ymax = 200.0
c
c Scaling set for mm initially
c
      scfact = 1.0
c
c Set up postscript style output
c
      if(ps) then
        open(unit=lout,file='post.ps',status='unknown')
        write(lout,1) 
1       format('%!',/,
     >         '%%Creator: PC Microsoft FORTRAN plotting package',/,
     >         '%%Pages: 1',/,
     >         '%%EndComments',//,
     >         '/l {lineto} def /m {moveto} def ',
     >         '/srgb {setrgbcolor} def',/,'/font {/Helvetica} def ',
     >         '/s {stroke} def /n {newpath} def',//,'%%EndProlog',/)
        write(lout,2)
2       format('550 40 translate 90 rotate ')
        psscale = 72.0 / 25.4
        icount = 1
      end if
c
c Initial color is white.
c
      call pcolor( 1 )
c
      return
      end
c-------------------------------------------------------------------
      subroutine scale(factor)
c-------------------------------------------------------------------
c Convert all user entered units to mm using FACTOR.
c
      real      xorg, yorg, factor, scfact
      common /origin/ xorg, yorg, scfact
c
      scfact = factor
c
      return
      end
c------------------------------------------------------------------
      subroutine pcolor( icol )
c------------------------------------------------------------------
      include   'fgraph.fd'
      integer*4 icol, red(16), grn(16), blu(16), lout, i, dummy4, rgb
      integer*4 icount
      integer*2 dummy, cicol
      real      lastx, lasty, psscale
      logical   ps
      common /output/ lout, ps, iold, lastx, lasty, psscale, icount
c
      DATA red /  0, 63, 63, 21,  0, 63, 10, 21,
     >            0,  0, 63, 25, 25,  0, 32, 63/
      DATA grn /  0, 63,  0,  0, 21, 10, 63, 47,
     >           63, 38,  0, 38, 25, 63,  0, 63/
      DATA blu /  0, 63, 63, 63, 63,  0,  0, 16,
     >           43, 63, 42, 63, 63, 63, 63,  0/
c
      if(iold.eq.0) then
        do i = 1, 16
          itmp  = rgb(red(i),grn(i),blu(i))
          dummy4 = remappalette(i-1,itmp)
        end do
      end if
c
      cicol = icol 
      dummy = settextcolor( cicol )
      dummy = setcolor( cicol )
c
      if(ps) then
        i = cicol + 1
        if(cicol.eq.1) i = 1
        write(lout,1) float(red(i))/63.0, float(grn(i))/63.0, 
     >                float(blu(i))/63.0
1       format(2x,3(f4.2,1x),'srgb')
      end if
c
      return
      end
c----------------------------------------------------------------------
      subroutine plot(x,y,jpen)
c----------------------------------------------------------------------
      include 'fgraph.fd'
      real    x, y, xx, yy, xorg, yorg, scfact, lastx, lasty, psscale
      integer*4 ipen, jpen, iold, icount
      integer*2 dummy, newx, newy
      record /xycoord/ xy
c
      integer lout
      logical ps, plt
      common /output/ lout, ps, iold, lastx, lasty, psscale, icount
      common /origin/ xorg, yorg, scfact
      common /lastcall/ plt
c
      ipen = jpen
      xx = x * scfact + xorg
      yy = y * scfact + yorg
c
c This resets the origin
c
      if(ipen.eq.-3) then
        xorg = xx
        yorg = yy
        ipen = 3
      end if
c
      if(ipen.eq.3) call moveto(newx(xx),newy(yy),xy)
      if(ipen.eq.2) dummy = lineto(newx(xx),newy(yy))
c
      if(ps) then
        if(ipen.eq.2) then
c
c The IOLD refers to last call to PLOT. Used to eliminate sequential moves
c that do not draw anything
c
          if(plt.and.iold.eq.3) then
            write(lout,5)
            write(lout,3) lastx, lasty
            icount = 1
          end if
          write(lout,2) xx*psscale, yy*psscale
          icount = icount + 1
          if(icount.gt.1000) then
            write(lout,4)
            write(lout,5)
            write(lout,3) xx*psscale, yy*psscale
            icount = 1
          end if
c
c Move the pen without drawing
c
         else if(ipen.eq.3) then
          if(plt.and.iold.eq.2) write(lout,4)
          lastx = xx * psscale
          lasty = yy * psscale
        end if
        iold = ipen
      end if
      plt = .true.
4     format('s')
5     format('n')
2     format(1x,2(f7.2,1x),' l')
3     format(1x,2(f7.2,1x),' m')
      return
      end
c---------------------------------------------------------------------------
      subroutine symbol(x,y,hite,string,theta,nchars)
c---------------------------------------------------------------------------
      include   'fgraph.fd'
      character string*(*), iostring*80, font*10/"t'modern'"/
      real      x, y, hite, theta, xx, yy, hhite, xorg, yorg, scfact
      real      lastx, lasty, psscale, xmax, ymax, hiteold/0.0/
      integer   nchars, icount
      integer*2 dummy, newx, newy, newh, neww, maxx, maxy
      record /xycoord/ xy
c
      integer lout, i, j, iold
      logical ps, plt
      character width*2, height*2
c
      common /screensize/ maxx, maxy, xmax, ymax
      common /output/ lout, ps, iold, lastx, lasty, psscale, icount
      common /origin/ xorg, yorg, scfact
      common /lastcall/ plt
c
      xx = x * scfact + xorg
      yy = y * scfact + yorg
      hhite = hite * scfact
      iostring = string(1:nchars)
      write(height,'(i2)') max(newh(hhite*1.6),1)
      write(width,'(i2)')  max(nint(neww(hhite*1.4)*.5),1)
      call trunc(height,i)
      call trunc(width,j)
      dummy = setfont( font//'h'//height(1:i)//'w'//width(1:j)//'v' )
c
      call trunc(iostring,nchars)
      if(nchars.eq.0) return
c
c 999 is a code to continue plotting from end of the last string - 
c coordinates are only needed for the postscript file.
c
      if(x.eq.999.0.and.y.eq.999.0) then
        call outgtext(iostring(1:nchars))
       else
        call moveto(newx(xx),newy(yy+hhite),xy)
        call outgtext(iostring(1:nchars))
      end if
c
c Postscript fonts set in opnplt
c
      if(ps) then
        if(plt.and.iold.eq.1) write(lout,2)
1       format('s')
        if(hite.ne.hiteold) then
          write(lout,4) nint(hhite*psscale)
4         format('/fontsize ',i2,' def font findfont fontsize ',
     >           'scalefont setfont')
        end if
        if(x.eq.999.0.and.y.eq.999.0) then
          write(lout,5) string(1:nchars)
5         format('currentpoint moveto (',a,') show')
         else
          xx = xx * psscale
          yy = yy * psscale
          if(theta.eq.0.0) then
            write(lout,2) xx, yy, string(1:nchars)
           else
            write(lout,3) xx, yy, theta, string(1:nchars)
          end if
        end if
        hiteold = hite
      end if
2     format(1x,2(f7.2,1x),' m (',a,') show')
3     format(1x,2(f7.2,1x),' m gsave ',f5.1,' rotate (',a,
     >       ') show grestore')
      plt = .false.
      return
      end
c---------------------------------------------------------------------------
       subroutine number(x,y,hite,rnumber,theta,fmt)
c---------------------------------------------------------------------------
      character iostring*80, iofmt*20, fmt*(*) 
      real      x, y, hite, theta, rnumber
      integer   nchars
c
      iofmt = fmt
      call shiftup(iofmt)
      call trunc(iofmt,nchars)
c
c Number is just an internal write and a call to symbol. Handle integers.
c
      if(index(iofmt(:nchars),'I').eq.0) then
        write(iostring,'('//iofmt(1:nchars)//')',err=1) rnumber
       else if(index(iofmt(:nchars),'I').ne.0) then
        write(iostring,'('//iofmt(1:nchars)//')',err=1) nint(rnumber)
      end if
      call trunc(iostring,nchars)
      call symbol(x,y,hite,iostring(1:nchars),theta,nchars)
1     return
      end
c--------------------------------------------------------------------------
      subroutine graphics_mode()
c--------------------------------------------------------------------------
      include   'fgraph.fd'
      integer*2 dummy, maxx, maxy
      real*4    xmax, ymax
      record /videoconfig/ myscreen
      common /screensize/  maxx, maxy, xmax, ymax
c
c Select the `best' video mode - ie highest resolution then max colors.
c
      call getvideoconfig( myscreen )
      select case( myscreen.adapter )
        case( $cga )
         dummy = setvideomode( $HRESBW )
        case( $ocga )
         dummy = setvideomode( $ORESCOLOR )
        case( $ega, $oega )
         if( myscreen.monitor .eq. $mono ) then
           dummy = setvideomode( $ERESNOCOLOR )
          else
           dummy = setvideomode( $ERESCOLOR )
         end if
        case( $mcga )
         dummy = setvideomode( $VRES2COLOR )
        case( $vga, $ovga )
         dummy = setvideomode( $VRES16COLOR )
        case( $hgc )
         dummy = setvideomode( $HERCMONO )
        case default
         dummy = 0
      end select
      if(dummy.eq.0) stop 'Error: cannot set graphics mode'
      call getvideoconfig( myscreen )
      maxx = myscreen.numxpixels - 1
      maxy = myscreen.numypixels - 1
c
c Select vector style fonts - pixel fonts don't work as well for this
c package and I wouldn't recommend then
c
      dummy = registerfonts( 'modern.fon' )
      call clearscreen( $gclearscreen )
      return
      end
c------------------------------------------------------------------------
      integer*2 function newx( xcoord )
c------------------------------------------------------------------------
c These routines convert (x,y) positions to screen pixel location.
c
      integer*2 maxx, maxy
      real*4    tempx, xcoord, xmax, ymax
      common /screensize/ maxx, maxy, xmax, ymax
c
      tempx = float( maxx ) * xcoord / xmax + 0.5
      newx  = nint( tempx )
      return
      end
c------------------------------------------------------------------------
      integer*2 function newy( ycoord ) 
c------------------------------------------------------------------------
      integer*2 maxx, maxy
      real*4    tempy, ycoord, xmax, ymax
      common /screensize/ maxx, maxy, xmax, ymax
c
      tempy = float( maxy ) * (1.0 - ycoord / ymax) - 0.5
      newy  = nint( tempy )
      return
      end
c------------------------------------------------------------------------
      integer*2 function newh( ycoord ) 
c------------------------------------------------------------------------
      integer*2 maxx, maxy
      real*4    tempy, ycoord, xmax, ymax
      common /screensize/ maxx, maxy, xmax, ymax
c
      tempy = float( maxy ) * ycoord / ymax - 0.5
      newh  = nint( tempy )
      return
      end
c------------------------------------------------------------------------
      integer*2 function neww( xcoord ) 
c------------------------------------------------------------------------
      integer*2 maxx, maxy
      real*4    tempx, xcoord, xmax, ymax
      common /screensize/ maxx, maxy, xmax, ymax
c
      tempx = float( maxx ) * xcoord / xmax - 0.5
      neww  = nint( tempx )
      return
      end
c---------------------------------------------------------------------------
      integer*4 function rgb(r, g, b)
c---------------------------------------------------------------------------
      integer*4 r, g, b
c
      rgb = ishl( ishl( b, 8) .or. g, 8) .or. r
      return
      end
