      subroutine geo2utm( Lat, Long, longorig, Northing, Easting )
c
c	FORTRAN routine based on a C routine taken from the Web
c
      real lat, long, northing, easting, longorig

      real*8 aa/6378206.4/
      real*8 eccSquared/0.00676866/
      real*8 k0/0.9996/
      real*8 pi/3.14159265d0/
      real*8 deg2rad

      real*8 LongOrigin
      real*8 eccPrimeSquared
      real*8 N, T, C, A, M

      deg2rad = pi/180.d0

      LongOrigin = longorig

      if( longorig.eq.999. ) then
        if(Long .eq. 0) then
          LongOrigin = -3
        else
          LongOrigin = int(Long/6)*6+3*int(Long/6)/abs(int(Long/6))
        endif
      endif

      longorig = LongOrigin

      eccPrimeSquared = (eccSquared)/(1-eccSquared)


      N = aa/sqrt(1-eccSquared*sin(Lat*deg2rad)*sin(Lat*deg2rad))
      T = tan(Lat*deg2rad)*tan(Lat*deg2rad)
      C = eccPrimeSquared*cos(Lat*deg2rad)*cos(Lat*deg2rad)
      A = cos(Lat*deg2rad)*(Long-LongOrigin)*deg2rad

      M = 111132.0894*Lat - 16216.94*sin(2*Lat*deg2rad)
     &         + 17.21*sin(4*Lat*deg2rad) - 0.02*sin(6*Lat*deg2rad)

      Easting = k0*N*(A+(1-T+C)*A*A*A/6 +
     &         (5-18*T+T*T+72*C-58*eccPrimeSquared)*A*A*A*A*A/120)
     &                                  + 500000.0

      Northing =
     &   k0*(M+N*tan(Lat*deg2rad)*(A*A/2+(5-T+9*C+4*C*C)*A*A*A*A/24
     &                           +
     & (61-58*T+T*T+600*C-330*eccPrimeSquared)*A*A*A*A*A*A/720))

      return
      end


