      subroutine mpopen(ifd,fn,file_status,*,*)

	implicit none



	include 'ctrlblk.inc'
c---------------------------------------------------------------------
c     ifd: file handle
c        input: a fortran unit number
c       output: if SUN then output is the c file descriptor
c               if an error occcurs during open output is -1
      integer ifd
c     --- fn: filename to be opened
      character*(*) fn
c     --- file_status: 'old' or 'new'
      character*(*) file_status
c
c     return 1 if file does not exist and file_status = 'old'
c     return 2 if file exists and file_status = 'new'
c
c---------------------------------------------------------------------
c
      integer ios
#ifdef SUN

      integer c_open_new_file, c_open_old_file

      integer FILE_EXISTS, FILE_NOT_FOUND

      parameter(

     &           FILE_EXISTS = 17,

     &           FILE_NOT_FOUND = 2

     &          )

#elif DOS
      integer FILE_EXISTS, FILE_NOT_FOUND
      parameter(


     &           FILE_EXISTS = 6415,
     &           FILE_NOT_FOUND = 6416
     &          )

#endif



c---------------------------------------------------------------------
c

      if( iprint.ge.1 ) then

#ifdef SUN

        write(*,*)'mpopen: entered with ifdef SUN'

#elif DOS

        write(*,*)'mpopen: entered with ifdef DOS'

#endif

      endif





      if(file_status.eq.'new') then
#ifdef SUN
        ifd=c_open_new_file(fn,ios)
        if(ifd.eq.-1) goto 2000
#elif DOS
        open(unit=ifd,file=fn,iostat=ios,err=2000,
     &        form='binary',status='new')
#endif
         return
 2000    continue
         if(ios.eq.FILE_EXISTS) then
            ifd=-1
            return 2
         endif
c        --- unrecognized error
	 write(*,*)' mpopen: unrecognized error opening ',
     &      fn, ' iostat=',ios  
         ifd=-1
         return
      elseif(file_status.eq.'old') then
#ifdef SUN
        ifd=c_open_old_file(fn,ios)
        if(ifd.eq.-1) goto 3000
#elif DOS
        open(unit=ifd,file=fn,iostat=ios,err=3000,
     &        form='binary',status='old')
#endif
         return
 3000    continue
         if(ios.eq.FILE_NOT_FOUND) then
            ifd=-1
            return 1
         endif
c        --- unrecognized error
	 write(*,*)' mpopen: unrecognized error opening ',
     &      fn, ' iostat=',ios  
         ifd=-1
         return
      endif
      end
c---------------------------------------------------------------------
      subroutine mpclose(ifd)
c---------------------------------------------------------------------
c     ifd: file handle
c        input: the value returned from mpopen()
c       output: if an error occcurs during close output is -1
      integer ifd
#ifdef SUN
      integer c_close,iret
#endif
c
c---------------------------------------------------------------------
c
c
#ifdef SUN
      iret=c_close(ifd)
      if(iret.eq.-1) then
         write(*,*)' mpclose: internal error'
         ifd=-1
      endif	
      return
#elif DOS
      close(unit=ifd)
      return
#endif
      end

