      SUBROUTINE CUBIC( A, B, C, D, ROOTR, ROOTI)

c  August 27, 1992 (Angela Tchen)
c  Checked for SUN compatibility--no changes were required.

      REAL    ROOTR(3), ROOTI(3), a, b, c, d, a2, t, q, r, rt, s2
      real    s1, a1, a0
      integer ndev, ndevm
      COMPLEX Z1, Z2, Z3, IMAG
      COMMON /NWRITE/ NDEV, NDEVM
      DATA IMAG/( 0.0, 1.0)/
C
C -- SOLUTION OF A CUBIC EQUATION  A(X**3) + B(X**2) + C(X) + D = 0
C    BY THE ANALYTICAL ALGORITHM GIVEN IN ABRAMOWITZ & STEGUN (P. 17)
C
      A2 = B/A
      A1 = C/A
      A0 = D/A
C
      Q = A1/3. - A2*A2/9.
      R = (A1*A2 - 3.*A0)/6. - A2*A2*A2/27.
C
      T = Q*Q*Q + R*R
      RT = SQRT(T)
C
      S1 = (R + RT)**(1./3.)
      S2 = SIGN( (ABS(R - RT))**(1./3.), (R - RT))
      IF(NDEVM .NE. 0)WRITE( NDEVM, 2004) Q, R, T, S1, S2
C
      Z1 = (S1 + S2) - A2/3.
      Z2 = -(S1 + S2)/2. - A2/3. + IMAG*1.732*(S1 - S2)/2.
      Z3 = -(S1 + S2)/2. - A2/3. - IMAG*1.732*(S1 - S2)/2.
C
C
      IF(NDEVM .NE. 0) THEN
        WRITE(NDEVM, 2000) Z1, Z2, Z3
      END IF
C
      IF (T) 101, 102, 103
C
  101 IF(NDEVM .NE. 0) WRITE( NDEVM, 2001) 
      ROOTR(1) = 0.0
      RETURN
C
  102 IF(NDEVM .NE. 0) WRITE( NDEVM, 2002)
      ROOTR(1) = REAL( Z1 )
      RETURN
C
  103 IF(NDEVM .NE. 0) WRITE( NDEVM, 2003) 
      ROOTR(1) = REAL( Z1 )
      RETURN
C
 2000 FORMAT(/, 5X, 'Z1=', 2E15.4, /, 5X, 'Z2=', 2E15.4, /,
     1          5X, 'Z3=', 2E15.4)
 2001 FORMAT(/, 10X, 'All roots real (irreducible case)')
 2002 FORMAT(/, 10X, 'All roots real and at least two equal')
 2003 FORMAT(/, 10X, 'One root real and one pair of complex conjugate',
     1       ' roots')
 2004 FORMAT(/,5X, '  Q=',E14.6, '  R=',E14.6, '  T=',E14.6, /,
     1       10X, '  S1=',E14.6, '  S2=', E14.6)
      END

