      SUBROUTINE LOPASS(N,X,TCUT,DELTA, worksp)

      REAL X(*),E(3),D(2), worksp(*), b, c, w, tcut, delta,xnorm
      integer i, n

C
C     BUTTERWORTH 2ND. ORDER FILTER (LOW-PASS) RUN FORWARDS AND
C     BACKWARDS OVER DATA TO GIVE ZERO PHASE SHIFT AND -12DB/OCTAVE
C      REFERENCE: KULHANEK (1976) PP87-92 & NOTES(JONES)
C

      include 'ctrlblk.inc'

      if( iprint.ge.2 ) then
        write(*,*)'lopass: entered with n,tcut,delta=',n,tcut,delta
      endif


      W=TAN(3.14159*DELTA/TCUT)
      B=W*(SQRT(2.0))
      C=W*W
      E(1)=1./(1.+B+C)
      E(2)=2.*E(1)
      E(3)=E(1)
      D(1)=2.*(C-1.)/(1.+B+C)
      D(2)=(1.-B+C)/(1.+B+C)
C         *APPLY NORMALISATION
      XNORM=(1.+D(1)+D(2))/(E(1)+E(2)+E(3))
      XNORM=ABS(XNORM)
      DO 1 I=1,3
    1 E(I)=E(I)*XNORM
      CALL FILTER(X,E,D,N, worksp)
      if(iprint.ge.1) WRITE(*,2001)N,TCUT,DELTA,(E(I),I=1,3),
     & (D(I),I=1,2)
 2001 FORMAT(/,5X,'LOPASS : N=',I5,'  TCUT=',E9.3,'  DELTA=',
     ?E9.3,/,5X,'COEFFICIENTS==> (',E10.4,' ) + (',E10.4,' ) + (',
     ?E10.4,' ) / ( 1. ) + (',E10.4,' ) + (',E10.4,' )' )

      if( iprint.ge.2 ) then
        write(*,*)'lopass: returning'
      endif

      RETURN
      END
 
