      SUBROUTINE PLRZN7

      include 'maxflims.inc'

      REAL MINUS,J
      INTEGER NPRE,EPRE,HPRE,DPRE,ZPRE,RXPRE,RYPRE
      COMPLEX S7
      integer n, ndevm, ndev, i, ic1, ic2
      real    delta, tlen, period, sum, theta1, beta, rat1
      real    r1, ratx1, theta2, rat2, ocoh1, ocoh2, focoh
      real    u, r2, ratx2, prd
      COMMON /TIME/ DELTA,TLEN,PERIOD(MAXF)
      COMMON /PRES7/ NPRE,EPRE,HPRE,DPRE,ZPRE,RXPRE,RYPRE
      COMMON /POWER7/ S7(7,7,MAXF)
      COMMON /NWRITE/ NDEV, NDEVM
      COMMON N
C
C     SUBROUTINE TO COMPUTE THE POLARISATION PARAMETERS
C     *NOTE* MUST COMPILE WITH ARRAY BOUND CHECKING OFF
C
      IF( NDEVM .NE. 0 ) WRITE(NDEVM,3333)
 3333 FORMAT(5X,'==>SUBROUTINE PLRZN ENTERED')

      WRITE(NDEV,100)
      WRITE(NDEV,101)
      WRITE(NDEV,103)
      WRITE(NDEV,104)
  100 FORMAT(//,10X,'POLARISATION PARAMETERS')
  101 format(/ ,3X,'  PSI = ANGLE OF MAJOR AXIS TO THE NORTH',
     &    /,3X,'RATIO = MINOR/MAJOR AXIS (POLARISED PART ONLY)',
     &    /,3X,'R = POLARISED/TOTAL PART')
  103 format(/,26X,'FOR MAGNETIC FIELD',17X,'FOR TELLURIC FIELD')
  104 format(/,9X,'PERIOD',5X,'PSI',4X,'G12',5X,'R',
     &    2X,'RATIO',1X,'IC1',5X,'PSI',4X,'G34',5X,'R',
     &    2X,'RATIO',1X,'IC2')
 
      DO 10 I=1,N
        IF( HPRE+DPRE.EQ.2 ) THEN
          MINUS=REAL(S7(1,1,I))-REAL(S7(2,2,I))
          SUM=REAL(S7(1,1,I))+REAL(S7(2,2,I))
          IF(MINUS.EQ.0.)MINUS=10E-10
          THETA1=2.*REAL(S7(1,2,I))/MINUS
          THETA1=0.5*180.*ATAN(THETA1)/3.141592
          IF(MINUS.LT.0.)THETA1=THETA1+90.0
          IF(THETA1.LT.0.)THETA1=THETA1+180.0
          BETA=2.*AIMAG(S7(1,2,I))/SUM
          BETA=0.5*ASIN(BETA)
          RAT1=TAN(BETA)
          IF(BETA.GT.0.)IC1=1
          IF(BETA.LT.0.)IC1=2
          IF(BETA.LT.0.01.AND.BETA.GT.-0.01)IC1=3

          J=REAL(S7(1,1,I)*S7(2,2,I)-S7(1,2,I)*S7(2,1,I))
          U=0.5*(SUM-SQRT(SUM**2-4.*J))
          R1=SQRT(1.-4.*J/(SUM**2))
          BETA=0.5*ASIN(2.*AIMAG(S7(1,2,I))/(SUM-2.*U))
          RATX1=TAN(BETA)
        END IF

        IF( NPRE+EPRE.EQ.2 ) THEN
          MINUS=REAL(S7(3,3,I))-REAL(S7(4,4,I))
          SUM=REAL(S7(3,3,I))+REAL(S7(4,4,I))
          IF(MINUS.EQ.0.)MINUS=10E-10
          THETA2=2.*REAL(S7(3,4,I))/MINUS
          THETA2=0.5*180.*ATAN(THETA2)/3.141592
          IF(MINUS.LT.0.)THETA2=THETA2+90.0
          IF(THETA2.LT.0.)THETA2=THETA2+180.0
          BETA=2.*AIMAG(S7(3,4,I))/SUM
          BETA=0.5*ASIN(BETA)
          RAT2=TAN(BETA)
          IF(BETA.GT.0.)IC2=1
          IF(BETA.LT.0.)IC2=2
          IF(BETA.LT.0.01.AND.BETA.GT.-0.01)IC2=3

          J=REAL(S7(3,3,I)*S7(4,4,I)-S7(3,4,I)*S7(4,3,I))
          U=0.5*(SUM-SQRT(SUM**2-4.*J))
          R2=SQRT(1.-4.*J/(SUM**2))
          BETA=0.5*ASIN(2.*AIMAG(S7(3,4,I))/(SUM-2.*U))
          RATX2=TAN(BETA)
        END IF

        ocoh1 = focoh( 7, s7(1,1,i), 1, 2 )
        ocoh2 = focoh( 7, s7(1,1,i), 3, 4 )

      if( period(i).gt.1. ) then
        prd = period(i)
      else
        prd = -1./period(i)
      endif
      WRITE(NDEV,102)I,prd,THETA1,ocoh1,R1,RATX1,IC1,
     ?THETA2,ocoh2,R2,RATX2,IC2
  102 FORMAT(1X,I3,1X,1PE10.3,1X,0P4F7.2,2X,I1,1X,4F7.2,2X,I1)

   10 CONTINUE
C
      RETURN
      END
