      SUBROUTINE rotate7( ANGLE, NTYPE )
c
      include 'maxflims.inc'
      integer n, ntype, m, j, i
      real    theta, a, b, c, d, e, angle
      COMPLEX S7, SX(7,7)
      COMMON /POWER7/ S7(7,7,MAXF)
      COMMON N
C
C     SUBROUTINE ROTATES THE POWER MATRIX  S  BY ANGLE  'ANGLE'
C
C     NTYPE = 1   ALL VECTORS ROTATED
C     NTYPE = 2   MAGNETIC VECTORS ROTATED (BOTH LOCAL & REMOTE)
C     NTYPE = 3   ELECTRIC VECTORS ROTATED
C
C
C     NOTE: this routine does NOT rotate Hz !!!!!!!!!!!
c  modified Oct 4, 1993 to rotate Hz - D. Boerner
c
      if(ntype.ne.1 ) then
        write(*,*)'rotate7 not coded yet for NTYPE>1'
        stop
      end if

      IF(NTYPE.NE.1 .AND. NTYPE.NE.2 .AND. NTYPE.NE.3) THEN
        WRITE(*,1)NTYPE
    1   FORMAT(20X,'***  SUBROUTINE  rotate7  ***',//,10X,
     ?   'IMPERMISSABLE PARAMETER , NTYPE =',I2,5X,'PROGRAM TERMINATED')
        STOP
      END IF
C
      THETA=ANGLE*3.141592/180.
      D = COS(THETA)
      E = SIN(THETA)
      A = D*D
      B = E*E
      C = D*E
C
      DO M=1,N
        IF( NTYPE.EQ.1 ) THEN
          SX(1,1)=S7(1,1,M)*A +S7(2,2,M)*B +(S7(1,2,M)+S7(2,1,M))*C
          SX(1,2)=S7(1,2,M)*A -S7(2,1,M)*B +(S7(2,2,M)-S7(1,1,M))*C
          SX(1,3)=S7(1,3,M)*A +S7(2,4,M)*B +(S7(1,4,M)+S7(2,3,M))*C
          SX(1,4)=S7(1,4,M)*A -S7(2,3,M)*B +(S7(2,4,M)-S7(1,3,M))*C
          SX(1,6)=S7(1,6,M)*A +S7(2,7,M)*B +(S7(1,7,M)+S7(2,6,M))*C
          SX(1,7)=S7(1,7,M)*A -S7(2,6,M)*B +(S7(2,7,M)-S7(1,6,M))*C
          SX(2,2)=S7(2,2,M)*A +S7(1,1,M)*B -(S7(1,2,M)+S7(2,1,M))*C
          SX(2,3)=S7(2,3,M)*A -S7(1,4,M)*B +(S7(2,4,M)-S7(1,3,M))*C
          SX(2,4)=S7(2,4,M)*A +S7(1,3,M)*B -(S7(2,3,M)+S7(1,4,M))*C
          SX(2,6)=S7(2,6,M)*A -S7(1,7,M)*B +(S7(2,7,M)-S7(1,6,M))*C
          SX(2,7)=S7(2,7,M)*A +S7(1,6,M)*B -(S7(2,6,M)+S7(1,7,M))*C
          SX(3,3)=S7(3,3,M)*A +S7(4,4,M)*B +(S7(3,4,M)+S7(4,3,M))*C
          SX(3,4)=S7(3,4,M)*A -S7(4,3,M)*B +(S7(4,4,M)-S7(3,3,M))*C
          SX(3,6)=S7(3,6,M)*A +S7(4,7,M)*B +(S7(3,7,M)+S7(4,6,M))*C
          SX(3,7)=S7(3,7,M)*A -S7(4,6,M)*B +(S7(4,7,M)-S7(3,6,M))*C
          SX(4,4)=S7(4,4,M)*A +S7(3,3,M)*B -(S7(3,4,M)+S7(4,3,M))*C
          SX(4,6)=S7(4,6,M)*A -S7(3,7,M)*B +(S7(4,7,M)-S7(3,6,M))*C
          SX(4,7)=S7(4,7,M)*A +S7(3,6,M)*B -(S7(4,6,M)+S7(3,7,M))*C
          SX(6,6)=S7(6,6,M)*A +S7(7,7,M)*B +(S7(6,7,M)+S7(7,6,M))*C
          SX(6,7)=S7(6,7,M)*A -S7(7,6,M)*B +(S7(7,7,M)-S7(6,6,M))*C
          SX(7,7)=S7(7,7,M)*A +S7(6,6,M)*B -(S7(6,7,M)+S7(7,6,M))*C
c
c rotate xpower with Hz just once 
c
          sx(5,5) = s7(5,5,m)
          sx(1,5) = s7(1,5,m)*d + s7(2,5,m)*e
          sx(2,5) =-s7(1,5,m)*e + s7(2,5,m)*d
          sx(3,5) = s7(3,5,m)*d + s7(4,5,m)*e
          sx(4,5) =-s7(3,5,m)*e + s7(4,5,m)*d
          sx(5,6) = s7(5,6,m)*d + s7(5,7,m)*e
          sx(5,7) =-s7(5,6,m)*e + s7(5,7,m)*d
c
        ELSE IF( NTYPE.EQ.2 ) THEN
          SX(1,1)=S7(1,1,M)*A +S7(2,2,M)*B +(S7(1,2,M)+S7(2,1,M))*C
          SX(1,2)=S7(1,2,M)*A -S7(2,1,M)*B +(S7(2,2,M)-S7(1,1,M))*C
          SX(1,3)=S7(1,3,M)*D +S7(2,3,M)*E
          SX(1,4)=S7(1,4,M)*D +S7(2,4,M)*E
          SX(2,2)=S7(2,2,M)*A +S7(1,1,M)*B -(S7(1,2,M)+S7(2,1,M))*C
          SX(2,3)=S7(2,3,M)*D-S7(1,3,M)*E
          SX(2,4)=S7(2,4,M)*D-S7(1,4,M)*E
          SX(3,3)=S7(3,3,M)
          SX(3,4)=S7(3,4,M)
          SX(4,4)=S7(4,4,M)
        ELSE IF( NTYPE.EQ.3 ) THEN
          SX(1,1)=S7(1,1,M)
          SX(1,2)=S7(1,2,M)
          SX(1,3)=S7(1,3,M)*D +S7(1,4,M)*E
          SX(1,4)=S7(1,4,M)*D -S7(1,3,M)*E
          SX(2,2)=S7(2,2,M)
          SX(2,3)=S7(2,3,M)*D+S7(2,4,M)*E
          SX(2,4)=S7(2,4,M)*D-S7(2,3,M)*E
          SX(3,3)=S7(3,3,M)*A +S7(4,4,M)*B +(S7(3,4,M)+S7(4,3,M))*C
          SX(3,4)=S7(3,4,M)*A -S7(4,3,M)*B +(S7(4,4,M)-S7(3,3,M))*C
          SX(4,4)=S7(4,4,M)*A +S7(3,3,M)*B -(S7(3,4,M)+S7(4,3,M))*C
        END IF

        SX(2,1)=CONJG(SX(1,2))
        SX(3,1)=CONJG(SX(1,3))
        SX(3,2)=CONJG(SX(2,3))
        SX(4,1)=CONJG(SX(1,4))
        SX(4,2)=CONJG(SX(2,4))
        SX(4,3)=CONJG(SX(3,4))
        SX(5,1)=CONJG(SX(1,5))
        SX(5,2)=CONJG(SX(2,5))
        SX(5,3)=CONJG(SX(3,5))
        SX(5,4)=CONJG(SX(4,5))
        SX(6,1)=CONJG(SX(1,6))
        SX(6,2)=CONJG(SX(2,6))
        SX(6,3)=CONJG(SX(3,6))
        SX(6,4)=CONJG(SX(4,6))
        SX(6,5)=CONJG(SX(5,6))
        SX(7,1)=CONJG(SX(1,7))
        SX(7,2)=CONJG(SX(2,7))
        SX(7,3)=CONJG(SX(3,7))
        SX(7,4)=CONJG(SX(4,7))
        SX(7,5)=CONJG(SX(5,7))
        SX(7,6)=CONJG(SX(6,7))
c
        do j = 1, 7
          do i = 1, 7
            s7(i,j,m) = sx(i,j)
          end do
        end do
      end do
c
      RETURN
      END
