      SUBROUTINE TRFN( NARRAY, S, X1, X2, R1, R2, Y, T1, T2)
      integer narray, i, j
      COMPLEX S(NARRAY,NARRAY), T1, T2, denom
      INTEGER X1, X2, R1, R2, Y
C
C  ROUTINE TO DERIVE THE TRANSFER FUNCTIONS BETWEEN THE INPUTS
C  (X1,X2), AND THE OUTPUT (Y), USING THE REFERENCE SIGNALS
C  (R1,R2).
C
C

      include 'ctrlblk.inc'

      if( iprint.ge.4 ) then
        write(*,*)'trfn: entered, narray = ', narray
      endif

      if( iprint.ge.5 ) then
        write(*,*)'      s array =>'
        do i = 1, narray
          do j = 1, narray
            write(*,*)'      s(i,j) =>', i,j,s(i,j)
          enddo
        enddo
      endif
      denom = S(R1,X1)*S(R2,X2) -  S(R1,X2)*S(R2,X1)
      if(denom.ne.cmplx(0.0,0.0)) then
        T1 =  ( S(R1,Y )*S(R2,X2) -  S(R1,X2)*S(R2,Y ) ) / denom
        T2 =  ( S(R2,Y )*S(R1,X1) -  S(R2,X1)*S(R1,Y ) ) / denom
       else
        t1 = cmplx(0.0,0.0)
        t2 = cmplx(0.0,0.0)
      end if

      if( iprint.ge.5 ) then
        write(*,*)'      t1 =>', t1
        write(*,*)'      t2 =>', t2
      endif

      RETURN
      END

      SUBROUTINE TRFN1( NARRAY, S, X, R, Y, T)
      INTEGER X, R, Y, narray, i, j
      COMPLEX S(NARRAY,NARRAY), T
C
C  ROUTINE TO DERIVE THE TRANSFER FUNCTIONS BETWEEN THE INPUTS
C  (X1,X2), AND THE OUTPUT (Y), USING THE REFERENCE SIGNALS
C  (R1,R2).
C
C

      include 'ctrlblk.inc'

      if( iprint.ge.4 ) then
        write(*,*)'trfn1: entered, narray = ', narray
      endif

      if( iprint.ge.5 ) then
        write(*,*)'      s array =>'
        do i = 1, narray
          do j = 1, narray
            write(*,*)'      s(i,j) =>', i,j,s(i,j)
          enddo
        enddo
      endif
      if(s(r,x).ne.cmplx(0.0,0.0)) then
        T = S(R,Y) / S(R,X)
       else
        t = cmplx(0.0,0.0)
      end if

      if( iprint.ge.5 ) then
        write(*,*)'      t =>', t
      endif

      RETURN
      END
