      subroutine ts_rdinfo( ind )

      implicit none

      integer ind
c...reads info block from input file (must be open already)

      include 'infoblk.inc'
      include 'defaults.inc'
      include 'ctrlblk.inc'

      character line*80, keyword*10, form_in*6

      integer lword, ichan, lnblnk

      logical SQ_SET, MD_SET, FM_SET

c...set variables to FALSE that must be set during read, otherwise
c   default values used
      SQ_SET = .FALSE.
      MD_SET = .FALSE.
      FM_SET = .FALSE.

      if( iprint.ge.2 ) then
        write(*,*)'ts_rdinfo: entered with form =',form
      endif

c...move to beginning of info block
      rewind( ind )
      if( form.eq.'BINARY' ) then
        read(ind,end=9999) line
      else
        read(ind,2001,end=9999) line
      endif
      if( iprint.eq.3 ) write(*,2001)'line>',line

      do while(line(1:1).ne.'>'  )
        if( form.eq.'BINARY' ) then
          read(ind,end=9999) line
        else
          read(ind,2001,end=9999) line
        endif
        if( iprint.ge.5 ) write(*,2001)'line>',line(1:lnblnk(line))
      enddo

c...check that first line is INFO_START
      keyword = line(2:11)
	if( keyword.ne.'INFO_START' ) then
	  write(*,*)'ts_rdinfo: Info block does not begin with '//
     &            'INFO_START'
	endif

c...read in info block one line at a time

      do while(line(1:1).eq.'>'  )

        keyword = line(2:11)

        if( keyword.eq.'INFO_START' ) then
	    continue

        elseif( keyword.eq.'STATION' ) then
          call word1( line(13:), stat, lword )

        elseif( keyword.eq.'INSTRUMENT' ) then
          read( line(13:),* ) instrument

        elseif( keyword.eq.'WINDOW' ) then
          call word1( line(13:), window, lword )

        elseif( keyword.eq.'LATITUDE' ) then
          read( line(13:),* ) lat

        elseif( keyword.eq.'LONGITUDE' ) then
          read( line(13:),* ) long

        elseif( keyword.eq.'ELEVATION' ) then
          read( line(13:),* ) elev

        elseif( keyword.eq.'UTM_ORIGIN' ) then
          read( line(13:),* ) utmorigin

        elseif( keyword.eq.'UTM_ZONE' ) then
          read( line(13:),* ) utmzone

        elseif( keyword.eq.'UTM_NORTH' ) then
          read( line(13:),* ) utmn

        elseif( keyword.eq.'UTM_EAST' ) then
          read( line(13:),* ) utme

        elseif( keyword.eq.'COORD_SYS' ) then
          read( line(13:),'(a)' ) azdir

        elseif( keyword.eq.'DECLIN' ) then
          read( line(13:),* ) declination

        elseif( keyword.eq.'FORM' ) then
          call word1( line(13:), form_in, lword )
          if( form.ne.form_in ) then
            write(*,*)'ts_rdinfo: Incompatible form specified in file:'
            write(*,*)'           form = ', form, 'form_in = ', form_in
            write(*,*)'Correct and rerun'
            stop
          endif

        elseif( keyword.eq.'FORMAT' ) then
          call word1( line(13:), format, lword )
          FM_SET = .TRUE.
          if(form.eq.'BINARY' .and. format.ne.'UNFORMATTED') then
            write(*,*)'ts_rdinfo: Incorrect format specified for '//
     &                          'BINARY file'
            write(*,*)'           format = ', format
            write(*,*)'           reset to UNFORMATTED'
            format = 'UNFORMATTED'
          endif

        elseif( keyword.eq.'FORM_TYPE' ) then

          call word1( line(13:), formtype, lword )

        elseif( keyword.eq.'FORM_LEN' ) then
          read( line(13:),* ) formlen

        elseif( keyword.eq.'ENDIAN' ) then
          call word1( line(13:), endian, lword )

        elseif( keyword.eq.'BIN_FORM' ) then

          call word1( line(13:), binform, lword )

        elseif( keyword.eq.'SEQ_REC' ) then
          read( line(13:),* ) seq_rec
          SQ_SET = .TRUE.

        elseif( keyword.eq.'NCHAN' ) then
          read( line(13:),* ) nchan

        elseif( keyword(1:4).eq.'CHAN' ) then
          read( keyword(6:6), * ) ichan
          call word1( line(13:), chan(ichan), lword )

        elseif( keyword(1:6).eq.'SENSOR' ) then
          read( keyword(8:8), * ) ichan
          read( line(13:),* ) sensor(ichan)

        elseif( keyword(1:4).eq.'AZIM' ) then
          read( keyword(6:6), * ) ichan
          read( line(13:),* ) azim(ichan)

        elseif( keyword(1:5).eq.'UNITS' ) then
          read( keyword(7:7), * ) ichan
          call word1( line(13:), units(ichan), lword )

        elseif( keyword.eq.'DELTA_T' ) then
          read( line(13:),* ) delta

        elseif( keyword.eq.'T_UNITS' ) then
          call word1( line(13:), tunits, lword )

        elseif( keyword.eq.'ORDER' ) then
          call word1( line(13:), order, lword )

        elseif( keyword(1:4).eq.'GAIN' ) then
          read( keyword(6:6), * ) ichan
          read( line(13:),* ) gain(ichan)
          if( gain(ichan).ne.1. ) then
            write(*,*)'ts_rdinfo: gain to be applied to channel',
     &                ichan,'   of', gain(ichan)
          endif

        elseif( keyword(1:8).eq.'BASELINE' ) then
          read( keyword(10:10), * ) ichan
          read( line(13:),* ) baseline(ichan)

        elseif( keyword.eq.'STARTTIME' ) then
          starttime = line(13:)
          lword = lnblnk( starttime )
          if( iprint.ge.2 ) write(*,*) 'Starttime read in >',
     &                         starttime(1:lword)
          if( starttime(1:2).ne.'19' .and. starttime(1:2).ne.'20' ) then
            write(*,*)'Start time in v4 format...converting'
            call convtimev5( starttime )
            if( iprint.ge.2 ) write(*,*)'Converted starttime >',
     &                           starttime
          endif

        elseif( keyword.eq.'ENDTIME' ) then
          endtime = line(13:)
          lword = lnblnk( endtime )
          if( iprint.ge.2 ) write(*,*) 'Endtime read in >',
     &                          endtime(1:lword)
          if( endtime(1:2).ne.'19' .and. endtime(1:2).ne.'20' ) then
            write(*,*)'End time in v4 format...converting'
            call convtimev5( endtime )
            if( iprint.ge.2 ) write(*,*)'Converted endtime >',endtime
          endif

        elseif( keyword(1:8).eq.'MIS_DATA' ) then
          read( line(13:),* ) misdat
          MD_SET = .TRUE.

        elseif( keyword(1:8).eq.'INFO_END' ) then
	    if( iprint.ge.3 ) then

            write(*,*) 'tsrdinfo: INFO_END found'
	    endif

	    goto 1002


        else
          write(*,2001)' '
          write(*,2001)'ts_rdinfo: Ignored/Unknown keyword: ', keyword
          write(*,2001)' '
        endif

        if( form.eq.'BINARY' ) then
          read(ind,end=9001,err=1001) line
          if( iprint.ge.5 ) write(*,2001)'line>',line
        else
          read(ind,2001,end=9001,err=1001) line
          if( iprint.ge.5 ) write(*,2001)'line>',line
        endif

      enddo

      if( iprint.ge.2 ) then
        write(*,2001)'ts_rdinfo: exiting'
      endif
      goto 1002

1001  backspace ind
      if( iprint.ge.2 ) then
        write(*,2001)'ts_rdinfo: exiting after one backspace'
      endif

1002  continue

c...check that important parameters have been set

      if( .not.SQ_SET ) then
        write(*,'(a)')'ts_rdinfo: SEQ_REC not read in:'//
     &               ' set to default = 1'
        seq_rec = 1
      endif

      if( .not.MD_SET ) then
        write(*,'(a,g20.10)')'ts_rdinfo: MIS_DAT not read in:'//
     &           ' set to default value: ', DEFMISDAT
        misdat = DEFMISDAT
      endif

      if( .not.FM_SET .and.form.eq.'ASCII') then
        write(*,'(a)')'ts_rdinfo: FORMAT not read in: set to FREE'
        format = 'FREE'
      endif

c...write out info block for iprint >= 1
      if( iprint.ge.1 ) then
        write(*,*)'Information block from input file...'
        write(*,*)'STATION   :', stat
        write(*,*)'INSTRUMENT:', instrument
        write(*,*)'WINDOW    :', window
        write(*,*)'LATITUDE  :', lat
        write(*,*)'LONGITUDE :', long
        write(*,*)'ELEVATION :', elev
        write(*,*)'UTM_ORIGIN:', utmorigin
        write(*,*)'UTM_NORTH :', utmn
        write(*,*)'UTM_EAST  :', utme
        write(*,*)'COORD_SYS :', azdir
        write(*,*)'DECLIN    :', declination
        write(*,*)'FORM      :', form
        write(*,*)'FORMAT    :', format

        write(*,*)'FORM_TYPE :', formtype

        write(*,*)'FORM_LEN  :', formlen

	  write(*,*)'ENDIAN    :', endian

	  write(*,*)'BIN_FORM  :', binform
        write(*,*)'SEQ_REC   :', seq_rec
        write(*,*)'NCHAN     :', nchan
        do ichan = 1, nchan
          write(*,*)'Channel......:', ichan
          write(*,*)'CHAN    :', chan(ichan)
          write(*,*)'AZIM    :', azim(ichan)
          write(*,*)'GAIN    :', gain(ichan)
          write(*,*)'UNITS   :', units(ichan)
          if( ichan.le.3 ) then
            write(*,*)'BASELINE:', baseline(ichan)
          endif
        enddo
        write(*,*)'STARTTIME :', starttime
        write(*,*)'ENDTIME   :', endtime
        write(*,*)'T_UNITS   :', tunits
        write(*,*)'DELTA_T   :', delta
        write(*,*)'MIS_DATA  :', misdat
      endif
      return


9001  write(*,2001)'ts_rdinfo: EOF still reading in info block ',
     &             '- aborting'
      stop

9999  write(*,2001)'ts_rdinfo: no info block found in file - aborting'
      stop

2001  format(2a)
      end
