      subroutine ts_read( ind, stime, etime, data )

      implicit none

      character*19 stime, etime
      character*1 char1

c...data declared as real*4 in case of double precision compilation
      real*4 data(5,*)
      integer ind

      integer sdata, sskip, npt, nskip, i, j

      external tdiff
      integer tdiff

c...reads in data from stime to etime
c   - file must already be opened and info read

      include 'infoblk.inc'
      include 'ctrlblk.inc'

      if( iprint.ge.1 ) then
        write(*,*)'ts_read entered: ind =', ind
        write(*,*)'stime: ', stime
        write(*,*)'etime: ', etime
      endif

c...get duration of required time window (in seconds)

      sdata = tdiff( stime, etime )
      npt   = sdata * delta

c...get duration of required skip from data starttime to stime

      sskip = tdiff( starttime, stime )
      nskip = sskip * delta

c...skip over comment & info blocks
      rewind ind
      if( form.eq.'ASCII' ) then
        read( ind,'(a)') char1
      else
        read( ind ) char1
      endif
      do while( char1.eq.'#' )
        if( form.eq.'ASCII' ) then
          read( ind,'(a)') char1
        else
          read( ind ) char1
        endif
      enddo

      do while( char1.eq.'>' )
        if( form.eq.'ASCII' ) then
          read( ind,'(a)') char1
        else
          read( ind ) char1
        endif
      enddo
      backspace ind

c...skip over skip points

      do i = 1, nskip
        if( form.eq.'ASCII' ) then
          read( ind,'(a)') char1
        else
          read( ind ) char1
        endif
      enddo

c...read in n points

      if( form.eq.'ASCII' ) then
        do i = 1, npt
          read( ind,*,end=9999) (data(j,i),j=1,nchan)
        enddo
      else
        do i = 1, npt
          read( ind, end=9999 ) (data(j,i),j=1,nchan)
        enddo
      endif

c...apply gains
      do i = 1, npt
        do j = 1, nchan
          data(j,i) = gain(j) * data(j,i)
        enddo
      enddo

      return

9999  write(*,*)'ts_read: Not all points could be read'
      write(*,*)'npt =', npt, '    points read =', i-1
      npt = i-1
      return

      end
