c----------------------------------------------------------------------------
      subroutine IO_error( file, ios )
c----------------------------------------------------------------------------
      character*(*) file

      character*60 message(5)

      integer*2 iperm(200)

      include 'io.inc'

c-- initialize messages 

      data message /' --Not enough privilege for attempted operation',
     &              ' --No such file or directory',
     &              ' --Attempting operation on a directory',
     &              ' --File already exists, delete old one first',
     &              ' --File does not exist, cannot open' /

c-- permutation array, iperm(ios) points to the correct message

      data iperm(1), iperm(2), iperm(31)
     &      / 1,        2,        3 /
      data iperm(117), iperm(118) 
     &      / 4,           5  /

c-------------------------------------------------------------------------

c     IO_error should be called after an open or close
c     statement to interpret any error.  The calling program could
c     appear thus:

c     open(iunit,file=filename, ... , iostat=ios, err=9999)
c          .
c          .
c          .
c9999 call IO_error(filename, ios)

c     IO_error matches the error message to ios using a permutation
c     array iperm.  Therefore to add more messages, one must first
c     increase the dimension of the character array message.  Then
c     the actual message is added to the data statement defining
c     the values of the message array.  Thirdly the iperm
c     data statement must be modified to point to the message
c     for the appropriate value of ios. Thus iperm(ios) gives
c     the appropriate array dimension value for the message array.

c--------------------------------------------------------------------------
c  Author: J.Craven    G.S.C. Ottawa   Dec 1989
c--------------------------------------------------------------------------

      write(out,'(a,i3,a,a)')' IO_error number: ', ios,
     &     ' for file: ', file

c$$$      if(iperm(ios).eq.0)then
c$$$         write(out,*)' Unknown error, see Appendix B (p37) of the'
c$$$     &        //' CONVEX FORTRAN User"s Guide'
c$$$      else
c$$$         write(out,*)message(iperm(ios))
c$$$      endif
      call error(1, 'Stop' )

      return
      end

