c ----------------------------------------------------------------------------

c

c     PHX2TS

c

c     A program to read MTU data with (16-byte flag) and convert

c     them to a four byte (for convenience) TS-format binary file.

c

c     *** modified from MTU-2ASC (Phoenix program)                  ***

c     *** modified from MTU-BIN  (Soyer program)                    ***

c     *** most part of source below is not used / wouldn't work !!! ***

c

c     Input File types are *.tsl *.tsh *.tsn (3 byte data)

c     Output in following format:

c               ...

c               isamp dat_ch1 ... dat_chn

c               ...

c     Filenames: mt3, mt4, mt5 (acc. to tsh_level3, tsh_level4, tsl, or:

c                               ts3,ts4,ts5)

c    

c

c     ag jones, mar 2003

c

c ----------------------------------------------------------------------------

      

      implicit integer*2 (i-n)



      include 'version.inc'

      include 'ctrlblk.inc'

      include 'defaults.inc'

      include 'io.inc'

      include 'bdate.inc'

#ifdef DOS

      include 'op_sys_DOS.inc'

#else

      include 'op_sys_UNIX.inc'

#endif





      CHARACTER*72  Filnam, Filtbl, Indir, Outdir

      CHARACTER  Tblfil*12, Fext*3

      INTEGER*4  Npos, Ichr, Ftype



	character*24 date_string

	character sep*1 



      external date



	logical ASCOUT /.FALSE./

	common / ascwrt / ASCOUT



	character*6 stat

	character*8 window

      common /statinfo/ stat, window



c-------------------------------------------------------------------------------

c     initialize



      call chkend(sysend)

      call fdate(date_string)



      call dirsep(sep)



c-------------------------------------------------------------------------------



      call iin( 'Print level (-1/0/1/2/3, +10 for ASCII in fort.69)',

     &           iprint)

	if( iprint.ge.10 ) then

	  write(*,*)'Opening file fort.69 to write data out into'

	  ASCOUT = .TRUE.

	  iprint = iprint - 10

	endif





      if( iprint.ge.1 ) then

	  write(*,*) 'Program start at: ', date_string

	  write(*,*) 'Machine endian  : ', sysend

	  write(*,*) 'UNIX setting    : ', UNIX

	endif



c-------------------------------------------------------------------------------

c     write banner



      call banner( 'PHX2TS' )

	

c-------------------------------------------------------------------------------



      Filtbl = "KAP027A.TSL" // CHAR(0)

	call tin('Give input table filename (TBL) OR data filename', Filtbl)

	Indir = "."

	call tin('Give input MTU data directory', Indir )

	Outdir = "."

	call tin('Give output TS file data directory', Outdir )



      Fext = Filtbl(index(Filtbl,'.')+1:)

	if(iprint.ge.1) write(*,*)'File extention >', Fext



	stat   = Filtbl(1:6)

	if( Filtbl(8:8).eq.'.' ) then

	 window = Filtbl(1:7)//'1'

	else

	  window = Filtbl(1:8)

	endif



      if( iprint.ge.1 ) then

        write(*,*)'Stat   =', stat

	  write(*,*)'Window =', window

	endif



      Ftype = 0

      IF (Fext.NE."TBL" .and. Fext.ne."tbl" ) THEN

C...Only 1 Time Series File requested - Find its File Type by Extension.

        IF (Fext.EQ.'tsh') Ftype = 1

        IF (Fext.EQ.'tsl') Ftype = 2

        IF (Fext.EQ.'tsd') Ftype = 3

        IF (Fext.EQ.'tsr') Ftype = 3

        IF (Fext.EQ.'ts2') Ftype = 4

        IF (Fext.EQ.'ts3') Ftype = 4

        IF (Fext.EQ.'ts4') Ftype = 4

        IF (Fext.EQ.'ts5') Ftype = 4

	  IF (Fext.EQ.'TSH') Ftype = 1

        IF (Fext.EQ.'TSL') Ftype = 2

        IF (Fext.EQ.'TSD') Ftype = 3

        IF (Fext.EQ.'TSR') Ftype = 3

        IF (Fext.EQ.'TS2') Ftype = 4

        IF (Fext.EQ.'TS3') Ftype = 4

        IF (Fext.EQ.'TS4') Ftype = 4

        IF (Fext.EQ.'TS5') Ftype = 4



        if(iprint.ge.1) write(*,*)'Ftype =', ftype

	  if( ftype.eq.3 ) then

	    write(*,*)'V5 format not supported'

	    stop

	  endif



	  CALL Chktsn(Filtbl,Indir,Outdir,Ftype)



      ELSE

c...loop for each possible MTU data type

        Npos = INDEX(Filtbl,'.')

        Filnam = Filtbl(1:Npos) // "tsh" // CHAR(0) 

        Ftype = 1

        CALL Chktsn(Filnam,Indir,Outdir,Ftype)



        Npos = INDEX(Filtbl,'.')

        Filnam = Filtbl(1:Npos) // "tsl" // CHAR(0) 

        Ftype = 2

        CALL Chktsn(Filnam,Indir,Outdir,Ftype)



        Filnam = Filtbl(1:Npos) // "ts2" // CHAR(0) 

        Ftype = 4

        CALL Chktsn(Filnam,Indir,Outdir,Ftype)



        Filnam = Filtbl(1:Npos) // "ts3" // CHAR(0) 

        Ftype = 4

        CALL Chktsn(Filnam,Indir,Outdir,Ftype)



        Filnam = Filtbl(1:Npos) // "ts4" // CHAR(0) 

        Ftype = 4

        CALL Chktsn(Filnam,Indir,Outdir,Ftype)



        Filnam = Filtbl(1:Npos) // "ts5" // CHAR(0) 

        Ftype = 4

        CALL Chktsn(Filnam,Indir,Outdir,Ftype)



 

      ENDIF



      STOP

      END

C

C -----------------------------------CHKTSN----------------------------

C

      SUBROUTINE Chktsn(Filnam,Indir,Outdir,Ftype)

C     Ftype: 1:tsh  2:tsl  3:tsR, tsD  4:ts2, ts3, ts4, ts5

      

      implicit integer*2 (i-n)

	

#ifdef DOS

      include 'op_sys_DOS.inc'

#else

      include 'op_sys_UNIX.inc'

#endif

      include 'ctrlblk.inc'

		

	CHARACTER*72  Filnam, Filtsn, Filets, Indir, Outdir, Filasn

      INTEGER*4  Ftype, Npos

      LOGICAL*2  Filok



	character sep*1 



	character*6 stat

	character*8 window

      common /statinfo/ stat, window





      call dirsep(sep)



      Npos_dot = INDEX(Filnam,'.')

      Npos_blk = lnblnk(Indir)

c

      IF (Indir(1:1) .EQ. ".") THEN

        Filtsn   = Filnam(1:Npos_dot+4)

      ELSE

        Filtsn   = Indir(1:Npos_blk)//sep//Filnam(1:Npos_dot+4)

      ENDIF



c...Opening input file

      Filok = .FALSE.

      OPEN(600,File=Filtsn,STATUS='OLD',ACCESS='SEQUENTIAL',ERR=16)

	if(iprint.ge.1) write(*,*)'Opened input file successfully: ', 

     &           Filtsn(1:lnblnk(Filtsn))

      Filok = .TRUE.    

16    CLOSE(600)

c

c     IF FilOK THEN File EXIST.

      IF (Filok) THEN 



C       Create the output file name.

        IF (Outdir(1:1).eq.'.') then

	    Filets = window(1:8)//'.ts'

	  else

	    Filets = Outdir(1:lnblnk(Outdir))//sep//

     &                       window(1:8)//'.ts'

	  endif

	  if( iprint.ge.1 ) then

	    write(*,*)'Calling Readts with:'

	    write(*,*)'Ftype =', Ftype

	    write(*,*)'Filtsn=', Filtsn

	    write(*,*)'Filets=', Filets

	  endif

        call Readts(Ftype,Filtsn,Filets)      

      else

        WRITE(6,*) "NOT FOUND File:",Filtsn(1:lnblnk(Filtsn))

	  stop 'Error end'

      endif

C

      RETURN

      END



C -----------------------------------GETREC----------------------------

      SUBROUTINE Getrec(Brec,Erec)

C       Get the Begining Record Number and End Record Number. 

      

      implicit integer*2 (i-n)

	

	INTEGER*4 Irec, Frec, Trec, Brec, Erec

C

c     Set the First Record number

      Frec = Brec  

c     Set the Total number of Records  

      Trec = Erec

C       

      WRITE(6,*) "INPUT First Record to convert to ASCII"

      WRITE(6,*) Frec, " is default. Press <ENTER>"  

      READ(5,"(I5)") Irec

      IF (Irec.GE.Brec .AND. Irec.LE.Trec) Brec = Irec  

C

      WRITE(6,*) "INPUT Last Record to convert to ASCII"

      WRITE(6,*) Trec, " is default. Press <ENTER>"  

      READ(5,"(I7)") Irec

      IF (Irec.GE.Brec .AND. Irec.LE.Trec) Erec = Irec  

C

      WRITE(6,*) "Convert Records from ",Brec," to ",Erec

      WRITE(6,*) " "

C  

      RETURN

      END  

C

C -----------------------------------GETRAF----------------------------

C

      SUBROUTINE Getraf(Ifile,Trec)

C     Count the Record in the *.tsn files. 

      

      implicit integer*2 (i-n)



      INTEGER*4 Irec, Trec 

      INTEGER*2 Ifile  

      CHARACTER Btag*16

C

c     Set the First Record number

      Irec = 0  

      WRITE(6,*) 'Counting RECORDs in Time Series File.'

 16    READ(Ifile,REC=Irec+1,ERR=999) Btag     

       Irec = Irec + 1 

       GOTO 16 

C

 999  Trec = Irec

      WRITE(6,*) "Total number of records found:",Trec  

c

      RETURN

      END

C

C -----------------------------------READts----------------------------

C

      SUBROUTINE Readts(Ftype,Filtsn,Filets)

      

      implicit integer*2 (i-n)





#ifdef DOS

      include 'op_sys_DOS.inc'

#else

      include 'op_sys_UNIX.inc'

#endif



      include 'defaults.inc'

	include 'ctrlblk.inc'

		

	CHARACTER*72  Filtsn, Filets, Filts1, Filts2, Ascbuf, R2tag*70

      CHARACTER*72  Hdfiln, Hdfil1, Hdfil2, Hddate

      CHARACTER  Fext*4, Btag*16, R1tag*62

      INTEGER*4  Ftype, Lrec, Irec, Brec, Erec, Trec

      INTEGER*4  I4data(3072,5), Pt

      INTEGER*2  Ifile, Npos, Tsize, Bsize, Ierr, Ofile

      INTEGER*4  Scan, Chan, Ic, Hou, Min, Sec

	integer*2  scan2, chan2, hou2, min2, sec2

      INTEGER*4  Ofile1, Ofile2, Hdfile, Hdfile1, Hdfile2

      INTEGER*4  Htim, Etim, Tdif

      INTEGER*4  Kmin, Ksec, Isamp

	integer*2  Taglen, Srate

	integer*4  RecLen



	character*24 date_string

	character*80 line

      character*11 lat, lon

      character*17 azdir

	character*60 sitdes

	character*19 stime, etime



	character*6 stat

	character*8 window

      common /statinfo/ stat, window



	integer seq_rec

      integer azimex, azimey, azimhx, azimhy

	integer nptwrt                                   !No. of points written to TS file



	logical ASCOUT /.FALSE./

	common / ascwrt / ASCOUT



	call fdate(date_string)



      nptwrt = 0



      write(*,*) ' INPUT FILE: ',Filtsn(1:lnblnk(Filtsn))  



      Npos = INDEX(Filets,'.')

      IF (Ftype .EQ. 1) THEN

        Filts1 = Filets(1:Npos+3)

        Filts2 = Filets(1:Npos+3)

        Filts1(Npos+1:Npos+3) = "ts3"

        Filts2(Npos+1:Npos+3) = "ts4"

        Hdfil1 = Filts1

        Hdfil2 = Filts2

        Hdfil1(Npos+4:Npos+6) = "_hd"

        Hdfil2(Npos+4:Npos+6) = "_hd"

        WRITE(*,*) "OUTPUT FILES: ",Filts1(1:Npos+4), Filts2(1:Npos+4)

      ELSEIF (FType .EQ. 2) THEN

        Filets(Npos+1:Npos+3) = "ts"

        Hdfiln = Filets

        Hdfiln(Npos+4:Npos+6) = "_hd"

        WRITE(*,*) "OUTPUT FILE: ",Filets(1:lnblnk(Filets))

      ELSEIF (FType .EQ. 4) THEN

        Filets(Npos+1:Npos+2) = "ts"

        Hdfiln = Filets

        Hdfiln(Npos+4:Npos+6) = "_hd"

        WRITE(*,*) "OUTPUT FILE: ",Filets(1:lnblnk(Filets))

      ENDIF



      if(iprint.ge.1) WRITE(*,*) "Ftype:",Ftype  

c  

      Npos = INDEX(Filtsn,'.')

      Fext(1:4) = Filtsn(Npos+1:Npos+3) // CHAR(0)

c

c     Read the first Btag (16 Bytes) and decode Tsize, Chan & Scan

      Ifile = 20

      OPEN(UNIT=Ifile,FILE=Filtsn,ACCESS='DIRECT',STATUS='OLD',RECL=16)

      READ(Ifile,REC=1,ERR=999) Btag

999   CLOSE(Ifile)

c

c     Check the status of Bit 14 in Btag. If NOT 0 then 32-byte TAG.

      IF (Btag(14:14) .EQ. CHAR(0)) THEN

         Tsize = 16           

         WRITE(6,*) 'Tag size found as 16-bytes for *.',Fext(1:3)

      ELSE

         Tsize = 32           

         WRITE(6,*) 'Tag size found as 32-bytes for *.',Fext(1:3)

      ENDIF



C     Decode the Btag information for CHAN and info required for TS file

      CALL Bcode1(Btag,Scan2,Chan2,R1tag,Hou2,Min2,Sec2)

	scan = scan2

	chan = chan2

	hou = hou2

	min = min2

	sec = sec2



      

	stime = R1tag(2:5)//'-'//R1tag(7:8)//'-'//R1tag(10:11)//' '//

     &        R1tag(15:22)

	etime = '2003-12-31 23:59:59'   !THIS NEEDS TO BE FIXED!!!

	read(R1tag(27:30),'(i4)') mtunum

	read(R1tag(35:38),'(i4)') idelta

	delta = float(idelta)

	read(R1tag(43:44),'(i2)') nchan



      if( iprint.ge.1 ) then

        write(6,*)'First Btag: ', R1tag

	  write(*,*)'stime =<', stime,'>'

	  write(*,*)'mtunum =', mtunum

	  write(*,*)'idelta =', idelta

	  write(*,*)'nchan =', nchan

	endif



c...reduce mtunum to 3-chars

	do while( mtunum.ge.1000 )

	  mtunum = mtunum-1000

	enddo

      if( iprint.ge.1 ) then

	  write(*,*)'mtunum for TS file use =', mtunum

	endif



C     Make sure that all sample indices relate to same (HTIM) time

      IF (Ftype .EQ. 1) Htim = Hou*60*60 + Min*60 + Sec

      IF (Ftype .EQ. 2) THEN

        IF (Htim .NE. 0) THEN

          Etim = Hou*60*60 + Min*60 + Sec

          Tdif = Htim - Etim

          IF (Tdif .LT. 0) Tdif = Tdif + 24*60*60

          WRITE (6,*) "Time difference between HTIM & ETIM: ", 

     &                Tdif," sec - skipped."

        ENDIF

      ENDIF

      IF (Ftype .EQ. 4) THEN

        IF (Htim .EQ. 0) THEN

C         Must be highest sampling rate / level 

          Htim = Hou*60*60 + Min*60 + Sec

          Tdif = 0

        ELSE

C         lower sampling rate -> prob. earlier start time

          Etim = Hou*60*60 + Min*60 + Sec

          Tdif = Htim - Etim

          IF (Tdif .LT. 0) Tdif = Tdif + 24*60*60

          WRITE (6,*) "Time difference between HTIM & ETIM: ", 

     &                Tdif," sec - skipped."

        ENDIF

      ENDIF



c     The Byte size is FIX to 3, but the Lrec changes with Scan.

      Bsize = 3



c...this comes from Gerry Graham (email of 9 March 2004)

      Taglen = Tsize

	Bsize = 3               !For both V5-comp and V5-2000 modes

	Srate = Scan

	RecLen = (INT4(Taglen) + INT4(Bsize * Chan * Srate))/4



      IF (Ftype .NE. 1) THEN 

        Lrec = INT4(Tsize) + INT4(Scan)*INT4(Bsize*Chan)

c        WRITE(6,*) "RANDOM ACCESS FILE with Lrec  :",Lrec

        WRITE(6,*) "RANDOM ACCESS FILE with RecLen:",RecLen

c       OPEN a Random Access File for *.TSN data.

c        OPEN(Ifile,FILE=Filtsn,ACCESS='DIRECT',STATUS='OLD',RECL=Lrec)

        OPEN(Ifile,FILE=Filtsn,ACCESS='DIRECT',STATUS='OLD',RECL=RecLen)

      ELSE

c       OPEN a Sequential Access File for *.tsh data. (2 Sample Rates)

        OPEN(Ifile,FILE=Filtsn,FORM='BINARY',ACCESS='SEQUENTIAL'

     &                        ,STATUS='OLD')

        WRITE(6,*) "SEQUENTIAL ACCESS FILE for 2 Sample Rates"

      ENDIF  







c...Open TS file

   	

	IF (Ftype .NE. 1) THEN

        Ofile = 30

c        OPEN(Ofile,FILE=Filasn,FORM='BINARY',ACCESS='SEQUENTIAL',

c     &       STATUS='UNKNOWN')

c

	if( UNIX .and. sysend.eq.'Big' ) then

        open(Ofile,FILE=Filets,FORM='UNFORMATTED',STATUS='UNKNOWN')

        write(*,'(a)')'Opened unformatted output file: '//Filets

      else

#ifdef DOS

        open(Ofile,FILE=Filets,FORM='UNFORMATTED',STATUS='UNKNOWN',

     &     convert='BIG_ENDIAN')

        write(*,'(2a)')'Opened BIG_ENDIAN unformatted output file: '//

     &                Filets

#else

        open(Ofile,FILE=Filets,FORM='UNFORMATTED',STATUS='UNKNOWN')

        write(*,'(2a)')'Opened unformatted output file: '//

     &                Filets

#endif

      endif

	  Hdfile = 35

        OPEN(Hdfile,FILE=HdFiln,ACCESS='SEQUENTIAL',STATUS='UNKNOWN')

      ELSE

	  write(*,*)'Program only works for Ftype .NE. 1'

        Ofile1 = 31

c        OPEN(Ofile1,FILE=Filas1,FORM='BINARY',ACCESS='SEQUENTIAL',

c     &       STATUS='UNKNOWN')

        Ofile2 = 32

c        OPEN(Ofile2,FILE=Filas2,FORM='BINARY',ACCESS='SEQUENTIAL',

c     &       STATUS='UNKNOWN')

c

        Hdfile1 = 36

c        OPEN(Hdfile1,FILE=Hdfil1,ACCESS='SEQUENTIAL',STATUS='UNKNOWN')

        Hdfile2 = 37

c        OPEN(Hdfile2,FILE=Hdfil2,ACCESS='SEQUENTIAL',STATUS='UNKNOWN')

         stop

      ENDIF





c-------------------------------------------------------------------------------

c     write out comment block



      exlen = 100.

	eylen = 100.

      azdir = 'MAGNETIC NORTH'

      azimex = 0

	azimey = 90

	azimhx = 0

	azimhy = 90

	mtuver = 9999

	maghx = 1201

	maghy = 1202

	maghz = 1203

	sitdes = 'Test site'

	rlat = -75.0000

	rlon =  45.0000

	elev = 0.

	longorigin = -45.

	utmn = 5000.

	utme = 5000.

	seq_rec = 1

	decl = -20.





      line = '# time series file from phx2ts'

      write(Ofile) line

      line = '# date: '//date_string

      write(Ofile) line



      line = '#'

      write(Ofile) line

      line = '# input file: '//Filtsn

      write(Ofile) line



      line = '#'

      write(Ofile) line

      line = '# Machine endian: '//sysend

      write(Ofile) line

      line = '# UNIX set      : '

      write(line(19:19),'(l1)') UNIX

      write(Ofile) line



      line = '#'

      write(Ofile) line

      line = '# site description: '//sitdes

      write(Ofile) line



      lat = ' +000:00:00'

	lon = ' +000:00:00'

      line = '#'

      write(Ofile) line

      line = '# Latitude   :'//lat

      write(Ofile) line

      line = '# Longitude  :'//lon

      write(Ofile) line



c...instrument numbers

      line = '#'

      write(Ofile) line

      write(line,'(a,i4)') '# MTU acquisition code : ', mtuver

      write(Ofile) line

      write(line,'(a,i4)') '# MTU box     number   : ', mtunum

      write(Ofile) line

	write(line,'(a)') '# Magnetometer coil numbers'

      write(Ofile) line

	write(line,'(a,i4)')'# Hx coil :', maghx

      write(Ofile) line

      write(line,'(a,i4)')'# Hy coil :', maghy

      write(Ofile) line

	write(line,'(a,i4)')'# Hz coil :', maghz

      write(Ofile) line



      line = '#'

      write(Ofile) line

      write(line,'(a,f10.2)') '# Ex line length (m): ', exlen

      write(Ofile) line

      write(line,'(a,f10.2)') '# Ey line length (m): ', eylen

      write(Ofile) line





      line = '#'

      write(Ofile) line

      line = '# Azimuths relative to: '//azdir

      write(Ofile) line

      write(line,'(a,i3)') '# Ex azimuth; ', azimex

      write(Ofile) line

      write(line,'(a,i3)') '# Ey azimuth; ', azimey

      write(Ofile) line

      write(line,'(a,i3)') '# Hx azimuth; ', azimhx

      write(Ofile) line

      write(line,'(a,i3)') '# Hy azimuth; ', azimhy

      write(Ofile) line





      line = '#F Filter block begin'

      write(Ofile) line

      line = '#F'

      write(Ofile) line

      line = '#F Filters applied to LiMS/LRMT data are:'

      write(Ofile) line

      line = '#F 1: Analogue anti-alias six-pole Bessel low-pass'

      write(Ofile) line

      line = '#F    filters on each channel with -3 dB point at '//

     &              'nominally 5 Hz.'

      write(Ofile) line

      line = '#F    -calibrated values given below'

      write(Ofile) line

      line = '#F'

      write(Ofile) line

      line = '#F 2: Digital anti-alias multi-stage Chebyshev FIR '//

     &              'filters'

      write(Ofile) line

      line = '#F    with final stage at 2xsampling rate'

      write(Ofile) line

      line = '#F'

      write(Ofile) line

      line = '#F 1: Analogue single-pole Butterworth high-pass '//

     &             'filters on the'

      write(Ofile) line

      line = '#F    telluric channels only with -3 dB point at'//

     &              ' nominally 30,000 s'

      write(Ofile) line

      line = '#F    -calibrated values given below'

      write(Ofile) line

      line = '#F'

      write(Ofile) line

      line = '#F Chan     Calib    Low-pass   High-pass (s)'

      write(Ofile) line

c      if(nchan.eq.5)then

c...note reordering that takes place in main processing codes

c        write(line(4:),'(i2,3f12.2)')1, calibs(1), cutsl(1), cutsh(1)

c        write(Ofile) line

c        write(line(4:),'(i2,3f12.2)')2, calibs(2), cutsl(2), cutsh(2)

c        write(Ofile) line

c        write(line(4:),'(i2,3f12.2)')3, calibs(5), cutsl(5), cutsh(5)

c        write(Ofile) line

c        write(line(4:),'(i2,3f12.2)')4, calibs(3), cutsl(3), cutsh(3)

c        write(Ofile) line

c        write(line(4:),'(i2,3f12.2)')5, calibs(4), cutsl(4), cutsh(4)

c        write(Ofile) line

c      else

c        do i = 1, nchan

c          write(line(4:),'(i2,3f12.2)')i,calibs(i),cutsl(i),cutsh(i)

c          write(Ofile) line

c        enddo

c      endif

      line = '#F'

      write(Ofile) line

      line = '#F In the tsrestack code, these filter responses are'

      write(Ofile) line

      line = '#F removed using bessel7.f and high17.f'

      write(Ofile) line

      line = '#F'

      write(Ofile) line

      line = '#F Filter block end'

      write(Ofile) line

      





c-------------------------------------------------------------------------------

c     write out info block





c...info start

      line = '>INFO_START:'

      write(Ofile) line



c...station

      line = '>STATION'

      line(12:) = ':'

      line(13:) = stat

      write(Ofile) line



c...instrument

      line = '>INSTRUMENT'

      line(12:) = ':'

      write(line(13:),*) mtunum

      write(Ofile) line



c...window

      line = '>WINDOW'

      line(12:) = ':'

      line(13:) = window

      write(Ofile) line



c...latitude

      line = '>LATITUDE'

      line(12:) = ':'

      write( line(13:),*) rlat

      write(Ofile) line



c...longitude

      line = '>LONGITUDE'

      line(12:) = ':'

      write( line(13:),*) rlon

      write(Ofile) line



c...elevation

      line = '>ELEVATION'

      line(12:) = ':'

      write( line(13:),* ) elev

      write(Ofile) line



c...UTM coordinates

      line = '>UTM_ORIGIN'

      line(12:) = ':'

      write( line(13:),* ) longorigin

      write(Ofile) line



      line = '>UTM_NORTH'

      line(12:) = ':'

      write( line(13:),* ) nint(utmn)

      write(Ofile) line



      line = '>UTM_EAST'

      line(12:) = ':'

      write( line(13:),* ) nint(utme)

      write(Ofile) line



c...coordinate system

      line = '>COORD_SYS'

      line(12:) = ':'

      line(13:) = azdir

      write(Ofile) line



c...declination

      if( index(azdir,'MAGNETIC').ne.0 ) then

        call rin('Give declination [default is site value]', decl)      

        line = '>DECLIN'

        line(12:) = ':'

	  write(line(13:),*) decl

        write(Ofile) line

	endif



c...form

      line = '>FORM'

      line(12:) = ':'

      line(13:) = 'BINARY'

      write(Ofile) line



c...format

      line = '>FORMAT'

      line(12:) = ':'

      line(13:) = 'UNFORMATTED'

      write(Ofile) line



c...endian

      line = '>ENDIAN'

      line(12:) = ':'

      line(13:) = 'Big'

      write(Ofile) line



c...binary format

      line = '>BIN_FORM'

      line(12:) = ':'

      line(13:) = 'IEEE'

      write(Ofile) line



c...seq_rec

      line = '>SEQ_REC'

      line(12:) = ':'

      write( line(13:),* ) seq_rec

      write(Ofile) line



c...nchan

      line = '>NCHAN'

      line(12:) = ':'

      write( line(13:),* ) nchan

      write(Ofile) line





c...chan_1

      line = '>CHAN_1'

      line(12:) = ':'

      line(13:) = 'HX'

      write(Ofile) line

c...sensor_1

      line = '>SENSOR_1'

      line(12:) = ':'

      write( line(13:),* ) maghx

      write(Ofile) line

c...azim_1

      line = '>AZIM_1'

      line(12:) = ':'

      write( line(13:),* ) float(azimhx)

      write(Ofile) line

c...units_1

      line = '>UNITS_1'

      line(12:) = ':'

      line(13:) = 'nT'

      write(Ofile) line

c...gain_1

      line = '>GAIN_1'

      line(12:) = ':'

      line(13:) = '1.0'

      write(Ofile) line





c...chan_2

      line = '>CHAN_2'

      line(12:) = ':'

      line(13:) = 'HY'

      write(Ofile) line

c...sensor_2

      line = '>SENSOR_2'

      line(12:) = ':'

      write( line(13:),* ) maghy

      write(Ofile) line

c...azim_2

      line = '>AZIM_2'

      line(12:) = ':'

      write( line(13:),* ) float(azimhy)

      write(Ofile) line

c...units_2

      line = '>UNITS_2'

      line(12:) = ':'

      line(13:) = 'nT'

      write(Ofile) line

c...gain_2

      line = '>GAIN_2'

      line(12:) = ':'

      line(13:) = '1.0'

      write(Ofile) line



c...chan_3

      line = '>CHAN_3'

      line(12:) = ':'

      line(13:) = 'HZ'

      write(Ofile) line

c...sensor_3

      line = '>SENSOR_3'

      line(12:) = ':'

      write( line(13:),* ) maghz

      write(Ofile) line

c...azim_3

      line = '>AZIM_3'

      line(12:) = ':'

      write( line(13:),* ) 0.0

      write(Ofile) line

c...units_3

      line = '>UNITS_3'

      line(12:) = ':'

      line(13:) = 'nT'

      write(Ofile) line

c...gain_3

      line = '>GAIN_3'

      line(12:) = ':'

      line(13:) = '1.0'

      write(Ofile) line



      if( nchan.eq.5) then

c...chan_4

        line = '>CHAN_4'

        line(12:) = ':'

        line(13:) = 'EX'

        write(Ofile) line

c...sensor_4

        line = '>SENSOR_4'

        line(12:) = ':'

        write( line(13:),* ) mtunum

        write(Ofile) line

c...azim_4

        line = '>AZIM_4'

        line(12:) = ':'

        write( line(13:),* ) float(azimex)

        write(Ofile) line

c...units_4

        line = '>UNITS_4'

        line(12:) = ':'

        line(13:) = 'mV/km'

        write(Ofile) line

c...gain_4

        line = '>GAIN_4'

        line(12:) = ':'

        line(13:) = '1.0'

        write(Ofile) line

c...chan_5

        line = '>CHAN_5'

        line(12:) = ':'

        line(13:) = 'EY'

        write(Ofile) line

c...sensor_5

        line = '>SENSOR_5'

        line(12:) = ':'

        write( line(13:),* ) mtunum

        write(Ofile) line

c...azim_5

        line = '>AZIM_5'

        line(12:) = ':'

        write( line(13:),* ) float(azimey)

        write(Ofile) line

c...units_5

        line = '>UNITS_5'

        line(12:) = ':'

        line(13:) = 'mV/km'

        write(Ofile) line

c...gain_5

        line = '>GAIN_5'

        line(12:) = ':'

        line(13:) = '1.0'

        write(Ofile) line

      endif



c...starttime

      line = '>STARTTIME'

      line(12:) = ':'

      line(13:) = stime

      write(Ofile) line



c...endtime

      line = '>ENDTIME'

      line(12:) = ':'

      line(13:) = etime

      write(Ofile) line



c...tunits

      line = '>T_UNITS'

      line(12:) = ':'

      line(13:) = 'Hz'

      write(Ofile) line



c...delta_t

      line = '>DELTA_T'

      line(12:) = ':'

      write( line(13:), * ) delta

      write(Ofile) line



c...misdat

      line = '>MIS_DATA'

      line(12:) = ':'

      write( line(13:), * ) DEFMISDAT

      write(Ofile) line



c...info end

      line = '>INFO_END  :'

      write(Ofile) line



c-----------------------------------------------------------------------------------------

C       Fix the File Name length for easier READ FORMAT.     

        Ascbuf(01:36) = "                                    "

        Ascbuf(37:72) = "                                    "

        Npos = 3+ INDEX(Filets,'.')

        Ascbuf(1:Npos) = Filets(1:Npos)

c        WRITE(Ofile,'(A6,A72)') "File: ",Ascbuf

        Irec = 0

C

      IF (Ftype .EQ. 1) THEN

C       Tsize .EQ. 16 for MTU-5 MTU data to Version D.

         IF (Tsize .EQ. 16) THEN

C           Count the number of records in the file.

            CALL Cntrec(Ifile,Tsize,Trec)

            Brec = 1

            Erec = Trec

C            CALL Getrec(Brec,Erec)

            Ierr = 0

C...IF Brec is NOT first record THEN move File Pointer.

            CALL Putrec(Ifile,Tsize,Brec)



C           SEQUENTIAL ACCESS FILE with 16-Byte Tags from MTU

            lfirst = 1

            Kmin  =  0

            Ksec  = -1

            DO 100 Irec = Brec, Erec



c              Get the next record.

               Minold = Min

               Ksec   = Ksec + 1

               CALL Gettsh(Ifile,R1tag,Scan2,Chan2,Min2,I4data,Ierr)

	         scan = scan2

	         chan = chan2

	         min = min2

c               WRITE(6,*)"TAGn: ", R1tag

               IF (Ierr .eq. 0) THEN

c...Determine minutes (-> samples) to skip

                  IF(Min .NE. Minold .AND. lfirst .NE.1) THEN

                     Mindif = Min - Minold

                     IF (Mindif .LT. 0) Mindif = Mindif + 60

                     Ksec = 0

                     Kmin = Kmin + Mindif

                  ENDIF

c...Write header to _hd file

                  IF (Irec.EQ.Brec) THEN

                     WRITE(Hddate,120) R1tag(4:5), R1tag(7:8),

     &                                 R1tag(10:11), R1tag(15:16),

     &                                 R1tag(18:19), R1tag(21:22)

120                  FORMAT(a2,1x,a2,1x,a2,1x,a2,1x,a2,1x,a2)

                  ENDIF

                  IF (lfirst.EQ.1 .OR.

     &                (Kmin.EQ.Mindif.AND.Kmin.NE.0.AND.Ksec.EQ.0)) THEN

                      IF (Scan .GE. 1000) THEN

                         Hdfile = Hdfile1

                      ELSE

                         Hdfile = Hdfile2

                      ENDIF 

                      WRITE(Hdfile,'(1x,a4,1x,a1)') R1tag(35:38),

     &                                              R1tag(44:44)

                      WRITE(Hdfile,*) Hddate

                  ENDIF

                  

c                 For calculate of offset in samples

                  IF (Scan .GE. 1000) THEN

                     Ofile = Ofile1

                  ELSE

                     Ofile = Ofile2

                  ENDIF

                  do Pt = 1, Scan

c                write(Ofile) (real(I4data(Pt,Ic)),Ic=1,Chan)

                write(Ofile) real(I4data(Pt,3)),                     ! Hx

     &                       real(I4data(Pt,4)),                     ! Hy

     &                       real(I4data(Pt,5)),                     ! Hz

     &                       real(I4data(Pt,1)),                     ! Ex

     &                       real(I4data(Pt,2))                      ! Ey

	               nptwrt = nptwrt + 1

			       if (ASCOUT) write(69,*)nptwrt,(I4data(Pt,Ic),Ic=1,Chan)

c                     Isamp = (60*Kmin+Ksec)*Scan + Pt

c                     WRITE(*,*) Isamp, (I4data(Pt,Ic),Ic=1,Chan)

                  enddo

               ENDIF   

               lfirst = 0

c              Get the next record.

 100        CONTINUE

            WRITE(6,*)"TAGn: ", R1tag

         ELSE

C           Tsize .EQ. 32 for MTU-5A AMT data from Version A

C           Count the number of records in the file.

            CALL Cntrec(Ifile,Tsize,Trec)

            Brec = 1

            Erec = Trec

            CALL Getrec(Brec,Erec)

            Ierr = 0

C           IF Brec is NOT first record THEN move File Pointer.

            CALL Putrec(Ifile,Tsize,Brec)

C     

            DO 102 Irec = Brec, Erec

               IF (Ierr .NE. 0) GOTO 102

               CALL Gtatsh(Ifile,R1tag,R2tag,Scan2,Chan2,I4data,Ierr)

	         scan = scan2

	         chan = chan2

c               IF (Ierr .EQ. 0) THEN

c                  IF(Irec.EQ.Brec) WRITE(6,*) "TAG1: ", R1tag

c                  IF(Irec.EQ.Brec) WRITE(6,*) ">>    ", R2tag

c                  WRITE(Ofile,'(A2,I7.5,1X,A62)')"> ",Irec, R1tag

c                  WRITE(Ofile,'(A2,A70)')">>", R2tag

c                  DO 242 Pt = 1, Scan

c                     WRITE(Ofile,'(6(I9,2x))') Pt, 

c     &                                         (I4data(Pt,Ic),Ic=1,Chan)

c 242              CONTINUE

c               ENDIF     

c              Get the next record.

 102        CONTINUE

            WRITE(6,*) "TAGn: ", R1tag

            WRITE(6,*) ">>    ", R2tag

         ENDIF 

      ENDIF



c...Ftype = 2. This is for V5 compatible files (MTU-5)

      IF (Ftype .EQ. 2) THEN

C       Get the number of RECORDS in the Random Access File.

        CALL Getraf(Ifile,Trec)

        Brec = 1 + Tdif

        Erec = Trec

C        CALL Getrec(Brec,Erec)

C       RANDOM ACCESS FILE with 16-Byte Tags

        Ierr = 0

        Ksec = -1

	  if(iprint.ge.1)write(*,*)'Getting records from Brec -> Erec', 

     &                 Brec, Erec

        DO 200 Irec = Brec, Erec

          IF (Ierr .NE. 0) GOTO 200

          CALL Gettsl(Ifile,Irec,R1tag,I4data,Ierr)

          Ksec = Ksec + 1

          IF (Ierr .EQ. 0) THEN

             IF(Irec.EQ.Brec) THEN

                WRITE(Hddate,120) R1tag(4:5), R1tag(7:8), R1tag(10:11),  

     &                         R1tag(15:16),R1tag(18:19), R1tag(21:22)

                WRITE(Hdfile,'(1x,a4,1x,a1)') R1tag(35:38), R1tag(44:44)

                WRITE(Hdfile,*) Hddate

             ENDIF

             do Pt = 1, Scan

c                write(Ofile) (real(I4data(Pt,Ic)),Ic=1,Chan)

                write(Ofile) real(I4data(Pt,3)),                     ! Hx

     &                       real(I4data(Pt,4)),                     ! Hy

     &                       real(I4data(Pt,5)),                     ! Hz

     &                       real(I4data(Pt,1)),                     ! Ex

     &                       real(I4data(Pt,2))                      ! Ey

	          nptwrt = nptwrt + 1

	          if (ASCOUT) write(69,*) nptwrt, (I4data(Pt,Ic),Ic=1,Chan)

c                Isamp = Ksec*Scan + Pt

c                WRITE(*,*) Isamp, (I4data(Pt,Ic),Ic=1,Chan)

             enddo

          ENDIF     

c         Get the next record.

 200    CONTINUE

        WRITE(6,*)"TAGn: ", R1tag

      ENDIF

C

      IF (Ftype .EQ. 3) THEN

        WRITE(6,*) "V5 FORMAT NOT SUPPORTED"

      ENDIF





c...Ftype = 4: This is for V5-2000 files (MTU-5A)

      IF (Ftype .EQ. 4) THEN

C       Get the number of RECORDS in the Random Access File.

        CALL Getraf(Ifile,Trec)

        Brec = 1 + Tdif

        Erec = Trec

C        CALL Getrec(Brec,Erec)

        Ierr = 0

        Ksec = -1

	  if(iprint.ge.1) write(*,*)'Getting records from Brec -> Erec', 

     &                  Brec, Erec

C...RANDOM ACCESS FILE with 32-Byte Tags

        DO 400 Irec = Brec, Erec

          IF (Ierr .NE. 0) GOTO 400

c...get the next record

          CALL Gettsn(Ifile,Irec,R1tag,R2tag,I4data,Ierr)

          Ksec = Ksec + 1

          IF (Ierr .EQ. 0) THEN

            IF(Irec.EQ.Brec) THEN

               WRITE(Hddate,120) R1tag(4:5), R1tag(7:8), R1tag(10:11),  

     &                         R1tag(15:16),R1tag(18:19), R1tag(21:22)

               WRITE(Hdfile,'(1x,a4,1x,a1)') R1tag(35:38), R1tag(44:44)

               WRITE(Hdfile,*) Hddate

            ENDIF

            do Pt = 1, Scan

c                if (pt .eq. 1) write(*,*) isamp,ksec,scan

c                write(Ofile) (real(I4data(Pt,Ic)),Ic=1,Chan)

                write(Ofile) real(I4data(Pt,3)),                     ! Hx

     &                       real(I4data(Pt,4)),                     ! Hy

     &                       real(I4data(Pt,5)),                     ! Hz

     &                       real(I4data(Pt,1)),                     ! Ex

     &                       real(I4data(Pt,2))                      ! Ey

	               nptwrt = nptwrt + 1

	               if( nptwrt*(nptwrt/1000).eq.nptwrt) then

	                 write(*,*)'Points written...', nptwrt

	               endif

			       if (ASCOUT) write(69,*) nptwrt, (I4data(Pt,Ic),Ic=1,Chan)

c                     Isamp = (60*Kmin+Ksec)*Scan + Pt

c                     WRITE(*,*) Isamp, (I4data(Pt,Ic),Ic=1,Chan)

            enddo

          ENDIF     

400     CONTINUE

        WRITE(*,*) "TAGn: ", R1tag

        WRITE(*,*) ">>    ", R2tag

      ENDIF

C

      CLOSE(Ifile)

      IF (Ftype .NE. 1) THEN

        CLOSE(Ofile)

        CLOSE(Hdfile)

      ELSE

        CLOSE(Ofile1)

        CLOSE(Ofile2)

        CLOSE(Hdfile1)

        CLOSE(Hdfile2)

      ENDIF

C

      write(*,*)'No. of points written to file =', nptwrt

      RETURN

      END  

C

C ------------------------ CntRec -------------------------------------

C 

      SUBROUTINE Cntrec(Ifile,Tsize,Trec)

      

      implicit integer*2 (i-n)



      INTEGER*2    Ifile, Scan, Chan

      INTEGER*2    Ic, Is, Tsize, Hou, Min, Sec

      INTEGER*4    Irec, Trec

      CHARACTER    Cdat*3,B1tag*16, B2tag*32, R1tag*62, R2tag*70

C

      Irec = 0

C

c     Read Tag and then Mtudat(Ch,Pt) 

C

 16   CONTINUE

        IF (Tsize .EQ. 16) THEN

C         SEQUENTIAL ACCESS FILE with 16-Byte Tags from MTU

          READ(Ifile,END=999,ERR=999) B1tag     

          CALL Bcode1(B1tag,Scan,Chan,R1tag,Hou,Min,Sec)

        ELSE

C         SEQUENTIAL ACCESS FILE with 32-Byte Tags from MTU

          READ(Ifile,END=999,ERR=999) B2tag     

          CALL Bcode2(B2tag,Scan,Chan,R1tag,R2tag)

        ENDIF  

C

        Irec = Irec + 1  

c       READ the  DATA.

        DO 80 Is = 1, Scan

          DO 55 Ic = 1, Chan   

            READ(Ifile) Cdat 

 55       CONTINUE

 80     CONTINUE

C      Check for next record

      GOTO 16  

C

 999  Trec = Irec  

c

C     Reset File Pointer to beginning of File.

      REWIND(Ifile)  

c

      RETURN

      END



C

C ------------------------ PutRec -------------------------------------

C 

      SUBROUTINE Putrec(Ifile,Tsize,Brec)

      

      implicit integer*2 (i-n)



      include 'ctrlblk.inc'



      INTEGER*2    Ifile, Scan, Chan

      INTEGER*2    Ic, Is, Tsize, Hou, Min, Sec

      INTEGER*4    Irec, Brec

      CHARACTER    Cdat*3,B1tag*16, B2tag*32, R1tag*62, R2tag*70



      if( iprint.ge.1 ) then

	  write(*,*)'Entered Putrec with:'

	  write(*,*)'Ifile =', Ifile

	  write(*,*)'Tsize =', Tsize

	  write(*,*)'Brec  =', Brec

	endif



      Irec = 1



c...Read Tag and then Mtudat(Ch,Pt) 



 16   CONTINUE

        IF (Irec .EQ. Brec) GOTO 999

        IF (Tsize .EQ. 16) THEN

C         SEQUENTIAL ACCESS FILE with 16-Byte Tags from MTU

          READ(Ifile,ERR=999) B1tag     

          CALL Bcode1(B1tag,Scan,Chan,R1tag,Hou,Min,Sec)

        ELSE

C         SEQUENTIAL ACCESS FILE with 32-Byte Tags from MTU

          READ(Ifile,ERR=999) B2tag     

          CALL Bcode2(B2tag,Scan,Chan,R1tag,R2tag)

        ENDIF  

C

        Irec = Irec + 1  

c       READ the  DATA.

        DO 80 Is = 1, Scan

          DO 55 Ic = 1, Chan   

            READ(Ifile) Cdat 

 55       CONTINUE

 80     CONTINUE

C      Check for next record

      GOTO 16  

C

999   CONTINUE  

c

      RETURN

      END



C

C ------------------------ GETtsh -------------------------------------

C 

      SUBROUTINE Gettsh(Ifile,R1tag,Scan,Chan,Min,I4data,Ierr)

      

      implicit integer*2 (i-n)



      INTEGER*2    Ifile, Scan, Chan

      INTEGER*2    Ic, Is, Ierr, Hou, Min, Sec

      CHARACTER    Btag*16, R1tag*62

c

      CHARACTER*3 Cdat 

      CHARACTER*4 C4data(1:5,1:3072)

      INTEGER*4   E4data(1:5,1:3072)

      INTEGER*4   I4data(1:3072,1:5)

c

      EQUIVALENCE  (E4data,C4data)

c

c     Read Mtudat(Ch,Pt) and Write C4dat(Pt,Ch) and convert to I4data(Pt,Ch)

C

      READ(Ifile,ERR=999) Btag     

      CALL Bcode1(Btag,Scan,Chan,R1tag,Hou,Min,Sec)

c

c     READ the  DATA.

      DO 80 Is = 1, Scan

        DO 55 Ic = 1, Chan   

          READ(Ifile) Cdat 

c         COPY the DATA from 3-byte CHAR to 4-byte 'INTEGER' format.

          C4data(Ic,Is)(2:4) = Cdat(1:3)

C

c         Convert the 3-byte Character data to 4-byte Integer by EQUIVALENT

c         Down shift the 4-byte Integer to 3-bytes by dividing by 256

          I4data(Is,Ic) = E4data(Ic,Is) / 256     

C

 55     CONTINUE

 80   CONTINUE

C

      Ierr = 0

      RETURN

C

 999  Ierr = -1

c

      RETURN

      END

C

C ------------------------ GTAtsh -------------------------------------

C 

      SUBROUTINE Gtatsh(Ifile,R1tag,R2tag,Scan,Chan,I4data,Ierr)

      

      implicit integer*2 (i-n)



      include 'ctrlblk.inc'



      INTEGER*2    Ifile, Scan, Chan

      INTEGER*2    Ic, Is, Ierr

      CHARACTER    B2tag*32, R1tag*62, R2tag*70

c

      CHARACTER*3 Cdat 

      CHARACTER*4 C4data(1:5,1:2400)

      INTEGER*4   E4data(1:5,1:2400)

      INTEGER*4   I4data(1:3072,1:5)

c

      EQUIVALENCE  (E4data,C4data)

c

c     Read Mtudat(Ch,Pt) and Write C4dat(Pt,Ch) and convert to I4data(Pt,Ch)

C

      READ(Ifile,ERR=999) B2tag     

      CALL Bcode2(B2tag,Scan,Chan,R1tag,R2tag)

c

c     READ the  DATA.

      DO 80 Is = 1, Scan

        DO 55 Ic = 1, Chan   

          READ(Ifile) Cdat 

c         COPY the DATA from 3-byte CHAR to 4-byte 'INTEGER' format.

          C4data(Ic,Is)(2:4) = Cdat(1:3)

C

c         Convert the 3-byte Character data to 4-byte Integer by EQUIVALENT

c         Down shift the 4-byte Integer to 3-bytes by dividing by 256

          I4data(Is,Ic) = E4data(Ic,Is) / 256     

 55     CONTINUE

 80   CONTINUE

C

      Ierr = 0

      RETURN

C

 999  Ierr = -1

c

      RETURN

      END

C

C ------------------------ GETtsl -------------------------------------

C 

      SUBROUTINE Gettsl(Ifile,Irec,R1tag,I4data,Ierr)

      

      implicit integer*2 (i-n)



      include 'ctrlblk.inc'



      INTEGER*2    Ifile, Scan, Chan, Rpt

      INTEGER*2    Ch, Mp, Ichr, Ierr, Hou, Min, Sec

      INTEGER*4    Irec, I4data(3072,5), E4data(5*24)

      CHARACTER    Btag*16, R1tag*62

      CHARACTER*4  C4data(5*24)

      CHARACTER*3  Mtudat(5*24)

      EQUIVALENCE  (E4data,C4data)

c

c     Read Mtudat(Ch,Pt) and Write E3dat(Pt,Ch) and convert to I4data(Pt,Ch)

      READ(Ifile,REC=Irec,ERR=999) Btag     

      CALL Bcode1(Btag,Scan,Chan,R1tag,Hou,Min,Sec)

c

c     Calculate the number of 3-byte characters in the record.

      Ichr = Chan*Scan

c     READ the Btag and DATA.

      READ(Ifile,Rec=Irec,ERR=999) Btag,(Mtudat(Mp),Mp=1,Ichr)     

C

c     COPY the DATA from 3-byte CHAR to 4-byte 'INTEGER' format.

      DO 124 Mp = 1, Ichr

         C4data(Mp)(2:4) = Mtudat(Mp)(1:3)

 124  CONTINUE

C

c     Convert the 4-byte INTEGER format to 4-byte INTEGER array.

      DO 122 Rpt = 1, Scan

         DO 121 Ch = 1, Chan

            I = (Rpt-1)*Chan + Ch  

            I4data(Rpt,Ch) = E4data(I) / 256

 121     CONTINUE

 122  CONTINUE

c

      Ierr = 0

      RETURN

C

 999  Ierr = -1

c

      RETURN

      END

C

C ------------------------ GETtsN -------------------------------------

C 

      SUBROUTINE Gettsn(Ifile,Irec,R1tag,R2tag,I4data,Ierr)

      

      implicit integer*2 (i-n)



      include 'ctrlblk.inc'



      INTEGER*2    Ifile, Scn, Chn

      INTEGER*2    Ic, Is, Ierr

      INTEGER*4    Irec

      CHARACTER    B2tag*32, R1tag*62, R2tag*70

c

      CHARACTER*3 Mtudat(1:5,1:2400) 

      CHARACTER*4 C4data(1:5,1:2400)

      INTEGER*4   E4data(1:5,1:2400)

      INTEGER*4   I4data(1:3072,1:5)

c

      EQUIVALENCE  (E4data,C4data)



	if( iprint.ge.3 ) then

	  write(*,*)'Entered Gettsn with'

	  write(*,*)'Ifile =', Ifile

	  write(*,*)'Irec  =', Irec

	endif

c

c     Read Mtudat(Ch,Pt) and Write C4dat(Pt,Ch) and convert to I4data(Pt,Ch)

C

      READ(Ifile,REC=Irec,ERR=999) B2tag     

      CALL  Bcode2(B2tag,Scn,Chn,R1tag,R2tag)

c

c     READ the Btag&Stag and DATA.

      READ(Ifile,Rec=Irec) B2tag,((Mtudat(Ic,Is),Ic=1,Chn),Is=1,Scn)   

C

c     COPY the DATA from 3-byte CHAR to 4-byte 'INTEGER' format.

      DO 110 Is = 1, Scn

        DO 100 Ic = 1, Chn

          C4data(Ic,Is)(2:4) = Mtudat(Ic,Is)(1:3)

 100    CONTINUE

 110  CONTINUE

C

c     Convert the 3-byte Character data to 4-byte Integer by EQUIVALENT

c     Down shift the 4-byte Integer to 3-bytes by dividing by 256

C

      DO 2400 Is = 1, Scn

        DO 5 Ic = 1, Chn  

           I4data(Is,Ic) = E4data(Ic,Is) / 256     

 5      CONTINUE

2400  CONTINUE                 

c

      Ierr = 0

      RETURN

C

 999  Ierr = -1

c

      RETURN

      END

C

C ------------------------- BCODE1 ------------------------------------

c

      SUBROUTINE Bcode1(Btag,Scan,Chan,R1tag,Hou,Min,Sec)

C     SUBROUTINE Bcode1(Btag,Tmdat,Snum,Scan,Chan,Stus,Sid)

c

c     A Routine to Decode the Btag in the *.tsh & *.tsl MTU-Files.

c     The first 8 bytes contain DATE & TIME information (1 byte each).

c     The second 8 bytes contain the SR, SCAN, CHAN, STAT (2 bytes each).

c     Version C, STAT was recoded to be 1 byte Status & 1 byte Chan sats ID.

c

c D-T  1 - 8 bytes UTC time [ss mn hr dy mt yy dw ct] (1 byte each).

c Snum 9 -10 bytes Serial Number

c Scan 11-12 bytes Scans of data in the record

c Chan 13 byte  Number of channels

c Blen 14 byte  0 for 16 byte TAG or 32 for 32 byte TAG

c Stus 15 byte  Status 0:Normal 3:Saturation 4:Internal error 6:Time out

c Sflg 16 byte  Saturation Flag:bit 0 for Chan1, bit 1 for Chan2, etc.

c ---------------------------------------------------------------------

      

      implicit integer*2 (i-n)



      CHARACTER    Btag*16, Tmdat*24, Bdat*26, R1tag*62

c     INTEGER*2    Sec,Min,Hrs,Day,Mth,Yer,Wkd,Cnt

      INTEGER*2    Td(13), Snum,Scan,Chan,Stus, I,J, Sid, Blen

      INTEGER*2    Hou, Min, Sec

      EQUIVALENCE  (Bdat,Td)

c

      DO 10 I=1, 26

        Bdat(I:I) = CHAR(0)

 10   CONTINUE  

c

c     Expand the first 8 bytes in Btag to 2 Byte Character data.

      DO 100 I = 1, 8

         J = 2*I -1

        Bdat(J:J) = Btag(I:I)

 100  CONTINUE

c

c     Copy the second 8 bytes in Btag to the latter half of Bdat.

      Bdat(17:24) = Btag(09:16)

C     Mask out the Channel Number.

      Bdat(22:22) = CHAR(0)

C     Get the Tag size.

      Blen = 16 

      IF (Btag(14:14) .NE. CHAR(0)) Blen = 32

C     Mask out the Channel Saturation identifier.

      Bdat(24:24) = CHAR(0)

C     Get the Channel Saturation ID.

      Bdat(25:25) = Btag(16:16)

      Bdat(26:26) = CHAR(0)

C

c     Td1:Sec  Td2:Min Td3:Hrs Td4:Mdy Td5:Mth Td6:yy Td7:Wdy Td8:Cnt

c                        19    98    05    15          14    35    55

      WRITE(Tmdat,900) Td(8),Td(6),Td(5),Td(4),' - ',Td(3),Td(2),Td(1)

c     READ the Character string as 2 byte Integers.

      Sec  = Td(1)

      Min  = Td(2)

      Hou  = Td(3)

      Snum = Td(09)

      Scan = Td(10)

      Chan = Td(11)

      Stus = Td(12)

      Sid  = Td(13)

C

      WRITE(R1tag,800) Tmdat,Snum,Scan,Chan,Blen,Stus,Sid

 800  FORMAT(A22,4H SN:,I4.4,4H SC:,I4.4,4H CH:,I2.2,

     &           4H TG:,I2.2,4H ST:,I2.2,4H SA:,Z2)

C

 900  FORMAT (1x,2I2.2,1H/,I2.2,1H/,I2.2,A3,I2.2,1H:,I2.2,1H:,I2.2,1H )

C

      RETURN

      END

c

C ------------------------- BCODE2 ------------------------------------

c

      SUBROUTINE Bcode2(B2tag,Scan,Chan,R1tag,R2tag)

c     SUBROUTINE Bcode2(Btag,Tmdat,Snum,Scan,Chan,Srat,Stus,Sid,Blen)

c

c     A Routine to Decode the B2tag in the *.tsn MTU-Files.

c D-T  1 - 8 bytes UTC time [ss mn hr dy mt yy dw ct] (1 byte each).

c Snum 9 -10 bytes Serial Number

c Scan 11-12 bytes Scans of data in the record

c Chan 13 byte  Number of channels

c Blen 14 byte  0 for 16 byte TAG or 32 for 32 byte TAG

c Stus 15 byte  Status 0:Normal 3:Saturation 4:Internal error 6:Time out

c Sflg 16 byte  Saturation Flag:bit 0 for Chan1, bit 1 for Chan2, etc.

c ---------------------------------------------------------------------

c Ftag 17 byte  0 Reserved for future use to indentify TAG formats

c Sbyt 18 byte  3 Sample length in bytes  

c Srat 19-20 bytes Sample Rate in units specified by byte 20

c Sunt 21 byte  0:Hz (Cycle/Sec) 1:Cyc/Min 2:Cyc/hr 3:Cyc/day

c Clks 22 byte Clock Status[0:N/A 1:CPU RTC 2:GPS 3:XTAL 4:UTC(GPS lock)]

c Cerr 23-26 bytes Clock Error TERR: uSec [- early, + late) Normally 0.

c Resv 27-32 bytes Must be 0.   Reserved for future.

c ---------------------------------------------------------------------

      

      implicit integer*2 (i-n)



      CHARACTER    B2tag*32,Tmdat*24, R1tag*62, R2tag*70

      CHARACTER    Null*1, Bdat*36, Chsat*12, Cunit*8, Clkerr*4

c     INTEGER*2    Sec,Min,Hrs,Day,Mth,Yer,Wkd,Cnt

      INTEGER*2    Td(18),Snum,Scan,Chan,Srat,Stus

      INTEGER*2    I,J, B, Sid, Blen, Sbyt, Sunt, Clst

      INTEGER*4    Cerr, Terr

      EQUIVALENCE  (Bdat,Td), (Clkerr,Cerr)

c

      Null = CHAR(0)

      DO 5 I = 1, 36

         Bdat(I:I) = Null

  5   CONTINUE                  

c

c     Expand the first 8 bytes in B2tag to 2 Byte Character data.

      DO 100 I = 1, 8

         J = 2*I -1

        Bdat(J:J) = B2tag(I:I)

 100  CONTINUE

C

c     Copy two bytes in Btag for Snum to next part of Bdat.

      Bdat(17:18) = B2tag(09:10)

c     Copy two bytes in Btag for Scan to next part of Bdat.

      Bdat(19:20) = B2tag(11:12)

c     Copy 0ne byte in Btag for Nchan to next part of Bdat.

      Bdat(21:21) = B2tag(13:13)

c     Copy 0ne byte in Btag for Blen to next part of Bdat.

      Bdat(23:23) = B2tag(14:14)

c     Copy 0ne byte in Btag for Stus to next part of Bdat.

      Bdat(25:25) = B2tag(15:15)

c     Copy 0ne byte in Btag for Flag to next part of Bdat.

      Bdat(27:27) = B2tag(16:16)

c     Copy 0ne byte in Btag for Sbyt to next part of Bdat.

      Bdat(29:29) = B2tag(18:18)

c     Copy two bytes in Btag for Srate to next part of Bdat.

      Bdat(31:32) = B2tag(19:20)

c     Copy 0ne byte  in Btag for Sunit to next part of Bdat.

      Bdat(33:33) = B2tag(21:21)

c     Copy 0ne byte  in Btag for Clkst to next part of Bdat.

      Bdat(35:35) = B2tag(22:22)

c     Copy Four bytes in Btag for Clkerr to Character variable.

      Clkerr = B2tag(23:26)

C

c              111111111122222222223333333

C --- 123456789012345678901234567890123456

C --- ScMnHrDdMmYyWdCtSnScChTgStSfSbSrSuCk

C ---                    1 1 1 1 1 1 1 1 1

C -Td- 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8

c

c     Td1:Sec  Td2:Min Td3:Hrs Td4:Mdy Td5:Mth Td6:yy Td7:Wdy Td8:Cnt

c                        20    02    09    11          14    35    55

      WRITE(Tmdat,900) Td(8),Td(6),Td(5),Td(4),' - ',Td(3),Td(2),Td(1)

 900  FORMAT (1x,2I2.2,1H/,I2.2,1H/,I2.2,A3,I2.2,1H:,I2.2,1H:,I2.2,1H )

c     READ the Character string as 2 byte Integers.

      Snum = Td(09)

      Scan = Td(10)

      Chan = Td(11)

      Blen = Td(12)

      Stus = Td(13)

      Sid  = Td(14)

C

      Chsat(1:12) = ' 0 0 0 0 0  '

      IF (Stus .EQ. 3) THEN

        Chsat(1:12) = '            '

C       Mask the bits for Channel Sats. Chsat = ' 1 2 3 4 5 6'

        DO 600 J=1,6

          I = 6-J

          B = INT(Sid /2**I)

          Sid = Sid - (B * 2**I)

          IF (B.GE.1) Chsat(2*(I+1):2*(I+1)) = CHAR(49+I)

 600    CONTINUE 

      ENDIF

c

      IF (B2tag(14:14) .EQ. CHAR(0)) THEN

        Blen = 16

        Srat = Scan

        Sunt = 0 

        Clst = 0

        Terr = 0

      ELSE

        Blen = 32

        Sbyt = Td(15)

        Srat = Td(16)

        Sunt = Td(17)

        Clst = Td(18)

        Terr = Cerr

      ENDIF

C

        IF (Sunt.EQ.0) Cunit = "Cyc/Sec."

        IF (Sunt.EQ.1) Cunit = "Cyc/Min."

        IF (Sunt.EQ.2) Cunit = "Cyc/Hr. "

        IF (Sunt.EQ.3) Cunit = "Cyc/Day "

C

      WRITE(R1tag,800) Tmdat,Snum,Scan,Chan,Blen,Stus,Sid

 800  FORMAT(A22,4H SN:,I4.4,4H SC:,I4.4,4H CH:,I2.2,

     &           4H TG:,I2.2,4H ST:,I2.2,4H SA:,Z2)

C

      WRITE(R2tag,850) Chsat,Sbyt,Srat,Cunit,Clst,Terr   

 850  FORMAT(4X,9H Ch Flag:,A12,4H BY:,I1.1,4H SR:,I5.5,

     &       1X,A8, 4H CK:,I1.1,4H TE:,I10.10,3HuS.)           

C

      RETURN

      END

C

C--------------------------- GETtsr -----------------------------------

C

      SUBROUTINE Gettsr(Ifile,Irec,Rtag,Scan,Chan,Bsize,I4data,Ierr)

      

      implicit integer*2 (i-n)



      include 'ctrlblk.inc'

	        

      INTEGER*2     Ifile, Scan, Chan, Bsize

      INTEGER*2     Ierr, I, K, Ch

      INTEGER*4     Irec, I4data(1:3072,1:5)

      CHARACTER*64  Rtag, Dummy*3

      CHARACTER*4   C4data(1:5,1:1024)

      INTEGER*4     E4data(1:5,1:1024)



      EQUIVALENCE  (E4data,C4data)



          IF (Bsize .EQ. 2) THEN

            READ(Ifile,REC=Irec,ERR=999) Dummy,Rtag,

     &      Dummy,( ( C4data(K,I)(3:3), C4data(K,I)(4:4),

     &                        I = 1,Scan ), K = 1,Chan)



            DO 295  Ch = 1, Chan

              DO 294 I=1, Scan

                  I4data(I,Ch) = E4data(Ch,I) /256 /256

 294          CONTINUE

 295        CONTINUE

         ELSE

            READ(Ifile,REC=Irec,ERR=999) Dummy,Rtag,

     &      Dummy,( ( C4data(K,I)(2:2), C4data(K,I)(3:3),

     &                C4data(K,I)(4:4),I = 1,Scan ), K = 1,Chan )

c

            DO 297  Ch = 1, Chan

              DO 296 I=1, Scan

                  I4data(I,Ch) = E4data(Ch,I) /256

 296          CONTINUE

 297        CONTINUE

         ENDIF

c

      Ierr=0

      RETURN

 999  Ierr=-1

      END

