#!/bin/csh  -f
#
#  lims_select
#
#  selects database & station
#

onintr exit

set old=$cwd

start:

set root = ''                       # Root for the station name
set lims_dir = `cat .lims.lims_dir`

if ($#argv == 2) then

  set dbase   = $1                        # Database name
  set stn     = $2                        # Station name
  set stn     = $dbase$stn                # Station name with project
  set stn_dir = $lims_dir$dbase'/'$stn    # Station directory
  goto write

else if ($#argv == 1) then

  set dbase  = $1       # Database name
  set ldbase_dir = $lims_dir$dbase
  cd $ldbase_dir
  goto station

endif

database:
  cd $lims_dir

  echo  ' ' 
  echo  '  DATABASES FOUND IN: '$lims_dir
  echo  ' '
  ls -xLF | grep '/'

  echo  ' ' 
  echo ' Enter Database Name'
database_select:
  echo ' '
  echo -n 'Database? ===> '$root
  set dbase=$<
  if( -e $dbase ) then
    echo 'Database selected =>'$dbase
    cd $old
  else
    echo 'Database not found; re-select'
    goto database_select
  endif


  set ldbase_dir = $lims_dir$dbase
  cd $ldbase_dir

  set wfile = 'windows.'$dbase
  set hfile = 'hardware.'$dbase

  if !( -e $wfile ) then
    echo 'Processing cannot proceed - create a windows file'
    goto exit
  endif

  if !( -e $hfile ) then
    echo 'Processing cannot proceed - create a hardware file'
    goto exit
  endif

#---check windows file
  echo 'Checking windows file ...'
  echo 'wcheck -1 <<END'       >  .lims_wcheck
  echo '-1'                    >> .lims_wcheck
  echo $dbase                  >> .lims_wcheck
  echo 'END'                   >> .lims_wcheck
  chmod +x .lims_wcheck
  .lims_wcheck
  rm .lims_wcheck

#---read station name in
station:

  echo ' '
  echo ' Enter Station Name (last 3 digits only)'
  echo '        - Hit <RETURN> For List Of Available Stations.'
  echo '        - Type "x" To Select Another Database.'
station_select:
  echo ' '
  echo -n 'Station? ===> '$root
  set stn=$<

  if($stn == "x") goto database

  if($stn == "") then

    echo  ' ' 
    echo  ' ' 
    echo  '  STATIONS FOUND IN: '$ldbase_dir
    echo  ' '
    ls -xd $dbase???
    goto station_select
  endif

  set stn=$dbase$stn

  if( -e $stn ) then
    echo 'Station selected =>'$stn
  else
    echo 'Station not found; re-select'
    goto station_select
  endif
  set stn_dir = $ldbase_dir'/'$stn


  echo ' '
  echo '>>> Time series files found in:  '$stn_dir
  echo ' '

  cd $stn_dir
  ls *.ts
  echo ' '
  grep $stn ../windows.$dbase

  echo ' '
  echo '>>> Cascade files found in:  '$stn_dir
  echo ' '

  cd $stn_dir
  ls *.cas

  echo ' '
  echo '>>> Response files found in:  '$stn_dir
  echo ' '

  cd $stn_dir
  ls *.dat
  echo ' '
  echo '>>> GB Decomposition files found in:  '$stn_dir
  echo ' '

  cd $stn_dir
  ls *g.dat? *.g?

write:
  cd   $old
  echo $stn     > .lims.stn
  echo $stn_dir > .lims.stn_dir
  echo $dbase   > .lims.dbase




exit:
  cd $old
