#!/bin/csh  -f
#
#  lims_splice
#
#  splices data from a station
#

onintr exit

set old=$cwd

if ( $#argv == 1 ) then
  set back = y
else
  set back = n
endif



start:

set root = ` `

set stn      = `cat .lims.stn`
set dbase    = `cat .lims.dbase`
set stn_dir  = `cat .lims.stn_dir`
set lims_dir = `cat .lims.lims_dir`

cd $lims_dir$dbase

  rm .lims.tsfiles > /dev/null

  echo  ' ' 
  echo  '  WINDOW FILES FOUND IN: '$stn_dir
  echo  ' '
  set tsfiles = ($stn/$stn*.ts)
  foreach tsfile ( $tsfiles )
     set base = `basename $tsfile`
     echo $base
     echo $base  >> .lims.tsfiles
  end 
  echo -n 'Splice all these files into a single file (y/n) ? =>'$root
  set ans=$<
  if( $ans != y ) then
    goto exit
  endif
  set nts = `wc -l .lims.tsfiles  | awk '{print $1}'`

if( $back == y ) then
  echo 'splice > .lims.splice.out <<END'   > .lims_splice
else
  echo 'splice  <<END1'   > .lims_splice
endif
  echo $nts                      >> .lims_splice   #no of tsfiles
  cat .lims.tsfiles              >> .lims_splice   #all .ts files
  echo 'END1'                    >> .lims_splice   #END
  echo 'windowtime  <<END2'      >> .lims_splice   #run windowtime
  echo '-1'                      >> .lims_splice   #no print to screen
  echo $stn'as.ts'              >> .lims_splice   #no print to screen
  echo 'T'                       >> .lims_splice   #add to windows file
  echo 'END2'                    >> .lims_splice   #END
 

  chmod +x .lims_splice
  if( $back == y ) then
    echo ' Backgrounding lims_splice script file'
    .lims_splice &
  else
    .lims_splice
  endif

exit:
  cd $old

