#!/bin/csh  -f
#
#  lims_woverlap
#
#  derives overlaps for remote-referencing
#

onintr exit

set old=$cwd

set scripts_dir = `cat .lims.scripts_dir`
set execs_dir   = `cat .lims.execs_dir`

start:
set root = ` `

set stn      = `cat .lims.stn`
set dbase    = `cat .lims.dbase`
set stn_dir  = `cat .lims.stn_dir`
set lims_dir = `cat .lims.lims_dir`

cd $stn_dir

if ($#argv == 1) then
  set window = $1
  goto remote
endif

window:
  echo  ' ' 
  echo  '  WINDOWS FOUND IN: '$stn_dir
  echo  ' '
  ls *.ts
  set nwind = `ls -1 *.ts | wc -l`

  if( $nwind == 0 ) then
    echo 'No windows found...'
    goto exit
  else if( $nwind == 1 ) then
    set window = `ls *.ts | cut -c7-8`
  else
    echo  ' ' 
    echo ' Enter Run number & Window (no extension) (e.g. a1) '
window_select:
    echo ' '
    echo -n 'Window? ===> '$root
    set window=$<
  endif

  set window=$stn$window
  set tmp=$window'.ts'

  if( -e $tmp ) then
    echo 'Window selected =>'$window'.ts'
  else
    echo 'Window not found; re-select'
    goto window_select
  endif
  
remote:
  cd $lims_dir$dbase
  echo ' '
  echo 'Determining possible remote-reference windows'
  echo $execs_dir'/woverlap -1 <<END >.lims.remote'         > .lims_limscas7
  echo '-1'                                                 >> .lims_limscas7
  echo $window                                              >> .lims_limscas7
  echo 'T'                                                  >> .lims_limscas7
  echo 'F'                                                  >> .lims_limscas7
  echo 'END'                                                >> .lims_limscas7
  chmod +x .lims_limscas7
  .lims_limscas7
  sort +4 .lims.remote

exit:
  cd $old
