c  ts2birpp: v1.0: 10 December 2001
c
c  converts a ts file into a Chave birrp input file (based on ts2chave)
c  writes out the data files and also the birrp command input file and
c  a header file carried forward for c2j
c
c-------------------------------------------------------------------------------

      implicit none

c-------------------------------------------------------------------------------

      include 'version.inc'
      include 'ctrlblk.inc' 
      include 'io.inc' 
      include 'infoblk.inc'
      include 'bdate.inc'
      include 'defaults.inc'

c-------------------------------------------------------------------------------

      integer MAXWINDOW
      parameter ( MAXWINDOW = 10 )
      integer MAXREFSITES
      parameter ( MAXREFSITES = 15 )
      integer MAXB
      parameter (MAXB=30000)

c-------------------------------------------------------------------------------

      integer ib, nblock

      integer narg, getnarg
      integer nwindow, iw, nptw(MAXWINDOW)

      integer npt, iunit, nchanout

      integer i, j
      integer nmax
      integer yy, mm, dd, hh, min, ss, dday, dhour, dmin, dsec, tsec
      integer nent
      integer nchan, nchan1, nchanr(MAXREFSITES)
      integer nskip
      integer instr1, instrr(MAXREFSITES)
      integer indr(MAXREFSITES)
      integer irem, nremote

      integer azimex, azimey, azimhx, azimhy
      integer azimrx(MAXREFSITES), azimry(MAXREFSITES)
      integer azimuth
      integer dec, decl, decr(MAXREFSITES), tdiff, sdur


      real a(MAXB,5+2*MAXREFSITES)

      real dat(5), datr1(5), datr(MAXREFSITES,5)
      real delta1, deltar(MAXREFSITES)
      real totn
      real ex, ey, hx, hy, hz, rx(MAXREFSITES), ry(MAXREFSITES)
      real exl, eyl, hxl, hyl, hzl, rxl(MAXREFSITES), ryl(MAXREFSITES)

      real angex, angey, anghx, angrx(MAXREFSITES)
      real declin1, declinr(MAXREFSITES)

      real lat1, long1, elev1
      real latr(MAXREFSITES), longr(MAXREFSITES), elevr(MAXREFSITES)
      real azim1(5), azimr(MAXREFSITES,5)


      character*30 prompt
      character*40 outfile(5+2*MAXREFSITES), fout
      character title*20, line*80
      character*40 indat1, indatr(MAXREFSITES)
      character proj*3, sep*1 
      character*10 dur
      character*5 tunits1, tunitsr(MAXREFSITES)
      character*8 tswindow(MAXWINDOW),  
     &            tswindowr(MAXREFSITES, MAXWINDOW)
      character*6 stat, statr(MAXREFSITES), stattmp
      character*19 stime(MAXWINDOW), etime(MAXWINDOW), 
     &             stime1, etime1, 
     &             stimer(MAXREFSITES,MAXWINDOW), 
     &             etimer(MAXREFSITES,MAXWINDOW)
      character*10 cmdarg
      character*1 mt, reply
      character*17 azdir1, azdirr(MAXREFSITES)
      character*6  form1, formr(MAXREFSITES)
      character*15 format1, formatr(MAXREFSITES)
      character*24 date_string

      logical HSG, AZIMSET
      logical QROTANG, QDECLIN, QPROTYP
      logical RR, MULTI
      logical FORMAT_OUTPUT, WRITE_DATA, T_FILTER

      integer*4 idate

c...functions

      integer lnblnk
      integer datchk
      integer*4 iconvdate

c...externals

      external date

c-------------------------------------------------------------------------------
c...get date
 
      call fdate(date_string)

c-------------------------------------------------------------------------------

      iprint = 0
      dec = 0
      mt = 'M'

      QPROTYP = .TRUE.
      QROTANG = .TRUE.

c-------------------------------------------------------------------------------
c...initialize variables and arrays.

      call dirsep(sep)

c-------------------------------------------------------------------------------
c...get command-line arguments

      narg = getnarg()
      do i = 1, narg
        call getcmdarg( i, cmdarg)
        if( index(cmdarg,'h').ne.0 ) then
          write(*,*)'Permitted options:-'
          write(*,*)'                    -1 -> 3  iprint level'
          stop
        else
          read(cmdarg,'(i2)') iprint
        endif
      enddo

      call iin( 'Give print level (-1/0/1/2/3)', iprint)
      
      if( iprint.ge.1 ) call banner( 'TS2BIRRP' )

c-------------------------------------------------------------------------------
c     Check for configuration file. If doesn't exist then create it and write
c     default values into it.

      open(unit=ind4, file='process.cfg', status='old', err=101)
      if( iprint.ge.0 ) then
        write(*,*)'Opened processing configuration file process.cfg'
      endif
      goto 102

101   write(*,*)'File process.cfg not found: Create one using tscascade'
      stop

102   do 103 while( .TRUE. )
        read(ind4,'(a)',end=104) line
        if( iprint.ge.3 ) then
          write(*,*)'Line>', line(1:lnblnk(line))
        endif

        if( line(1:6).eq.'ROTANG' ) then
          read(line(8:),*) azimuth
          QROTANG = .FALSE.
          AZIMSET = .TRUE.
          if( iprint.ge.1 ) then
            write(*,*)'ROTANG found with value :', azimuth
          endif
 
        elseif( line(1:6).eq.'PROTYP' ) then
          line = line(8:)
          if( index(line,'MT').ne.0 ) then
            mt  = 'M'
            HSG = .FALSE.
          else if( index(line,'GDS').ne.0 ) then
            mt  = 'G'
            HSG = .FALSE.
          else if( index(line,'HSG').ne.0 ) then
            HSG = .TRUE.
          else
            write(*,*)'Unrecognized processing type =', line(1:5)
            write(*,*)'Edit process.cfg file and re-run'
            stop
          endif
          QPROTYP = .FALSE.
          if( iprint.ge.1 ) then
            write(*,*)'PROTYP found with value :', line(1:5)
          endif

        endif

103   continue

104   if( iprint.ge.0 ) then
        write(*,*)'Read in parameters from process.cfg file'
      endif
      close(unit=ind4)
      

c-------------------------------------------------------------------------------
c...write banner

      call banner( 'TS2BIRRP' )

c-------------------------------------------------------------------------------

1     nremote = 1
      call iin('Give number of remote sites (0, 1, ...)', 
     &          nremote )
      if( nremote.eq.0 ) then
        RR    = .FALSE.
        MULTI = .FALSE.
      elseif( nremote.eq.1 ) then
        RR    = .TRUE.
        MULTI = .FALSE.
      elseif( nremote.gt.1 ) then
        RR    = .TRUE.
        MULTI = .TRUE.
      endif

 
2     if( QPROTYP ) then
        call tin( 'MT, GDS or HSG processing', mt )
        call shiftup( mt )
        if( mt.eq.'H' ) then
          HSG = .TRUE.
          indat1 = 'hs2hsgxf'
        else if( mt.eq.'G' ) then
          HSG = .FALSE.
        else if( mt.eq.'M' ) then
          HSG = .FALSE.
        else
          write(*,*)'Erroneous input, M, G or H only please'
          goto 2
        endif
      endif

      T_FILTER = .TRUE.
      call lin('30,000 s highpass telluric filters used?', T_FILTER )

c-------------------------------------------------------------------------------
c...get number of windows to use

c...SET TO "1" FOR THIS VERSION - VALUES >1 NOT TESTED
      nwindow = 1
c      call iin( 'Give number of windows', nwindow )

c-------------------------------------------------------------------------------
c...loop around for each window


c...read in the name of the input data file 

      tswindow(1) = 'tbt101ss'

      iw = 1
c      do 1000 iw = 1, nwindow

300   call tin( 'Give window (extension assumed)', tswindow(iw) )

      proj = tswindow(iw)(1:3)
      stat = tswindow(iw)(1:6)
      title(1:12) = tswindow(iw)

      if( iprint.ge.1 ) write(*,*)'Station =>', stat

      do irem = 1, nremote
        tswindowr(irem, iw) = tswindow(iw)
        line = 'Give remote-reference window xx (no extension)'
        write(line(30:31),'(i2.2)') irem
        call tin( line(1:lnblnk(line)), tswindowr(irem, iw) )
        title(9:20) = ' +'//tswindowr(irem,iw)
        statr(irem) = tswindowr(irem,iw)(1:6)
      enddo

      if( iprint.ge.1 ) then
        write(*,*)'Data files to open ==>'
        write(*,*)' file01 =>', tswindow(iw)
        do irem = 1, nremote
          line = ' file00 =>'//tswindowr(irem,iw)
          write(line(6:7),'(i2.2)') irem
          write(*,*)line
        enddo
      endif


c-------------------------------------------------------------------------------
c...open the output data files

      if( iw.eq.1 ) then
        reply = 'b'
        FORMAT_OUTPUT = .FALSE.
        call tin('Output files ASCII (a) or BINARY (b)?', reply)
        if(reply.eq.'a') then
          FORMAT_OUTPUT = .TRUE.
        else
          nblock=30000
          prompt='Blocking factor (max=xxxxxx)?'
          write(prompt(22:27),'(i6)')MAXB
          call iin(prompt, nblock)
          if(nblock.gt.30000)then
            write(*,*)' Factor too high, set to MAXB=',MAXB
            nblock=MAXB
          endif
        endif
      endif
      outfile(1)=stat//sep//tswindow(iw)//'.ex'
      outfile(2)=stat//sep//tswindow(iw)//'.ey'
      outfile(3)=stat//sep//tswindow(iw)//'.hx'
      outfile(4)=stat//sep//tswindow(iw)//'.hy'
      outfile(5)=stat//sep//tswindow(iw)//'.hz'
      nchanout = 5

      do irem = 1, nremote
        outfile(5+2*irem-1)=stat//sep//tswindowr(irem,iw)//'.rx'
        outfile(5+2*irem  )=stat//sep//tswindowr(irem,iw)//'.ry'
        nchanout = nchanout + 2
      enddo

      do i = 1, nchanout
         iunit = 50 + i
         write(*,*)' Writing unit ', iunit, '  file = ', outfile(i)
         if(FORMAT_OUTPUT) then
            open(iunit,file=outfile(i),status='unknown')
         else
            open(iunit,file=outfile(i),status='unknown',
     &           form='unformatted')
         endif
      enddo

c-------------------------------------------------------------------------------
c...open data files and read in the window and header file information.

      form = '?'
      write(*,*)'Opening local    data file ==>', tswindow(iw)
      call ts_open( ind1, tswindow(iw), indat1, .FALSE., .FALSE. )
      write(*,*)'Opened local    data file on unit', ind1,' ==>',
     &           indat1(1:lnblnk(indat1))
      call ts_rdinfo(ind1)

c..format common
      form1   = form
      format1 = format

c..ts_stat common
      stattmp = stat

c..ts_pos common
      lat1  = lat
      long1 = long
      elev1 = elev

c..ts_data common
      if( tunits.eq.'s' ) delta = 1./delta
      delta1  = delta
      tunits1 = tunits
      nchan1  = nchan

c..ts_azim common
      do i = 1, 5
        azim1(i) = azim(i)
      enddo
      azimhx = azim(1)
      azimhy = azim(2)
      azimex = azim(4)
      azimey = azim(5)
      azdir1 = azdir
      declin1 = declination

c..ts_start common
      stime1 = starttime

c...ts_end common
      etime1 = endtime



c...open RR files
      do irem = 1, nremote 
        form = '?'
        indr(irem) = 10+irem
        write(*,*)'Opening remote data file ==>', tswindowr(irem,iw)
        call ts_open( indr(irem), tswindowr(irem,iw), indatr(irem), 
     &                .FALSE., .FALSE. )
        write(*,*)'Opened remote data file on unit', indr(irem),' ==>',
     &             indatr(irem)
        call ts_rdinfo(indr(irem))

c..format common
        formr(irem)   = form
        formatr(irem) = format

c..ts_stat common
        statr(irem) = stat
        stat        = stattmp

c..ts_pos common
        latr(irem)  = lat
        longr(irem) = long
        elevr(irem) = elev

c..ts_data common
        if( tunits.eq.'s' ) delta = 1./delta
        if(delta.ne.delta1) then
          write(*,*) 'Sampling rates differ between local and ',
     >               'remote data files.'
          stop
        endif
        deltar(irem)  = delta
        tunitsr(irem) = tunits
        nchanr(irem)  = nchan

c..ts_azim common
        do i = 1, 5
          azimr(irem,i) = azim(i)
        enddo
        azimrx(irem) = azim(1)
        azimry(irem) = azim(2)
        azdirr(irem) = azdir
        declinr(irem) = declination

c..ts_start common
        stimer(irem,iw) = starttime
c..ts_end common
        etimer(irem,iw) = endtime

      enddo


      nchan = nchan1

      goto 320
  310 write (*,*)' Error opening DATA INPUT file, re-enter.'
      goto 300
  320 continue


c-------------------------------------------------------------------------------
c...get instrument number(s) from the windows file

      fout = 'windows.'//proj
      goto 405
  400 call tin (' Give the project windows file', fout )
  405 open ( ind4, file=fout, status='old', form='formatted', err=410 )
      go to 420
  410 write (*,*) ' ts2birrp: Error opening WINDOWS file, re-enter'
      go to 400
  420 continue


      call getwindow( ind4, tswindow(iw), instr1, nchan1, 
     &                stime1, etime1 )
      if( instr1.eq.-9999 ) then
        write(*,*)'Window not found in windows.'//proj//' file: '//
     &            'Using times in ts file'
        stime1 = starttime
        etime1 = endtime
      endif
      if( iprint.ge.1 ) then
        write(*,*)' window start and end times: ', stime1,'-',etime1
      endif
      sdur = tdiff( stime1, etime1 )
      do irem = 1, nremote
        rewind( ind4 )
        call getwindow(ind4, tswindowr(irem,iw), instrr(irem), 
     &                 nchanr(irem), stimer(irem,iw), etimer(irem,iw))
        if( instrr(irem).eq.-9999 ) then
          write(*,*)'Window not found in windows.'//proj//' file: '//
     &              'Using times in ts file'
        endif
c...pick off only 2 channels from remote sites
        nchanr(irem) = 2
      enddo
      close(unit=ind4)


c-------------------------------------------------------------------------------

      if( nchan1.eq.3 ) then
        if( mt.eq.'M' ) then
          write(*,*)'>>>>>Only 3 channels found: GDS processing to',
     &              ' be undertaken'
          mt = 'G'
        endif
      else if( nchan1.eq.4 ) then
        if( iprint.ge.1 ) write(*,*)'4 channels found'
      else if( nchan1.eq.5 ) then
        if( iprint.ge.1 ) write(*,*)'5 channels found'
      else
        write(*,*)'Weird number of channels; not 3 or 4 or 5 -- ',
     &            'don''''t know what to do now!'
        stop
      endif
c
c---nchan = total number of channels recorded on the data file.
c   delta is the sampling rate in Hz
c
      if( iprint.ge.1 ) then
        write(*,*) 'Sampling rate in Hz =', delta 
      end if

c...find latest start time from all 
  900 if( iprint.ge.0 ) then
        write(*,'(2a)') 'Give the required event start time >',
     &            'yyyy-mm-dd hh:mn:ss'
      endif
      stime(iw) = stime1
      idate = iconvdate( stime1 )
      do irem = 1, nremote
        if( idate.lt.iconvdate(stimer(irem,iw)) ) then
          stime(iw) = stimer(irem,iw)
          idate = iconvdate(stimer(irem,iw))
        endif
      enddo
      call tin ( ' ', stime(iw) )
      if( datchk( stime(iw) ).ne.0 ) goto 900

c...find earliest end time
905   if( iprint.ge.0 ) then
        write(*,'(2a)') 'Give the required event end   time >',
     &            'yyyy-mm-dd hh:mn:ss'
      endif
      etime(iw) = etime1
      idate = iconvdate( etime1 )
      do irem = 1, nremote
        if( idate.gt.iconvdate(etimer(irem,iw)) ) then
          etime(iw) = etimer(irem,iw)
          idate = iconvdate(etimer(irem,iw))
        endif
      enddo
      call tin ( ' ', etime(iw) )
      if( datchk( etime(iw) ).ne.0 ) goto 905


c...write out times
      write(*,'(a)')'Start and end times.....'
      write(*,'(4a)')'Overlap   = ', stime(iw), ' - ', etime(iw)
      write(*,'(4a)')'Local     = ', stime1,    ' - ', etime1
      do irem = 1, nremote
        write(*,'(a,i2.2,4a)')'Remote ',irem,' = ', 
     &            stimer(irem,iw),    ' - ',  etimer(irem,iw)
      enddo


      call date( 0, stime(iw), yy, mm, dd, hh, min, ss )


c...sdur is the duration in seconds from the start time to the end
      sdur = tdiff( stime(iw), etime(iw) )
      
c...check whether sdur is negative
      if( sdur.le.0 ) then
        write(*,*)'No overlap between the local site and all remotes'
        stop 'Program ended'
      endif

      dday  =  sdur/(60*60*24)
      dhour =  mod(sdur,60*60*24)/(60*60)
      dmin  =  mod(sdur,60*60)/60
      dsec  =  mod(sdur,60)

      if( iprint.ge.0 ) then
        write( dur, '(i4.4,a1,i2.2,a1,i2.2)') 
     &           dday, '/', dhour, '/', dmin
        write( *, '(2a)') 'Duration (dddd/hh/mm) : ', dur
      end if

      if(dday.eq.0 .and. dhour.eq.0 .and. dmin.eq.0 .and. dsec.eq.0)then
        dday  =  sdur/(60*60*24)
        dhour =  mod(sdur,60*60*24)/(60*60)
        dmin  =  mod(sdur,60*60)/60
        dsec  =  mod(sdur,60)
      endif


c...calculate the total number of seconds of data to be analysed.

      tsec = dday*86400 + dhour*3600 + dmin*60 + dsec

c...totn is the total number of entries required for analysis.
c
      totn =  float(tsec) * delta 
      nmax = ifix(totn)

      write(*,*) 'Total number of data requested:', nmax

c-------------------------------------------------------------------------------
c     write out co-ordinates and request direction for rotation

 
      write(*,*)'Co-ordinates of acquisition ==>'
      write(*,*)'Hx  =', azimhx, '  Ex =', azimex,
     &     '  Ey =', azimey, '  Coord sys: ', azdir1,
     &     'decl  =', declin1
      do irem = 1, nremote
        write(*,*)'Rx  =', azimrx(irem), 
     &            '                     Coord sys: ', azdirr(irem),
     &            'decr  =', declinr(irem)
      enddo


c...get declination if site in magnetic co-ordinates and not read in
c   from time series
      if( QDECLIN .and. declin1.eq.-999. ) then
        if( index(azdir1, 'MAGNETIC').ne.0 ) then
          call iin( 'Give declination', dec )
        endif
      else
       decl = nint( declin1 )
      endif

      do irem = 1, nremote
        if( index(azdirr(irem), 'MAGNETIC').ne.0 ) then
          if( declinr(irem).ne.-999. ) then
            decr(irem) = nint( declinr(irem) )
          else
            decr(irem) = dec
          endif
        else
          decr(irem) = 0
        endif
      enddo

c...request co-ordinate system
      if( QROTANG ) then
        if( .NOT.AZIMSET ) azimuth = 0
        call iin( 'Desired co-ordinate system in TRUE NORTH', azimuth)
      endif

c...rotation angles required
      anghx  = float( azimuth - (azimhx + decl) )
      angex  = float( azimuth - (azimex + decl) )
      angey  = float( azimuth - (azimey + decl) + 90 )
      do irem = 1, nremote
        angrx(irem) = float( azimuth - (azimrx(irem) + decr(irem)) )
      enddo

      write(*,*)'Rotation angles to be applied for azimuth ==>', 
     &                         azimuth
      write(*,*)'Ex  =', angex
      write(*,*)'Ey  =', angey
      write(*,*)'Hx  =', anghx
      do irem = 1, nremote
        write(*,*)'Rx  =', angrx(irem)
      enddo

c-------------------------------------------------------------------------------
c....skip data for data start times < stime


      if( stime1.lt.stime(iw) ) then
        nskip = tdiff( stime1, stime(iw) ) * delta
        write(*,*)'Skipping', nskip, '  data for local  file'
          form   = form1
          format = format1
        call ts_skip( ind1, nskip )
        if( nskip.lt.0 ) then
          write(*,*)'EOF reached for local file'
          stop
        endif
      endif

      do irem = 1, nremote
        if( stimer(irem,iw).lt.stime(iw) ) then
          nskip = tdiff( stimer(irem,iw), stime(iw) ) * delta
          write(*,*)'Skipping', nskip, '  data for remote file', irem
          form   = formr(irem)
          format = formatr(irem)
          call ts_skip( indr(irem), nskip )
          if( nskip.lt.0 ) then
            write(*,*)'EOF reached for remote-1 file'
            stop
          endif
        endif
      enddo


c-------------------------------------------------------------------------------

      npt = 0

7     continue

c...read in data from local site 
      nchan = nchan1
      form  = form1
      format = format1
      call ts_in1(ind1, dat)
      if( dat(1).eq.EOF ) then
        write(*,*)'EOF found on local file'
        goto 30
      endif
      if( iprint.ge.3 ) then
        write(*,*) 'Input dat  =>', (dat(i),i=1,nchan1)
      endif

c...read in data from remote sites 
      do irem = 1, nremote
        nchan = nchanr(irem)
        form  = formr(irem)
        format = formatr(irem)
        call ts_in1(indr(irem), datr1)
        if( datr1(1).eq.EOF ) then
          write(*,*)'EOF found on remote-1 file'
          goto 30
        endif
        do i = 1, 2
          datr(irem,i) = datr1(i)
        enddo
        if( iprint.ge.3 ) then
          write(*,*) 'Input datr =>', (datr(irem,i),i=1,2)
        endif
      enddo


      if ( nent .lt. 0 ) then
        if ( npt.gt.32 ) go to 30
        write(*, '(a)')' No data found. Program ending.'
        go to 9999
      end if


c
c      Channel     LIMS        Cascade      Jones       HSG
c         1         Hx           Ex           Hx         Gx
c         2         Hy           Ey           Hy         Gy
c         3         Hz           Hx           Ex
c         4         Ex           Hy           Ey
c         5         Ey           Hz           Hz         Hz
c         6         Rx           Rx           Rx         Rx
c         7         Ry           Ry           Ry         Ry
c

c...assign data input
      hx = dat(1)
      hy = dat(2)
      if( nchan1.eq.3 .or. nchan1.eq.5 ) then
        hz = dat(3)
        ex = dat(4)
        ey = dat(5)
      else if( nchan1.eq.4 ) then
        hz = 0.
        ex = dat(3)
        ey = dat(4)
      endif

      do irem = 1, nremote
        rx(irem) = datr(irem,1)
        ry(irem) = datr(irem,2)
      enddo


c...check not equal to misdat: if equal to misdat, set to last good value

      if( hx.gt.misdat*0.99999.and.hx.lt.misdat*1.00001) hx = hxl
      if( hy.gt.misdat*0.99999.and.hy.lt.misdat*1.00001) hy = hyl
      if( hz.gt.misdat*0.99999.and.hz.lt.misdat*1.00001) hz = hzl
      if( ex.gt.misdat*0.99999.and.ex.lt.misdat*1.00001) ex = exl
      if( ey.gt.misdat*0.99999.and.ey.lt.misdat*1.00001) ey = eyl
      do irem = 1, nremote
        if( rx(irem).gt.misdat*0.99999.and.
     &      rx(irem).lt.misdat*1.00001) rx(irem) = rxl(irem)
        if( ry(irem).gt.misdat*0.99999.and.
     &      ry(irem).lt.misdat*1.00001) ry(irem) = ryl(irem)
      enddo

      hxl  = hx
      hyl  = hy
      hzl  = hz
      exl  = ex
      eyl  = ey
      do irem = 1, nremote
       rxl(irem) = rx(irem)
       ryl(irem) = ry(irem)
      enddo


c...perform rotations (if required) in time domain

      if( iprint.ge.3 ) then
        write(*,*) 'Pre-rot  =>',hx,hy,ex,ey,
     &                (rx(irem),ry(irem),irem=1,nremote)
      endif

      if( anghx.ne.0. ) then
        call rotdat( hx, hy, anghx, anghx )
      endif

      if( angex.ne.0. .or. angey.ne.0. ) then
        call rotdat( ex, ey, angex, angey )
      endif

      do i = 1, nremote
        if( angrx(irem).ne.0. ) then
          call rotdat( rx(irem), ry(irem), angrx(irem), angrx(irem) )
        endif
      enddo


      if( iprint.ge.3 ) then
        write(*,*) 'Post-rot =>',hx,hy,ex,ey,
     &                (rx(irem),ry(irem),irem=1,nremote)
      endif


c...write data  out

      if(FORMAT_OUTPUT) then
         ib=1
      else
         ib=ib+1
         if(ib.eq.nblock) then
            WRITE_DATA = .TRUE.
         else
            WRITE_DATA = .FALSE.
         endif
      endif

      if( mt.eq.'M' ) then
        A(ib,1) = ex
        A(ib,2) = ey
      end if

      if( HSG ) then
        A(ib,3) = hx + hy
        A(ib,4) = hx + hy
        A(ib,5) = hz
      else
        A(ib,3) = hx
        A(ib,4) = hy
        A(ib,5) = hz
      endif

      do irem = 1, nremote
         A(ib,5+2*irem-1) = rx(irem)
         A(ib,5+2*irem  ) = ry(irem)
      enddo


      if( iprint.ge.3 ) then
        write(*,*) 'Points to write ==>'
        write(*,*)(a(ib,i),i=1,nchanout)
      end if

      if(FORMAT_OUTPUT) then
         do i = 1, nchanout
            iunit = 50 + i
            write(iunit,*) a(1,i)
         end do   
      else
         if(WRITE_DATA) then
            do i = 1, nchanout
               iunit = 50 + i
               write(iunit) (a(j,i),j=1,ib)
            enddo   
            ib=0
         endif
      endif
      NPT = NPT+1

      IF(NPT-NMAX) 7,9999,9999

9999  continue


c...flush data still in buffer: fill to end of block with zeroes
30    if( .not.FORMAT_OUTPUT .and. ib.gt.0 ) then
        do i = 1, nchanout
          iunit = 50 + i
          write(iunit) (a(j,i),j=1,ib), (0.0,j=ib+1,nblock)
        end do  
      endif

      write(*,*)' Number of points written: ', npt
      nptw(iw) = npt

1000  continue

c...end of "nwindow" loop
c-------------------------------------------------------------------------------
c...write out input file for use with Chave's code

      close(unit=7)
      open(unit=7,file=stat//'_birrp_in')
      write(*,'(2a)')'Opening file for input params to birrp: ',
     &               stat//'_birrp_in'

      write(7,'(a,t50,a)') '1','ILEV'           !1 advanced input mode
      write(7,'(a,t50,a)') '3','NOUT'           !3 outputs
      write(7,'(a,t50,a)') '2','NINP'           !2 inputs
      write(7,'(i2,t50,a)') 2*nremote,'NREF'    !n remote series
      if( nremote.gt.1 ) then
        write(7,'(2i3,t50,a)') 0, nremote,'NR3,NR2' !3-comp & 2-comp
      endif
      write(7,'(a,t50,a)') '1','NRR'            !1 2-stage robust method
      write(7,'(a,t50,a)') '0','NORM'           !1 L2 norm
      write(7,'(a,t50,a)') '1','TBW'            !1 prolate
      write(7,'(f,t50,a)') 1./delta1,'DELTAT'   !digitizing interval (s)
      write(7,'(a,t50,a)') '32768 2 12','NFFT,NSCTINC,NSCTMAX'
      write(7,'(a,t50,a)') '3 1 2','NF1,NFINC,NFSECT'
      write(7,'(a)') 'y'                   !yes
      write(7,'(a,t50,a)') '0. 0.0 .99999',
     &                      'UIN,AINLIN,AINUIN' !robust parameters
      write(7,'(a,t50,a)') '0.25','C2THRESHB'   !1st stage coh thresh
      write(7,'(a,t50,a)') '0.25','C2THRESHE'   !2nd stage coh thresh
      write(7,'(a,t50,a)') '0','NZ'             !Hz coh mode
      write(7,'(a,t50,a)') '0.25','C2THRESHE1'  !Hz coh thresh
      write(7,'(a,t50,a)') '20','NC2BLK'        !coh block size
      write(7,'(2f,t50,a)') 1.e5, 4/delta1,'PERLO,PERHI' !longest & shortest
      write(7,'(a)') stat//'/'//stat            !OFIL station - root name
      write(7,'(a,t50,a)') '0','NLEV'           !output level
      write(7,'(a,t50,a)') '0','NFREJ'          !no freq rej
      if( T_FILTER ) then
        write(7,'(a,t50,a)') '1','NFIL'         !1 filter param
      else
        write(7,'(a,t50,a)') '0','NFIL'         !1 filter param
      endif
      write(7,'(i2,t50,a)') nwindow,'NPCS'      !nwindow pieces
      write(7,'(a,t50,a)') '5','NAR'            !AR length
      if( FORMAT_OUTPUT ) then
        write(7,'(a,t50,a)') '0','IMODE'        !input mode
      else
        write(7,'(a,t50,a)') '1','IMODE'        !input mode
      endif

c...Ex
      if( .not.FORMAT_OUTPUT ) then
        write(7,*) nblock                       !blocking factor
      endif
      if(T_FILTER) write(7,*) delta/30000.      !low-pass filter
      do iw = 1, nwindow
        write(7,'(a)') stat//'/'//
     &               tswindow(iw)//'.ex'        !ex input file
        write(7,*) 0, nptw(iw)                  !nskip, nread
      enddo
c...Ey
      if( .not.FORMAT_OUTPUT ) then
        write(7,*) nblock                       !blocking factor
      endif
      if(T_FILTER) write(7,*) delta/30000.      !low-pass filter
      do iw = 1, nwindow
        write(7,'(a)') stat//'/'//
     &               tswindow(iw)//'.ey'        !ey input file
        write(7,*) 0, nptw(iw)                  !nskip, nread
      enddo

c...Hz
      if( .not.FORMAT_OUTPUT ) then
        write(7,*) nblock                     !blocking factor
      endif
      if(T_FILTER) write(7,*) 0.0             !low-pass filter
      do iw = 1, nwindow
        write(7,'(a)') stat//'/'//
     &               tswindow(iw)//'.hz'      !hz input file
        write(7,*) 0, nptw(iw)                !nskip, nread
      enddo

c...Hx
      if( .not.FORMAT_OUTPUT ) then
        write(7,*) nblock                     !blocking factor
      endif
      if(T_FILTER) write(7,*) 0.0             !low-pass filter
      do iw = 1, nwindow
        write(7,'(a)') stat//'/'//
     &               tswindow(iw)//'.hx'      !hx input file
        write(7,*) 0, nptw(iw)                !nskip, nread
      enddo

c...Hy
      if( .not.FORMAT_OUTPUT ) then
        write(7,*) nblock                     !blocking factor
      endif
      if(T_FILTER) write(7,*) 0.0             !low-pass filter
      do iw = 1, nwindow
        write(7,'(a)') stat//'/'//
     &               tswindow(iw)//'.hy'      !hy input file
        write(7,*) 0, nptw(iw)                !nskip, nread
      enddo

      do irem = 1, nremote
c...Rx
      if( .not.FORMAT_OUTPUT ) then
        write(7,*) nblock                     !blocking factor
      endif
      if(T_FILTER) write(7,*) 0.0             !low-pass filter
      do iw = 1, nwindow
        write(7,'(a)') stat//'/'//
     &                 tswindowr(irem,iw)//'.rx' !rx input file
        write(7,*) 0, nptw(iw)                  !nskip, nread
      enddo

c...Ry
      if( .not.FORMAT_OUTPUT ) then
        write(7,*) nblock                     !blocking factor
      endif
      if(T_FILTER) write(7,*) 0.0             !low-pass filter
      do iw = 1, nwindow
        write(7,'(a)') stat//'/'//
     &                 tswindowr(irem,iw)//'.ry' !ry input file
        write(7,*) 0, nptw(iw)                  !nskip, nread
      enddo

      enddo

      write(7,'(a)') '0 90 0'
      write(7,'(a)') '0 90 0'
      do irem = 1, nremote
        write(7,'(a)') '0 90 0'
      enddo
      close(unit=7)

c...write out header file to add to start of response file
      open(unit=7,file=stat//'/'//stat//'.blk')
      write(*,'(2a)')'Opening file for header blocks: ',
     &          stat//'/'//stat//'.blk'
      write(7,'(a)') '# ts2birrp9: ver='//ver
      write(7,'(a)') '# date: '//date_string
      write(7,'(a)') '#'
      write(7,'(a,i2)') '# no. of windows =', nwindow
      write(7,'(a)') '#'
      do iw = 1, nwindow
      write(7,'(a,i2)') '# window:', iw
      write(7,'(a)') '# tswindow   : '//tswindow(iw)
      do irem = 1, nremote
      write(7,'(a,i2.2,a)') '# tswindowr',irem,': '//tswindowr(irem,iw)
      enddo
      write(7,'(a)') '#'
      write(7,'(a)') '# window start :'//stime(iw)
      write(7,'(a)') '# window end   :'//etime(iw)
      write(7,'(a)') '#'
      enddo
      write(7,'(a,i3)' ) '# azimuth    : ', azimuth
      write(7,'(a)') '#'
      write(7,'(a,f7.1)' ) '# Ex rotation: ', angex
      write(7,'(a,f7.1)' ) '# Ey rotation: ', angey
      write(7,'(a,f7.1)' ) '# Hx rotation: ', anghx
      write(7,'(a,f7.1)' ) '# Hy rotation: ', anghx
      do irem = 1, nremote
        write(7,'(a,f7.1)' ) '# Rx  rotation: ', angrx(irem)
        write(7,'(a,f7.1)' ) '# Ry  rotation: ', angrx(irem)
      enddo
      write(7,'(a)') '#'
      write(7,'(a)') '# Acquisition coordinates: '
      write(7,'(a)') '#'
      write(7,'(a)')     '# Local site :'//tswindow(1)(1:6)
      write(7,'(2a)' )   '# coord_sys  : ', azdir1
      write(7,'(a,i3)' ) '# declination: ', decl
      write(7,'(a,i3)' ) '# Ex azimuth : ', azimex
      write(7,'(a,i3)' ) '# Ey azimuth : ', azimey
      write(7,'(a,i3)' ) '# Hx azimuth : ', azimhx
      write(7,'(a,i3)' ) '# Hy azimuth : ', azimhy
      do irem = 1, nremote
        write(7,'(a)')     '#'
        write(7,'(a)')     '# Remote site:'//statr(irem)
        write(7,'(2a)' )   '# coord_sys  : ', azdirr(irem)
        write(7,'(a,i3)' ) '# declination: ', decr(irem)
        write(7,'(a,i3)' ) '# Rx azimuth : ', azimrx(irem)
        write(7,'(a,i3)' ) '# Ry azimuth : ', azimry(irem)
      enddo
      write(7,'(a)') '#'

      write(7,'(a  )') '>STATION   ='//stat
      do irem = 1, nremote
        write(7,'(a  )') '>STATION_RR='//statr(irem)
      enddo
      write(7,'(a12,f12.1)') '>AZIMUTH   =', float(azimuth)
      write(7,'(a12,f12.4)') '>LATITUDE  =', lat1
      write(7,'(a12,f12.4)') '>LONGITUDE =', long1
      write(7,'(a12,f12.1)') '>ELEVATION =', elev1



      stop 'Done.'
      END
