c  ts2chave: v4.0: 21 March 1996
c
c  converts a ts file into a Chave input file

      implicit none

      include 'version.inc'
      include 'ctrlblk.inc' 
      include 'io.inc' 
      include 'infoblk.inc'
      include 'bdate.inc'

      integer MAXWINDOW
      parameter ( MAXWINDOW = 10 )


      integer ib, nblock, MAXB,j
      parameter (MAXB=30000)
      character*1 reply
      character*30 prompt
      logical format_data, write_data
      real a(MAXB,7)
      character*40 outfile(7)

      integer narg, getnarg, i, j, instr1, instr2
      integer nwindow, iw, nptw(MAXWINDOW)

      integer npt, iunit, nchanout
c
      real dat(5), dat2(5), delta1, delta2, totn
      real ex, ey, hx, hy, hz, rx, ry 
      real exl, eyl, hxl, hyl, hzl, rxl, ryl 
      integer in, out, ind, ind1, ind2, daterr, nmax
      integer yy, mm, dd, hh, min, ss, dday, dhour, dmin, dsec, tsec
      integer nent, nchan, nchan1, nchan2
      integer byy,  bmm,  bdd,  bhh,  bmin,  bss, inc
      integer byy1, bmm1, bdd1, bhh1, bmin1, bss1, inc1
      integer byy2, bmm2, bdd2, bhh2, bmin2, bss2, inc2
      integer nskip

      integer azimex, azimey, azimhx, azimhy, azimrx, azimry, azimuth
      integer dec, decl, decr, tdiff, sdur
      real angex, angey, anghx, angrx, declin1, declin2

      real lat1, long1, lat2, long2, elev1, elev2 
      real azim1(5), azim2(5)

      logical RR, HSG, AZIMSET
      logical QROTANG, QDECLIN, QPROTYP

      character title*20, fout*40, indat1*40, indat2*40, line*80
      character proj*3, sep*1 
      character*10 dur
      character*5 tunits1, tunits2
      character*8 tswindow(MAXWINDOW), tswindowrr(MAXWINDOW)
      character*6 stat, statrr, stattmp
      character*19 stime(MAXWINDOW), etime(MAXWINDOW), 
     &             stime1, etime1, stime2, etime2
      character*10 cmdarg
      character*1 ans, mt
      character azdir1*17, azdir2*17
      character*6 form1, form2
      character*15 format1, format2
      character*24 date_string

c-------------------------------------------------------------------------------
c     get date
 
      call fdate(date_string)

c-------------------------------------------------------------------------------

      iprint = 0
      dec = 0
      mt = 'M'

      QPROTYP = .TRUE.
      QROTANG = .TRUE.

c-------------------------------------------------------------------------------

c     Initialize variables and arrays.

      call dirsep(sep)
      inc   = 2
      inc1  = 2
      inc2  = 2

c-------------------------------------------------------------------------------
c     get command-line arguments

      narg = getnarg()
      do i = 1, narg
        call getcmdarg( i, cmdarg)
        if( index(cmdarg,'h').ne.0 ) then
          write(*,*)'Permitted options:-'
          write(*,*)'                    -1 -> 3  iprint level'
          stop
        else
          read(cmdarg,'(i2)') iprint
        endif
      enddo

      call iin( 'Give print level (-1/0/1/2/3)',iprint)

c-------------------------------------------------------------------------------
c     Check for configuration file. If doesn't exist then create it and write
c     default values into it.

      open(unit=ind3, file='process.cfg', status='old', err=101)
      if( iprint.ge.0 ) then
        write(*,*)'Opened processing configuration file process.cfg'
      endif
      goto 102

101   write(*,*)'File process.cfg not found'
      stop

102   do 103 while( .TRUE. )
        read(ind3,'(a)',end=104) line

        if( line(1:6).eq.'ROTANG' ) then
          read(line(8:),*) azimuth
          QROTANG = .FALSE.
          AZIMSET = .TRUE.
          if( iprint.ge.1 ) then
            write(*,*)'ROTANG found with value :', azimuth
          endif
 
        else if( line(1:6).eq.'PROTYP' ) then
          read(line(8:),'(a)') line
          if( index(line,'MT').ne.0 ) then
            mt  = 'M'
            HSG = .FALSE.
          else if( index(line,'GDS').ne.0 ) then
            mt  = 'G'
            HSG = .FALSE.
          else if( index(line,'HSG').ne.0 ) then
            HSG = .TRUE.
          else
            write(*,*)'Unrecognized processing type =', line(1:5)
            write(*,*)'Edit process.cfg file and re-run'
            stop
          endif
          QPROTYP = .FALSE.
          if( iprint.ge.1 ) then
            write(*,*)'PROTYP found with value :', line(1:5)
          endif

        endif

103   continue

104   if( iprint.ge.0 ) then
        write(*,*)'Read in parameters from process.cfg file'
      endif
      
110   continue

c-------------------------------------------------------------------------------

      if( iprint.ge.1 ) then
        write(*,*)' '
        write(*,*)' >>>>>>>>>>>>> TS2CHAVE <<<<<<<<<<<<<<<<<<<'
        write(*,*)' '
        write(*,*)'           version = ', ver
        write(*,*)'build date = ', bdate
        write(*,*)' '
        write(*,*)'It is assumed that this program is being run from'
        write(*,*)'the database directory of the project '
        write(*,*)'(e.g. /local/mt/lims/nod)  '
        write(*,*)'and that all data files reside in subdirectories'
        write(*,*)'with the respective station names '
        write(*,*)'(e.g. /local/mt/lims/nod/nod001 nod002 etc.)'
        write(*,*)' '
        write(*,*)'windows and hardware database files are required'
        write(*,*)'(e.g. windows.nod & hardware.nod) '
        write(*,*)' '
      end if

c-------------------------------------------------------------------------------

      ans = 'Y'
      call yin( 'Remote-reference processing (y/n)?', ans )
      if( ans.eq.'Y' ) then
        RR = .TRUE.
      else
        RR = .FALSE.
      endif

 
2     if( QPROTYP ) then
        call tin( 'MT, GDS or HSG processing', mt )
        call shiftup( mt )
        if( mt.eq.'H' ) then
          HSG = .TRUE.
          indat1 = 'hs2hsgxf'
        else if( mt.eq.'G' ) then
          HSG = .FALSE.
        else if( mt.eq.'M' ) then
          HSG = .FALSE.
        else
          write(*,*)'Erroneous input, M G or H only please'
          goto 2
        endif
      endif

c-------------------------------------------------------------------------------
c...get number of windows to use

      nwindow = 1
      call iin( 'Give number of windows', nwindow )

c-------------------------------------------------------------------------------
c...loop around for each window


c  Read in the name of the input data file 

      tswindow(1) = 'tbt101ss'

      do 1000 iw = 1, nwindow

300   call tin( 'Give window (extension assumed)', tswindow(iw) )

      proj = tswindow(iw)(1:3)
      stat = tswindow(iw)(1:6)
      title(1:12) = tswindow(iw)

      if( iprint.ge.1 ) write(*,*)'Station =>', stat

      if( RR ) then
        tswindowrr(iw) = tswindow(iw)
        call tin( 'Give remote-reference window (no extension)', 
     &             tswindowrr(iw) )
        title(9:20) = ' +'//tswindowrr(iw)
        statrr = tswindowrr(iw)(1:6)
      else
        tswindowrr(iw) = tswindow(iw)
      endif

      if( iprint.ge.1 ) then
        write(*,*)'Data files to open ==>'
        write(*,*)' file1 =>', tswindow(iw)
        if( RR ) then 
          write(*,*)' file2 =>', tswindowrr(iw)
        else
          write(*,*)' No file2'
        end if
      end if


c-------------------------------------------------------------------------------
c
c Open the output data files
c
      if( iw.eq.1 ) then
        reply='u'
        format_data=.false.
        call tin('Output files ASCII (a) or BINARY (b)?',reply)
        if(reply.eq.'a') then
          format_data=.true.
        else
          nblock=30000
          prompt='Blocking factor (max=xxxxxx)?'
          write(prompt(22:27),'(i6)')MAXB
          call iin(prompt, nblock)
          if(nblock.gt.30000)then
            write(*,*)' Factor too high, set to MAXB=',MAXB
            nblock=MAXB
          endif
        endif
      endif
      outfile(1)=stat//sep//tswindow(iw)//tswindowrr(iw)(4:8)//'.ex'
      outfile(2)=stat//sep//tswindow(iw)//tswindowrr(iw)(4:8)//'.ey'
      outfile(3)=stat//sep//tswindow(iw)//tswindowrr(iw)(4:8)//'.hx'
      outfile(4)=stat//sep//tswindow(iw)//tswindowrr(iw)(4:8)//'.hy'
      outfile(5)=stat//sep//tswindow(iw)//tswindowrr(iw)(4:8)//'.hz'
      iunit=10
      do i =1, 5
         write(*,*)' Writing ', outfile(i)
         if(format_data) then
            open(iunit,file=outfile(i),status='unknown')
         else
            open(iunit,file=outfile(i),status='unknown',
     &           form='unformatted')
         endif
         iunit=iunit+1
      end do
      nchanout=5

      if( RR ) then
        outfile(6)=stat//sep//tswindow(iw)//tswindowrr(iw)(4:8)//'.rx'
        outfile(7)=stat//sep//tswindow(iw)//tswindowrr(iw)(4:8)//'.ry'
        do i=6,7
           write(*,*)' Writing ', outfile(i)
           if(format_data)then
              open(iunit,file=outfile(i),status='unknown')
           else
              open(iunit,file=outfile(i),status='unknown',
     &             form='unformatted')
           endif
           iunit=iunit+1
        end do
        nchanout=7
      endif

c-------------------------------------------------------------------------------
c
c Open the data file and Read in the window and header file information.
c

      form = '?'
      write(*,*)'Opening input file for window ', tswindow(iw)
      call ts_open( ind1, tswindow(iw), indat1, .FALSE., .FALSE. )
      write(*,*)'Opened data file =>',indat1
      call ts_rdinfo(ind1)

      if( iprint.ge.1 ) then
        write(*,*)'Information block from input file...'
        write(*,*)'STATION   :', stat
        write(*,*)'WINDOW    :', tswindow
        write(*,*)'LATITUDE  :', lat
        write(*,*)'LONGITUDE :', long
        write(*,*)'ELEVATION :', elev
        write(*,*)'COORD_SYS :', azdir
        write(*,*)'FORM      :', form
        write(*,*)'FORMAT    :', format
        write(*,*)'NCHAN     :', nchan
        do i = 1, nchan
          write(*,*)'Channel......:', i
          write(*,*)'CHAN    :', chan(i)
          write(*,*)'AZIM    :', azim(i)
          write(*,*)'GAIN    :', gain(i)
          write(*,*)'UNITS   :', units(i)
        enddo
        write(*,*)'STARTTIME :', starttime
      endif

c..format common
      form1   = form
      format1 = format

c..ts_stat common
      stattmp = stat

c..ts_pos common
      lat1  = lat
      long1 = long
      elev1 = elev

c..ts_data common
      if( tunits.eq.'s' ) delta = 1./delta
      delta1  = delta
      tunits1 = tunits
      nchan1  = nchan

c..ts_azim common
      do i = 1, 5
        azim1(i) = azim(i)
      enddo
      azimhx = azim(1)
      azimhy = azim(2)
      azimex = azim(4)
      azimey = azim(5)
      azdir1 = azdir
      declin1 = declination

c..ts_start common
      stime1 = starttime
      call date( 0, stime1, byy, bmm, bdd, bhh, bmin, bss )
      if( iprint.ge.1 ) write(*,*) 'block start time=',stime1
      byy1 = byy
      bmm1 = bmm
      bdd1 = bdd
      bhh1 = bhh
      bmin1= bmin
      bss1 = bss

c
      if( RR ) then 
        form = '?'
        write(*,*)'Opening input file for window ', tswindowrr(iw)
        call ts_open( ind2, tswindowrr(iw), indat2, .FALSE., .FALSE. )
        call ts_rdinfo(ind2)

        if( iprint.ge.1 ) then
          write(*,*)'Information block from input file...'
          write(*,*)'STATION   :', stat
          write(*,*)'WINDOW    :', tswindowrr
          write(*,*)'LATITUDE  :', lat
          write(*,*)'LONGITUDE :', long
          write(*,*)'ELEVATION :', elev
          write(*,*)'FORM      :', form
          write(*,*)'FORMAT    :', format
          write(*,*)'NCHAN     :', nchan
          do i = 1, nchan
            write(*,*)'Channel......:', i
            write(*,*)'CHAN    :', chan(i)
            write(*,*)'AZIM    :', azim(i)
            write(*,*)'GAIN    :', gain(i)
            write(*,*)'UNITS   :', units(i)
          enddo
          write(*,*)'STARTTIME :', starttime
        endif

c..format common
        form2   = form
        format2 = format

c..ts_stat common
        statrr = stat
        stat   = stattmp

c..ts_pos common
        lat2  = lat
        long2 = long
        elev2 = elev

c..ts_data common
        if( tunits.eq.'s' ) delta = 1./delta
        delta2  = delta
        tunits2 = tunits
        nchan2  = nchan

c..ts_azim common
        do i = 1, 5
          azim2(i) = azim(i)
        enddo
        azimrx = azim(1)
        azimry = azim(2)
        azdir2 = azdir
        declin2 = declination

c..ts_start common
        stime2 = starttime
        call date( 0, stime2, byy, bmm, bdd, bhh, bmin, bss )
        if( iprint.ge.1 ) write(*,*) 'block start time=',stime2
        byy2 = byy
        bmm2 = bmm
        bdd2 = bdd
        bhh2 = bhh
        bmin2= bmin
        bss2 = bss

        if(delta1.ne.delta2) then
          write(*,*) 'Sampling rates differ between local and ',
     >               'remote data files.'
          stop
        endif

      else
        nchan2 = nchan1
      endif

      nchan = nchan1

      go to 320
  310 write (*,*)' Error opening DATA INPUT file, re-enter.'
      go to 300
  320 continue
c
c--Get instrument number(s) from the windows file
c
      fout = 'windows.'//proj
      goto 405
  400 call tin (' Give the project windows file', fout )
  405 open ( inc, file=fout, status='old', form='formatted', err=410 )
      go to 420
  410 write (*,*) ' ts2chave: Error opening WINDOWS file, re-enter'
      go to 400
  420 continue


      call getwindow( inc, tswindow(iw), instr1, nchan1, 
     &                stime1, etime1 )
      if( iprint.ge.1 ) then
        write(*,*)' window start and end times:', stime1,'-',etime1
      endif
      sdur = tdiff( stime1, etime1 )
      if( RR ) then
        rewind( inc )
        call getwindow(inc, tswindowrr(iw), instr2, nchan2, 
     &                 stime2, etime2)
        nchan2 = 2
      else
        tswindowrr(iw) = tswindow(iw)
        instr2 = instr1
        nchan2 = nchan1
        stime2 = stime1
        etime2 = etime1
      end if
      close(inc)



      if( nchan1.eq.3 ) then
        if( mt.eq.'M' ) then
          write(*,*)'>>>>>Only 3 channels found: GDS processing to',
     &              ' be undertaken'
          mt = 'G'
        endif
      else if( nchan1.eq.4 ) then
        if( iprint.ge.1 ) write(*,*)'4 channels found'
      else if( nchan1.eq.5 ) then
        if( iprint.ge.1 ) write(*,*)'5 channels found'
      else
        write(*,*)'Wierd number of channels; not 3 or 4 or 5 -- ',
     &            'don''''t know what to do now!'
        stop
      endif
c
c---nchan = total number of channels recorded on the data file.
c   delta is the sampling rate in Hz
c
      if( iprint.ge.1 ) then
        write(*,*) 'Sampling rate in Hz =', delta 
      end if

  900 if( iprint.ge.0 ) then
        write(*,'(2a)') 'Give the required event start time >',
     &            'yyyy-mm-dd hh:mn:ss'
      end if
      if( stime1.gt.stime2 ) then
        stime(iw) = stime1
      else
        stime(iw) = stime2
      end if
      call tin ( ' ', stime(iw) )
      call date( 0, stime(iw), yy, mm, dd, hh, min, ss )
      if( iprint.ge.2 ) then
        write(*,*)'stime=',stime(iw)
        write(*,*)' yy, mm, dd, hh, min =>', yy, mm, dd, hh, min, ss
      end if

      call chkdat ( yy, mm, dd, hh, min, ss, daterr )
      if( daterr .gt. 0 ) go to 900

      if ( yy .ne. byy ) then
        write(*,'(a, i4)')' Requested wrong year!  Data block year is',
     &                      byy
        go to 900
      end if

905   if( iprint.ge.0 ) then
        write(*,'(2a)') 'Give the required event end   time >',
     &            'yyyy-mm-dd hh:mn:ss'
      end if
      if( etime1.lt.etime2 ) then
        etime(iw) = etime1
      else
        etime(iw) = etime2
      end if
      call tin ( ' ', etime(iw) )
      call date( 0, etime(iw), yy, mm, dd, hh, min, ss )
      if( iprint.ge.2 ) then
        write(*,*)'etime=',etime(iw)
        write(*,*)' yy, mm, dd, hh, min =>', yy, mm, dd, hh, min, ss
      end if

      call chkdat ( yy, mm, dd, hh, min, ss, daterr )
      if( daterr .gt. 0 ) go to 905


      call date( 0, stime(iw), yy, mm, dd, hh, min, ss )


c...sdur is the duration in seconds from the start time to the end
      sdur = tdiff( stime(iw), etime(iw) )

      dday  =  sdur/(60*60*24)
      dhour =  mod(sdur,60*60*24)/(60*60)
      dmin  =  mod(sdur,60*60)/60
      dsec  =  mod(sdur,60)

      if( iprint.ge.0 ) then
        write( dur, '(i4.4,a1,i2.2,a1,i2.2)') 
     &           dday, '/', dhour, '/', dmin
        write( *, '(2a)') 'Duration (dddd/hh/mm) : ', dur
      end if

      if(dday.eq.0 .and. dhour.eq.0 .and. dmin.eq.0 .and. dsec.eq.0)then
        dday  =  sdur/(60*60*24)
        dhour =  mod(sdur,60*60*24)/(60*60)
        dmin  =  mod(sdur,60*60)/60
        dsec  =  mod(sdur,60)
      endif


c...calculate the total number of seconds of data to be analysed.

      tsec = dday*86400 + dhour*3600 + dmin*60 + dsec

c...totn is the total number of entries required for analysis.
c
      totn =  float(tsec) * delta 
      nmax = ifix(totn)

      write(*,*) 'Total number of data requested:', nmax

c-------------------------------------------------------------------------------
c     write out co-ordinates and request direction for rotation

 
      write(*,*)'Co-ordinates of acquisition ==>'
      write(*,*)'Hx =', azimhx, '  Ex =', azimex,
     &     '  Ey =', azimey, '  Coord sys: ', azdir1,
     &     'decl =', declin1
      if( RR ) then
        write(*,*)'Rx =', azimrx, 
     &            '                        Coord sys: ', azdir2,
     &     'decr =', declin2
      endif


c...get declination if site in magnetic co-ordinates and not read in
c   from time series
      if( QDECLIN .and. declin1.eq.-999. ) then
        if( index(azdir1, 'MAGNETIC').ne.0 .or.
     &      index(azdir2, 'MAGNETIC').ne.0 ) then
          call iin( 'Give declination', dec )
        endif
      endif

      if( index(azdir1, 'MAGNETIC').ne.0 ) then
        if( declin1.ne.-999. ) then
          decl = nint( declin1 )
        else
          decl = dec
        endif
      else
        decl = 0
      endif

      if( index(azdir2, 'MAGNETIC').ne.0 ) then
        if( declin2.ne.-999. ) then
          decr = nint( declin1 )
        else
          decr = dec
        endif
      else
        decr = 0
      endif

c...request co-ordinate system
      if( QROTANG ) then
        if( .NOT.AZIMSET ) azimuth = 0
        call iin( 'Desired co-ordinate system in TRUE NORTH', azimuth)
      endif

c...rotation angles required
      anghx = float( azimuth - (azimhx + decl) )
      angex = float( azimuth - (azimex + decl) )
      angey = float( azimuth - (azimey + decl) + 90 )
      angrx = float( azimuth - (azimrx + decr) )

c      if( iprint.ge.0 ) then
        write(*,*)'Rotation angles to be applied for azimuth ==>', 
     &                         azimuth
        write(*,*)'Ex =', angex
        write(*,*)'Ey =', angey
        write(*,*)'Hx =', anghx
        if( RR ) write(*,*)'Rx =', angrx
c      endif

c-------------------------------------------------------------------------------

 
c....skip data for data start times < stime
      if( stime1.lt.stime(iw) ) then
        nskip = tdiff( stime1, stime(iw) ) * delta
        write(*,*)'Skipping', nskip, '  data for local  file'
        call ts_skip( ind1, nskip )
      endif
      if( RR ) then
        if( stime2.lt.stime(iw) ) then
          nskip = tdiff( stime2, stime(iw) ) * delta
          write(*,*)'Skipping', nskip, '  data for remote file'
          call ts_skip( ind2, nskip )
        endif
      endif

c-------------------------------------------------------------------------------

      NPT = 0

7     continue

c...read in data from local site 
      ind   = ind1
      nchan = nchan1
      form  = form1
      format = format1
      call ts_in1(ind1, dat)
      if( dat(1).eq.-999.999 ) goto 30
      if( iprint.ge.3 ) then
        write(*,*) 'Input dat  =>', (dat(i),i=1,nchan1)
      end if

c...read in data from remote site 
      if( RR ) then
        ind = ind2
        nchan = nchan2
        form  = form2
        format = format2
        call ts_in1(ind2, dat2)
        nchan = nchan1
        if( iprint.ge.3 ) then
          write(*,*) 'Input dat2 =>', (dat2(i),i=1,nchan2)
        end if
      end if


      if ( nent .lt. 0 ) then
        if ( npt .gt. 32 ) go to 30
        write(*, '(a)')' No data found. Program ending.'
        go to 9999
      end if


c
c      Channel     LIMS        Cascade      Jones       HSG
c         1         Hx           Ex           Hx         Gx
c         2         Hy           Ey           Hy         Gy
c         3         Hz           Hx           Ex
c         4         Ex           Hy           Ey
c         5         Ey           Hz           Hz         Hz
c         6         Rx           Rx           Rx         Rx
c         7         Ry           Ry           Ry         Ry
c

c...assign data input
      hx = dat(1)
      hy = dat(2)
      if( nchan.eq.3 .or. nchan.eq.5 ) then
        hz = dat(3)
        ex = dat(4)
        ey = dat(5)
      else if( nchan.eq.4 ) then
        hz = 0.
        ex = dat(3)
        ey = dat(4)
      endif

      if( RR ) then
        rx = dat2(1)
        ry = dat2(2)
      else
        rx = hx
        ry = hy
      endif


c...check not equal to misdat: if equal to misdat, set to last good value

      if( hx.gt.misdat*0.99999.and.hx.lt.misdat*1.00001) hx = hxl
      if( hy.gt.misdat*0.99999.and.hy.lt.misdat*1.00001) hy = hyl
      if( hz.gt.misdat*0.99999.and.hz.lt.misdat*1.00001) hz = hzl
      if( ex.gt.misdat*0.99999.and.ex.lt.misdat*1.00001) ex = exl
      if( ey.gt.misdat*0.99999.and.ey.lt.misdat*1.00001) ey = eyl
      if( rx.gt.misdat*0.99999.and.rx.lt.misdat*1.00001) rx = rxl
      if( ry.gt.misdat*0.99999.and.ry.lt.misdat*1.00001) ry = ryl

      hxl = hx
      hyl = hy
      hzl = hz
      exl = ex
      eyl = ey
      rxl = rx
      ryl = ry


c...perform rotations (if required) in time domain

      if( (anghx+angex+angey+angrx).ne.0. .and. iprint.ge.3 ) then
        write(*,*) 'Pre-rot  =>',hx,hy,ex,ey,rx,ry
      endif
      if( anghx.ne.0. ) then
        call rotdat( hx, hy, anghx, anghx )
      endif

      if( angex.ne.0. .or. angey.ne.0. ) then
        call rotdat( ex, ey, angex, angey )
      endif

      if( angrx.ne.0. ) then
        call rotdat( rx, ry, angrx, angrx )
      endif
      if( (anghx+angex+angey+angrx).ne.0. .and. iprint.ge.3 ) then
        write(*,*) 'Post-rot =>',hx,hy,ex,ey,rx,ry
      endif


c...write data  out

      if(format_data) then
         ib=1
      else
         ib=ib+1
         if(ib.eq.nblock) then
            write_data=.true.
         else
            write_data=.false.
         endif
      endif

      if( mt.eq.'M' ) then
        A(ib,1) = ex
        A(ib,2) = ey
      end if

      if( HSG ) then
        A(ib,3) = hx + hy
        A(ib,4) = hx + hy
        A(ib,5) = hz
      else
        A(ib,3) = hx
        A(ib,4) = hy
        A(ib,5) = hz
      endif

      if(RR)then
         A(ib,6) = rx
         A(ib,7) = ry
      endif

      if( iprint.ge.3 ) then
        write(*,*) 'Points to write ==>'
        write(*,*)(a(ib,i),i=1,7)
      end if

      if(format_data) then
         iunit=10
         do i=1, nchanout
            write(iunit,*) a(1,i)
            iunit=iunit+1
         end do   
      else
         if(write_data) then
            iunit=10
            do i=1, nchanout
               write(iunit) (a(j,i),j=1,ib)
               iunit=iunit+1
            end do   
            ib=0
         endif
      endif
      NPT = NPT+1

      IF(NPT-NMAX) 7,9999,9999

9999  continue


c...flush data still in buffer: fill to end of block with zeroes
30    if( .not.format_data .and. ib.gt.0 ) then
        iunit=10
        do i=1, nchanout
          write(iunit) (a(j,i),j=1,ib), (0.0,j=ib+1,nblock)
          iunit=iunit+1
        end do  
      endif

      write(*,*)' Number of points written: ', npt
      nptw(iw) = npt

1000  continue

c...end of "nwindow" loop
c-------------------------------------------------------------------------------
c...write out input file for use with Chave's code
      close(unit=7)
      open(unit=7,file=stat//'_rrrmt_in')
      write(*,'(2a)')'Opening file for input params to rrrmt: ',
     &               stat//'_rrrmt_in'

      write(7,'(a)') '3'                        !3 outputs
      write(7,'(a)') '2'                        !2 inputs
      write(7,'(a)') '1'                        !1 prolate
      write(7,'(a)') '16384 2 11'               !FFT, subdiv, no.
      write(7,'(a)') '3 2'                      !3rd & 4th harmonics
      write(7,'(a)') '1'                        !robust param
      write(7,'(a)') '0'                        !leverage param
      write(7,'(a)') '0 4'                      !lower/upper rej
      write(7,'(a)') '0.5 0.1'                  !coh thresh & trim
      write(7,'(a)') '1'                        !nz
      write(7,'(a)') '10'                       !coh block size
      write(7,'(a)') '0.0 0.5'                  !coh f_lo & f_up
      write(7,'(a)') stat//'/'//stat            !station - root name
      write(7,'(a)') '0'                        !output level
      write(7,'(a)') '0'                        !no freq rej
      write(7,'(a)') '1'                        !1 filter param
      write(7,'(i2)') nwindow                   !nwindow pieces
      write(7,'(a)') '5'                        !AR length

c...Ex
      if( format_data ) then
        write(7,'(a)') 'f'                      !formatted
      else
        write(7,'(a)') 'u'                      !unformatted
        write(7,*) nblock                       !blocking factor
      endif
      write(7,*) delta/30000.                   !low-pass filter
      do iw = 1, nwindow
        write(7,'(a)') stat//'/'//tswindow(iw)//
     &               tswindowrr(iw)(4:8)//'.ex' !ex input file
        write(7,*) 0, nptw(iw)                  !nskip, nread
      enddo
c...Ey
      if( format_data ) then
        write(7,'(a)') 'f'                      !formatted
      else
        write(7,'(a)') 'u'                      !unformatted
        write(7,*) nblock                       !blocking factor
      endif
      write(7,*) delta/30000.                   !low-pass filter
      do iw = 1, nwindow
        write(7,'(a)') stat//'/'//tswindow(iw)//
     &               tswindowrr(iw)(4:8)//'.ey' !ey input file
        write(7,*) 0, nptw(iw)                  !nskip, nread
      enddo

c...Hz
      if( format_data ) then
        write(7,'(a)') 'f'                    !formatted
      else
        write(7,'(a)') 'u'                    !unformatted
        write(7,*) nblock                     !blocking factor
      endif
      write(7,*) 0.0                          !low-pass filter
      do iw = 1, nwindow
        write(7,'(a)') stat//'/'//tswindow(iw)//
     &               tswindowrr(iw)(4:8)//'.hz' !hz input file
        write(7,*) 0, nptw(iw)                  !nskip, nread
      enddo

c...Hx
      if( format_data ) then
        write(7,'(a)') 'f'                    !formatted
      else
        write(7,'(a)') 'u'                    !unformatted
        write(7,*) nblock                     !blocking factor
      endif
      write(7,*) 0.0                          !low-pass filter
      do iw = 1, nwindow
        write(7,'(a)') stat//'/'//tswindow(iw)//
     &               tswindowrr(iw)(4:8)//'.hx' !hx input file
        write(7,*) 0, nptw(iw)                  !nskip, nread
      enddo

c...Hy
      if( format_data ) then
        write(7,'(a)') 'f'                    !formatted
      else
        write(7,'(a)') 'u'                    !unformatted
        write(7,*) nblock                     !blocking factor
      endif
      write(7,*) 0.0                          !low-pass filter
      do iw = 1, nwindow
        write(7,'(a)') stat//'/'//tswindow(iw)//
     &               tswindowrr(iw)(4:8)//'.hy' !hy input file
        write(7,*) 0, nptw(iw)                  !nskip, nread
      enddo

c...Rx
      if( format_data ) then
        write(7,'(a)') 'f'                    !formatted
      else
        write(7,'(a)') 'u'                    !unformatted
        write(7,*) nblock                     !blocking factor
      endif
      write(7,*) 0.0                          !low-pass filter
      do iw = 1, nwindow
        if( RR ) then
          write(7,'(a)') stat//'/'//tswindow(iw)//
     &                 tswindowrr(iw)(4:8)//'.rx' !rx input file
        else
          write(7,'(a)') stat//'/'//tswindow(iw)//
     &                 tswindowrr(iw)(4:8)//'.hx' !hx input file
        endif
        write(7,*) 0, nptw(iw)                  !nskip, nread
      enddo

c...Ry
      if( format_data ) then
        write(7,'(a)') 'f'                    !formatted
      else
        write(7,'(a)') 'u'                    !unformatted
        write(7,*) nblock                     !blocking factor
      endif
      write(7,*) 0.0                          !low-pass filter
      do iw = 1, nwindow
        if( RR ) then
          write(7,'(a)') stat//'/'//tswindow(iw)//
     &                 tswindowrr(iw)(4:8)//'.ry' !ry input file
        else
          write(7,'(a)') stat//'/'//tswindow(iw)//
     &                     tswindowrr(iw)(4:8)//'.hy' !hy input file
        endif
        write(7,*) 0, nptw(iw)                  !nskip, nread
      enddo

      write(7,'(a)') '0 90 0'
      write(7,'(a)') '0 90 0'
      write(7,'(a)') '0 90 0'
      close(unit=7)

c...write out header file to add to start of response file
      open(unit=7,file=stat//'/'//stat//'.blk')
      write(*,'(2a)')'Opening file for header blocks: ',
     &          stat//'/'//stat//'.blk'
      write(7,'(a)') '# ts2chave: ver='//ver
      write(7,'(a)') '# date: '//date_string
      write(7,'(a)') '#'
      write(7,'(a,i2)') '# no. of windows =', nwindow
      write(7,'(a)') '#'
      do iw = 1, nwindow
      write(7,'(a,i2)') '# window:', iw
      write(7,'(a)') '# tswindow  : '//tswindow(iw)
      write(7,'(a)') '# tswindowrr: '//tswindowrr(iw)
      write(7,'(a)') '#'
      write(7,'(a)') '# window start :'//stime(iw)
      write(7,'(a)') '# window end   :'//etime(iw)
      write(7,'(a)') '#'
      enddo
      write(7,'(a,i3)' ) '# azimuth    : ', azimuth
      write(7,'(a)') '#'
      write(7,'(a,f7.1)' ) '# Ex rotation: ', angex
      write(7,'(a,f7.1)' ) '# Ey rotation: ', angey
      write(7,'(a,f7.1)' ) '# Hx rotation: ', anghx
      write(7,'(a,f7.1)' ) '# Hy rotation: ', anghx
      if( RR ) then
        write(7,'(a,f7.1)' ) '# Rx rotation: ', angrx
        write(7,'(a,f7.1)' ) '# Ry rotation: ', angrx
      endif
      write(7,'(a)') '#'
      write(7,'(a)') '# Acquisition coordinates: '
      write(7,'(a)') '#'
      write(7,'(a)')     '# Local site :'//tswindow(1)(1:6)
      write(7,'(2a)' )   '# coord_sys  : ', azdir1
      write(7,'(a,i3)' ) '# declination: ', decl
      write(7,'(a,i3)' ) '# Ex azimuth : ', azimex
      write(7,'(a,i3)' ) '# Ey azimuth : ', azimey
      write(7,'(a,i3)' ) '# Hx azimuth : ', azimhx
      write(7,'(a,i3)' ) '# Hy azimuth : ', azimhy
      if( RR ) then
        write(7,'(a)')     '#'
        write(7,'(a)')     '# Remote site:'//statrr
        write(7,'(2a)' )   '# coord_sys  : ', azdir2
        write(7,'(a,i3)' ) '# declination: ', decl
        write(7,'(a,i3)' ) '# Rx azimuth : ', azimrx
        write(7,'(a,i3)' ) '# Ry azimuth : ', azimry
      endif
      write(7,'(a)') '#'

      write(7,'(a  )') '>STATION   ='//stat
      if( RR ) then
        write(7,'(a  )') '>STATION_RR='//statrr
      endif
      write(7,'(a12,f12.1)') '>AZIMUTH   =', float(azimuth)
      write(7,'(a12,f12.4)') '>LATITUDE  =', lat1
      write(7,'(a12,f12.4)') '>LONGITUDE =', long1
      write(7,'(a12,f12.1)') '>ELEVATION =', elev1





      stop 'Done.'
      END
