c  ts2chave: v4.0: 21 March 1996
c
c  converts a ts file into a Chave input file
c
c  24-Oct-2000: Modified for using RRRMT Ver 9
c

c-------------------------------------------------------------------------------

      implicit none

c-------------------------------------------------------------------------------

      include 'version.inc'
      include 'ctrlblk.inc' 
      include 'io.inc' 
      include 'infoblk.inc'
      include 'bdate.inc'
      include 'defaults.inc'

c-------------------------------------------------------------------------------

      integer MAXWINDOW
      parameter ( MAXWINDOW = 10 )
      integer MAXB
      parameter (MAXB=30000)

c-------------------------------------------------------------------------------

      integer ib, nblock

      integer narg, getnarg
      integer nwindow, iw, nptw(MAXWINDOW)

      integer npt, iunit, nchanout

      integer i, j
      integer nmax
      integer yy, mm, dd, hh, min, ss, dday, dhour, dmin, dsec, tsec
      integer nent
      integer nchan, nchan1, nchan2, nchan3
      integer nskip
      integer instr1, instr2, instr3

      integer azimex, azimey, azimhx, azimhy
      integer azimrx1, azimry1, azimrx2, azimry2
      integer azimuth
      integer dec, decl, decr, tdiff, sdur


      real a(MAXB,9)

      real dat(5), dat2(5), dat3(5)
      real delta1, delta2, delta3
      real totn
      real ex, ey, hx, hy, hz, rx1, ry1,  rx2, ry2
      real exl, eyl, hxl, hyl, hzl, rxl1, ryl1, rxl2, ryl2

      real angex, angey, anghx, angrx1, angrx2
      real declin1, declin2, declin3

      real lat1, long1, elev1
      real lat2, long2, elev2
      real lat3, long3, elev3
      real azim1(5), azim2(5), azim3(5)


      character*30 prompt
      character*40 outfile(9), fout
      character title*20, line*80
      character*40 indat1, indat2, indat3
      character proj*3, sep*1 
      character*10 dur
      character*5 tunits1, tunits2, tunits3
      character*8 tswindow(MAXWINDOW), tswindowr1(MAXWINDOW), 
     &                                 tswindowr2(MAXWINDOW)
      character*6 stat, statr1, statr2, stattmp
      character*19 stime(MAXWINDOW), etime(MAXWINDOW), 
     &             stime1, etime1, stime2, etime2, stime3, etime3
      character*10 cmdarg
      character*1  ans, mt, reply
      character*17 azdir1, azdir2, azdir3
      character*6  form1, form2, form3
      character*15 format1, format2, format3
      character*24 date_string

      logical HSG, AZIMSET
      logical QROTANG, QDECLIN, QPROTYP
      logical RR, MULTI
      logical FORMAT_OUTPUT, WRITE_DATA

c...functions

      integer lnblnk
      integer datchk

c-------------------------------------------------------------------------------
c...get date
 
      call fdate(date_string)

c-------------------------------------------------------------------------------

      iprint = 0
      dec = 0
      mt = 'M'

      QPROTYP = .TRUE.
      QROTANG = .TRUE.

c-------------------------------------------------------------------------------
c...initialize variables and arrays.

      call dirsep(sep)

c-------------------------------------------------------------------------------
c...get command-line arguments

      narg = getnarg()
      do i = 1, narg
        call getcmdarg( i, cmdarg)
        if( index(cmdarg,'h').ne.0 ) then
          write(*,*)'Permitted options:-'
          write(*,*)'                    -1 -> 3  iprint level'
          stop
        else
          read(cmdarg,'(i2)') iprint
        endif
      enddo

      call iin( 'Give print level (-1/0/1/2/3)', iprint)

c-------------------------------------------------------------------------------
c     Check for configuration file. If doesn't exist then create it and write
c     default values into it.

      open(unit=ind4, file='process.cfg', status='old', err=101)
      if( iprint.ge.0 ) then
        write(*,*)'Opened processing configuration file process.cfg'
      endif
      goto 102

101   write(*,*)'File process.cfg not found'
      stop

102   do 103 while( .TRUE. )
        read(ind4,'(a)',end=104) line

        if( line(1:6).eq.'ROTANG' ) then
          read(line(8:),*) azimuth
          QROTANG = .FALSE.
          AZIMSET = .TRUE.
          if( iprint.ge.1 ) then
            write(*,*)'ROTANG found with value :', azimuth
          endif
 
        else if( line(1:6).eq.'PROTYP' ) then
          read(line(8:),'(a)') line
          if( index(line,'MT').ne.0 ) then
            mt  = 'M'
            HSG = .FALSE.
          else if( index(line,'GDS').ne.0 ) then
            mt  = 'G'
            HSG = .FALSE.
          else if( index(line,'HSG').ne.0 ) then
            HSG = .TRUE.
          else
            write(*,*)'Unrecognized processing type =', line(1:5)
            write(*,*)'Edit process.cfg file and re-run'
            stop
          endif
          QPROTYP = .FALSE.
          if( iprint.ge.1 ) then
            write(*,*)'PROTYP found with value :', line(1:5)
          endif

        endif

103   continue

104   if( iprint.ge.0 ) then
        write(*,*)'Read in parameters from process.cfg file'
      endif
      close(unit=ind4)
      

c-------------------------------------------------------------------------------
c...write banner

      call banner( 'TS2CHAVE9' )

c-------------------------------------------------------------------------------

1     ans = 's'
      call tin('Single remote (s), multi remote (m), or none (n)', 
     &          ans )
      call shiftup( ans )
      if( ans.eq.'S' ) then
        RR    = .TRUE.
        MULTI = .FALSE.
      elseif( ans.eq.'M' ) then
        RR    = .TRUE.
        MULTI = .TRUE.
      elseif( ans.eq.'N' ) then
        RR    = .FALSE.
        MULTI = .FALSE.
      else
        write(*,*)'Answer not recognised; reply s, m or n'
        goto 1
      endif

 
2     if( QPROTYP ) then
        call tin( 'MT, GDS or HSG processing', mt )
        call shiftup( mt )
        if( mt.eq.'H' ) then
          HSG = .TRUE.
          indat1 = 'hs2hsgxf'
        else if( mt.eq.'G' ) then
          HSG = .FALSE.
        else if( mt.eq.'M' ) then
          HSG = .FALSE.
        else
          write(*,*)'Erroneous input, M G or H only please'
          goto 2
        endif
      endif

c-------------------------------------------------------------------------------
c...get number of windows to use

      nwindow = 1
      call iin( 'Give number of windows', nwindow )

c-------------------------------------------------------------------------------
c...loop around for each window


c...read in the name of the input data file 

      tswindow(1) = 'tbt101ss'

      do 1000 iw = 1, nwindow

300   call tin( 'Give window (extension assumed)', tswindow(iw) )

      proj = tswindow(iw)(1:3)
      stat = tswindow(iw)(1:6)
      title(1:12) = tswindow(iw)

      if( iprint.ge.1 ) write(*,*)'Station =>', stat

      if( RR ) then
        tswindowr1(iw) = tswindow(iw)
        call tin( 'Give 1st remote-reference window (no extension)', 
     &             tswindowr1(iw) )
        title(9:20) = ' +'//tswindowr1(iw)
        statr1 = tswindowr1(iw)(1:6)
        if( MULTI ) then 
          tswindowr2(iw) = tswindow(iw)
          call tin( 'Give 2nd remote-reference window (no extension)', 
     &             tswindowr2(iw) )
          title(9:20) = ' +'//tswindowr2(iw)
          statr2 = tswindowr2(iw)(1:6)
        else
          tswindowr2(iw) = tswindowr1(iw)
        endif
      else
        tswindowr1(iw) = tswindow(iw)
        tswindowr2(iw) = tswindow(iw)
      endif

      if( iprint.ge.1 ) then
        write(*,*)'Data files to open ==>'
        write(*,*)' file1 =>', tswindow(iw)
        if( RR ) then 
          write(*,*)' file2 =>', tswindowr1(iw)
          if( MULTI ) then 
            write(*,*)' file3 =>', tswindowr2(iw)
          else
            write(*,*)' No file3'
          endif
        else
          write(*,*)' No file2'
          write(*,*)' No file3'
        endif
      endif


c-------------------------------------------------------------------------------
c...open the output data files

      if( iw.eq.1 ) then
        reply = 'b'
        FORMAT_OUTPUT = .FALSE.
        call tin('Output files ASCII (a) or BINARY (b)?', reply)
        if(reply.eq.'a') then
          FORMAT_OUTPUT = .TRUE.
        else
          nblock=30000
          prompt='Blocking factor (max=xxxxxx)?'
          write(prompt(22:27),'(i6)')MAXB
          call iin(prompt, nblock)
          if(nblock.gt.30000)then
            write(*,*)' Factor too high, set to MAXB=',MAXB
            nblock=MAXB
          endif
        endif
      endif
      outfile(1)=stat//sep//tswindow(iw)//tswindowr1(iw)(4:8)//'.ex'
      outfile(2)=stat//sep//tswindow(iw)//tswindowr1(iw)(4:8)//'.ey'
      outfile(3)=stat//sep//tswindow(iw)//tswindowr1(iw)(4:8)//'.hx'
      outfile(4)=stat//sep//tswindow(iw)//tswindowr1(iw)(4:8)//'.hy'
      outfile(5)=stat//sep//tswindow(iw)//tswindowr1(iw)(4:8)//'.hz'
      nchanout = 5

      if( RR ) then
        outfile(6)=stat//sep//tswindow(iw)//tswindowr1(iw)(4:8)//'.rx'
        outfile(7)=stat//sep//tswindow(iw)//tswindowr1(iw)(4:8)//'.ry'
        if( MULTI ) then
          outfile(8)=stat//sep//tswindow(iw)//tswindowr2(iw)(4:8)//'.rx'
          outfile(9)=stat//sep//tswindow(iw)//tswindowr2(iw)(4:8)//'.ry'
          nchanout = 9
        else
          nchanout = 7
        endif
      endif

      do i = 1, nchanout
         iunit = 10 + i
         write(*,*)' Writing unit ', iunit, '  file = ', outfile(i)
         if(FORMAT_OUTPUT) then
            open(iunit,file=outfile(i),status='unknown')
         else
            open(iunit,file=outfile(i),status='unknown',
     &           form='unformatted')
         endif
      enddo

c-------------------------------------------------------------------------------
c...open data files and read in the window and header file information.

      form = '?'
      write(*,*)'Opening local    data file ==>', tswindow(iw)
      call ts_open( ind1, tswindow(iw), indat1, .FALSE., .FALSE. )
      write(*,*)'Opened local    data file on unit', ind1,' ==>',
     &           indat1(1:lnblnk(indat1))
      call ts_rdinfo(ind1)

c..format common
      form1   = form
      format1 = format

c..ts_stat common
      stattmp = stat

c..ts_pos common
      lat1  = lat
      long1 = long
      elev1 = elev

c..ts_data common
      if( tunits.eq.'s' ) delta = 1./delta
      delta1  = delta
      tunits1 = tunits
      nchan1  = nchan

c..ts_azim common
      do i = 1, 5
        azim1(i) = azim(i)
      enddo
      azimhx = azim(1)
      azimhy = azim(2)
      azimex = azim(4)
      azimey = azim(5)
      azdir1 = azdir
      declin1 = declination

c..ts_start common
      stime1 = starttime


c...open first RR file
      if( RR ) then 
        form = '?'
        write(*,*)'Opening remote-1 data file ==>', tswindowr1(iw)
        call ts_open( ind2, tswindowr1(iw), indat2, .FALSE., .FALSE. )
        write(*,*)'Opened remote-1 data file on unit', ind2,' ==>',
     &             indat2(1:lnblnk(indat2))
        call ts_rdinfo(ind2)

c..format common
        form2   = form
        format2 = format

c..ts_stat common
        statr1 = stat
        stat   = stattmp

c..ts_pos common
        lat2  = lat
        long2 = long
        elev2 = elev

c..ts_data common
        if( tunits.eq.'s' ) delta = 1./delta
        if(delta.ne.delta1) then
          write(*,*) 'Sampling rates differ between local and ',
     >               'remote data files.'
          stop
        endif
        delta2  = delta
        tunits2 = tunits
        nchan2  = nchan

c..ts_azim common
        do i = 1, 5
          azim2(i) = azim(i)
        enddo
        azimrx1 = azim(1)
        azimry1 = azim(2)
        azdir2  = azdir
        declin2 = declination

c..ts_start common
        stime2 = starttime

      else
        nchan2 = nchan1
      endif


c...open second RR file
      if( MULTI ) then 
        form = '?'
        write(*,*)'Opening remote-2 data file ==>', tswindowr2(iw)
        call ts_open( ind3, tswindowr2(iw), indat3, .FALSE., .FALSE. )
        write(*,*)'Opened remote-2 data file on unit', ind3,' ==>',
     &             indat3(1:lnblnk(indat3))
        call ts_rdinfo(ind3)

c..format common
        form3   = form
        format3 = format

c..ts_stat common
        statr2 = stat
        stat   = stattmp

c..ts_pos common
        lat3  = lat
        long3 = long
        elev3 = elev

c..ts_data common
        if( tunits.eq.'s' ) delta = 1./delta
        if(delta.ne.delta1) then
          write(*,*) 'Sampling rates differ between local and ',
     >               'remote data files.'
          stop
        endif
        delta3  = delta
        tunits3 = tunits
        nchan3  = nchan

c..ts_azim common
        do i = 1, 5
          azim3(i) = azim(i)
        enddo
        azimrx2 = azim(1)
        azimry2 = azim(2)
        azdir3  = azdir
        declin3 = declination

c..ts_start common
        stime3 = starttime

      else
        nchan3 = nchan1
      endif


      nchan = nchan1

      goto 320
  310 write (*,*)' Error opening DATA INPUT file, re-enter.'
      goto 300
  320 continue


c-------------------------------------------------------------------------------
c...get instrument number(s) from the windows file

      fout = 'windows.'//proj
      goto 405
  400 call tin (' Give the project windows file', fout )
  405 open ( ind4, file=fout, status='old', form='formatted', err=410 )
      go to 420
  410 write (*,*) ' ts2chave: Error opening WINDOWS file, re-enter'
      go to 400
  420 continue


      call getwindow( ind4, tswindow(iw), instr1, nchan1, 
     &                stime1, etime1 )
      if( iprint.ge.1 ) then
        write(*,*)' window start and end times:', stime1,'-',etime1
      endif
      sdur = tdiff( stime1, etime1 )
      if( RR ) then
        rewind( ind4 )
        call getwindow(ind4, tswindowr1(iw), instr2, nchan2, 
     &                 stime2, etime2)
        nchan2 = 2
        if( MULTI ) then
          rewind( ind4 )
          call getwindow(ind4, tswindowr2(iw), instr3, nchan3, 
     &                   stime3, etime3)
          nchan3 = 2
        else
          tswindowr2(iw) = tswindow(iw)
          instr3 = instr2
          nchan3 = nchan2
          stime3 = stime2
          etime3 = etime2
        endif
      else
        tswindowr1(iw) = tswindow(iw)
        instr2 = instr1
        nchan2 = nchan1
        stime2 = stime1
        etime2 = etime1
      endif
      close(unit=ind4)

c-------------------------------------------------------------------------------


      if( nchan1.eq.3 ) then
        if( mt.eq.'M' ) then
          write(*,*)'>>>>>Only 3 channels found: GDS processing to',
     &              ' be undertaken'
          mt = 'G'
        endif
      else if( nchan1.eq.4 ) then
        if( iprint.ge.1 ) write(*,*)'4 channels found'
      else if( nchan1.eq.5 ) then
        if( iprint.ge.1 ) write(*,*)'5 channels found'
      else
        write(*,*)'Weird number of channels; not 3 or 4 or 5 -- ',
     &            'don''''t know what to do now!'
        stop
      endif
c
c---nchan = total number of channels recorded on the data file.
c   delta is the sampling rate in Hz
c
      if( iprint.ge.1 ) then
        write(*,*) 'Sampling rate in Hz =', delta 
      end if

  900 if( iprint.ge.0 ) then
        write(*,'(2a)') 'Give the required event start time >',
     &            'yyyy-mm-dd hh:mn:ss'
      endif
      if( stime1.gt.stime2 ) then
        if( stime1.gt.stime3 ) then
          stime(iw) = stime1
        else
          stime(iw) = stime3
        endif
      else
        if( stime2.gt.stime3 ) then
          stime(iw) = stime2
        else
          stime(iw) = stime3
        endif
      endif
      call tin ( ' ', stime(iw) )
      if( datchk( stime(iw) ).ne.0 ) goto 900


905   if( iprint.ge.0 ) then
        write(*,'(2a)') 'Give the required event end   time >',
     &            'yyyy-mm-dd hh:mn:ss'
      end if
      if( etime1.lt.etime2 ) then
        if( etime1.lt.etime3 ) then
          etime(iw) = etime1
        else
          etime(iw) = etime3
        endif
      else
        if( etime2.lt.etime3 ) then
          etime(iw) = etime2
        else
          etime(iw) = etime3
        endif
      endif
      call tin ( ' ', etime(iw) )
      if( datchk( etime(iw) ).ne.0 ) goto 905


c...write out times
      write(*,*)'Start and end times.....'
      write(*,*)'Overlap = ', stime(iw), ' - ', etime(iw)
      write(*,*)'Local   = ', stime1,    ' - ', etime1
      if( RR ) then
        write(*,*)'Remote-1= ', stime2,    ' - ', etime2
      endif
      if( MULTI ) then
        write(*,*)'Remote-2= ', stime3,    ' - ', etime3
      endif


      call date( 0, stime(iw), yy, mm, dd, hh, min, ss )


c...sdur is the duration in seconds from the start time to the end
      sdur = tdiff( stime(iw), etime(iw) )

      dday  =  sdur/(60*60*24)
      dhour =  mod(sdur,60*60*24)/(60*60)
      dmin  =  mod(sdur,60*60)/60
      dsec  =  mod(sdur,60)

      if( iprint.ge.0 ) then
        write( dur, '(i4.4,a1,i2.2,a1,i2.2)') 
     &           dday, '/', dhour, '/', dmin
        write( *, '(2a)') 'Duration (dddd/hh/mm) : ', dur
      end if

      if(dday.eq.0 .and. dhour.eq.0 .and. dmin.eq.0 .and. dsec.eq.0)then
        dday  =  sdur/(60*60*24)
        dhour =  mod(sdur,60*60*24)/(60*60)
        dmin  =  mod(sdur,60*60)/60
        dsec  =  mod(sdur,60)
      endif


c...calculate the total number of seconds of data to be analysed.

      tsec = dday*86400 + dhour*3600 + dmin*60 + dsec

c...totn is the total number of entries required for analysis.
c
      totn =  float(tsec) * delta 
      nmax = ifix(totn)

      write(*,*) 'Total number of data requested:', nmax

c-------------------------------------------------------------------------------
c     write out co-ordinates and request direction for rotation

 
      write(*,*)'Co-ordinates of acquisition ==>'
      write(*,*)'Hx  =', azimhx, '  Ex =', azimex,
     &     '  Ey =', azimey, '  Coord sys: ', azdir1,
     &     'decl  =', declin1
      if( RR ) then
        write(*,*)'Rx1 =', azimrx1, 
     &            '                     Coord sys: ', azdir2,
     &            'decr1 =', declin2
        if( MULTI ) then
          write(*,*)'Rx2 =', azimrx2, 
     &            '                     Coord sys: ', azdir3,
     &            'decr2 =', declin3
        endif
      endif


c...get declination if site in magnetic co-ordinates and not read in
c   from time series
      if( QDECLIN .and. declin1.eq.-999. ) then
        if( index(azdir1, 'MAGNETIC').ne.0 .or.
     &      index(azdir2, 'MAGNETIC').ne.0 ) then
          call iin( 'Give declination', dec )
        endif
      endif

      if( index(azdir1, 'MAGNETIC').ne.0 ) then
        if( declin1.ne.-999. ) then
          decl = nint( declin1 )
        else
          decl = dec
        endif
      else
        decl = 0
      endif

      if( index(azdir2, 'MAGNETIC').ne.0 ) then
        if( declin2.ne.-999. ) then
          decr = nint( declin1 )
        else
          decr = dec
        endif
      else
        decr = 0
      endif

c...request co-ordinate system
      if( QROTANG ) then
        if( .NOT.AZIMSET ) azimuth = 0
        call iin( 'Desired co-ordinate system in TRUE NORTH', azimuth)
      endif

c...rotation angles required
      anghx  = float( azimuth - (azimhx + decl) )
      angex  = float( azimuth - (azimex + decl) )
      angey  = float( azimuth - (azimey + decl) + 90 )
      angrx1 = float( azimuth - (azimrx1 + decr) )
      angrx2 = float( azimuth - (azimrx2 + decr) )

c      if( iprint.ge.0 ) then
        write(*,*)'Rotation angles to be applied for azimuth ==>', 
     &                         azimuth
        write(*,*)'Ex  =', angex
        write(*,*)'Ey  =', angey
        write(*,*)'Hx  =', anghx
        if( RR ) then
          write(*,*)'Rx1 =', angrx1
          if( MULTI ) then
            write(*,*)'Rx2 =', angrx2
          endif
        endif
c      endif

c-------------------------------------------------------------------------------
c....skip data for data start times < stime


      if( stime1.lt.stime(iw) ) then
        nskip = tdiff( stime1, stime(iw) ) * delta
        write(*,*)'Skipping', nskip, '  data for local  file'
          form   = form1
          format = format1
        call ts_skip( ind1, nskip )
        if( nskip.lt.0 ) then
          write(*,*)'EOF reached for local file'
          stop
        endif
      endif

      if( RR ) then
        if( stime2.lt.stime(iw) ) then
          nskip = tdiff( stime2, stime(iw) ) * delta
          write(*,*)'Skipping', nskip, '  data for 1st remote file'
          form   = form2
          format = format2
          call ts_skip( ind2, nskip )
          if( nskip.lt.0 ) then
            write(*,*)'EOF reached for remote-1 file'
            stop
          endif
        endif
      endif

      if( MULTI ) then
        if( stime3.lt.stime(iw) ) then
          nskip = tdiff( stime3, stime(iw) ) * delta
          write(*,*)'Skipping', nskip, '  data for 2nd remote file'
          form   = form3
          format = format3
          call ts_skip( ind3, nskip )
          if( nskip.lt.0 ) then
            write(*,*)'EOF reached for remote-2 file'
            stop
          endif
        endif
      endif

c-------------------------------------------------------------------------------

      npt = 0

7     continue

c...read in data from local site 
      nchan = nchan1
      form  = form1
      format = format1
      call ts_in1(ind1, dat)
      if( dat(1).eq.EOF ) then
        write(*,*)'EOF found on local file'
        goto 30
      endif
      if( iprint.ge.3 ) then
        write(*,*) 'Input dat  =>', (dat(i),i=1,nchan1)
      endif

c...read in data from 1st remote site 
      if( RR ) then
        nchan = nchan2
        form  = form2
        format = format2
        call ts_in1(ind2, dat2)
        if( dat2(1).eq.EOF ) then
          write(*,*)'EOF found on remote-1 file'
          goto 30
        endif
        if( iprint.ge.3 ) then
          write(*,*) 'Input dat2 =>', (dat2(i),i=1,2)
        endif
      endif

c...read in data from 2nd remote site 
      if( MULTI ) then
        nchan = nchan3
        form  = form3
        format = format3
        call ts_in1(ind3, dat3)
        if( dat3(1).eq.EOF ) then
          write(*,*)'EOF found on remote-1 file'
          goto 30
        endif
        if( iprint.ge.3 ) then
          write(*,*) 'Input dat2 =>', (dat3(i),i=1,2)
        endif
      endif


      if ( nent .lt. 0 ) then
        if ( npt.gt.32 ) go to 30
        write(*, '(a)')' No data found. Program ending.'
        go to 9999
      end if


c
c      Channel     LIMS        Cascade      Jones       HSG
c         1         Hx           Ex           Hx         Gx
c         2         Hy           Ey           Hy         Gy
c         3         Hz           Hx           Ex
c         4         Ex           Hy           Ey
c         5         Ey           Hz           Hz         Hz
c         6         Rx           Rx           Rx         Rx
c         7         Ry           Ry           Ry         Ry
c

c...assign data input
      hx = dat(1)
      hy = dat(2)
      if( nchan1.eq.3 .or. nchan1.eq.5 ) then
        hz = dat(3)
        ex = dat(4)
        ey = dat(5)
      else if( nchan1.eq.4 ) then
        hz = 0.
        ex = dat(3)
        ey = dat(4)
      endif

      if( RR ) then
        rx1 = dat2(1)
        ry1 = dat2(2)
        if( MULTI ) then
          rx2 = dat3(1)
          ry2 = dat3(2)
        else
          rx2 = rx1
          ry2 = ry1
        endif
      else
        rx1 = hx
        ry1 = hy
        rx2 = hx
        ry2 = hy
      endif


c...check not equal to misdat: if equal to misdat, set to last good value

      if( hx.gt.misdat*0.99999.and.hx.lt.misdat*1.00001) hx = hxl
      if( hy.gt.misdat*0.99999.and.hy.lt.misdat*1.00001) hy = hyl
      if( hz.gt.misdat*0.99999.and.hz.lt.misdat*1.00001) hz = hzl
      if( ex.gt.misdat*0.99999.and.ex.lt.misdat*1.00001) ex = exl
      if( ey.gt.misdat*0.99999.and.ey.lt.misdat*1.00001) ey = eyl
      if( rx1.gt.misdat*0.99999.and.rx1.lt.misdat*1.00001) rx1 = rxl1
      if( ry1.gt.misdat*0.99999.and.ry1.lt.misdat*1.00001) ry1 = ryl1
      if( rx2.gt.misdat*0.99999.and.rx2.lt.misdat*1.00001) rx2 = rxl2
      if( ry2.gt.misdat*0.99999.and.ry2.lt.misdat*1.00001) ry2 = ryl2

      hxl  = hx
      hyl  = hy
      hzl  = hz
      exl  = ex
      eyl  = ey
      rxl1 = rx1
      ryl1 = ry1
      rxl2 = rx2
      ryl2 = ry2


c...perform rotations (if required) in time domain

      if( (anghx+angex+angey+angrx1+angrx2).ne.0. .and. 
     &                                      iprint.ge.3 ) then
        write(*,*) 'Pre-rot  =>',hx,hy,ex,ey,rx1,ry1,rx2,ry2
      endif
      if( anghx.ne.0. ) then
        call rotdat( hx, hy, anghx, anghx )
      endif

      if( angex.ne.0. .or. angey.ne.0. ) then
        call rotdat( ex, ey, angex, angey )
      endif

      if( angrx1.ne.0. ) then
        call rotdat( rx1, ry1, angrx1, angrx1 )
      endif

      if( angrx2.ne.0. ) then
        call rotdat( rx2, ry2, angrx2, angrx2 )
      endif

      if( (anghx+angex+angey+angrx1+angrx2).ne.0. .and. 
     &                                      iprint.ge.3 ) then
        write(*,*) 'Post-rot =>',hx,hy,ex,ey,rx1,ry1,rx2,ry2
      endif


c...write data  out

      if(FORMAT_OUTPUT) then
         ib=1
      else
         ib=ib+1
         if(ib.eq.nblock) then
            WRITE_DATA = .TRUE.
         else
            WRITE_DATA = .FALSE.
         endif
      endif

      if( mt.eq.'M' ) then
        A(ib,1) = ex
        A(ib,2) = ey
      end if

      if( HSG ) then
        A(ib,3) = hx + hy
        A(ib,4) = hx + hy
        A(ib,5) = hz
      else
        A(ib,3) = hx
        A(ib,4) = hy
        A(ib,5) = hz
      endif

      if( RR )then
         A(ib,6) = rx1
         A(ib,7) = ry1
      endif

      if( MULTI )then
         A(ib,8) = rx2
         A(ib,9) = ry2
      endif



      if( iprint.ge.3 ) then
        write(*,*) 'Points to write ==>'
        write(*,*)(a(ib,i),i=1,9)
      end if

      if(FORMAT_OUTPUT) then
         do i = 1, nchanout
            iunit = 10 + i
            write(iunit,*) a(1,i)
         end do   
      else
         if(WRITE_DATA) then
            do i = 1, nchanout
               iunit = 10 + i
               write(iunit) (a(j,i),j=1,ib)
            enddo   
            ib=0
         endif
      endif
      NPT = NPT+1

      IF(NPT-NMAX) 7,9999,9999

9999  continue


c...flush data still in buffer: fill to end of block with zeroes
30    if( .not.FORMAT_OUTPUT .and. ib.gt.0 ) then
        do i = 1, nchanout
          iunit = 10 + i
          write(iunit) (a(j,i),j=1,ib), (0.0,j=ib+1,nblock)
        end do  
      endif

      write(*,*)' Number of points written: ', npt
      nptw(iw) = npt

1000  continue

c...end of "nwindow" loop
c-------------------------------------------------------------------------------
c...write out input file for use with Chave's code

      close(unit=7)
      open(unit=7,file=stat//'_rrrmt_in')
      write(*,'(2a)')'Opening file for input params to rrrmt.9: ',
     &               stat//'_rrrmt_in'

      write(7,'(a)') '3'                        !3 outputs
      write(7,'(a)') '2'                        !2 inputs
      if( MULTI ) then
        write(7,'(a)') '4'                      !4 remote series
        write(7,'(a)') '0 2'                    !0 3-comp & 2 2-comp ref sites
      else
        write(7,'(a)') '2'                      !2 remote series
      endif
      if( .not.MULTI ) then
        write(7,'(a)') '1'                      !1 2-stage robust method
      endif
      write(7,'(a)') '1'                        !1 prolate
      write(7,'(a)') '16384 2 11'               !FFT, subdiv, no.
      write(7,'(a)') '3 2'                      !3rd & 4th harmonics
      write(7,'(a)') '1.e-4 4'                  !robust parameters
      write(7,'(a)') '0.5 0.1'                  !1st stage coh thresh & trim
      write(7,'(a)') '0.75 0.1'                 !2nd stage coh thresh & trim
      write(7,'(a)') '0'                        !3rd variable threshold mode
      write(7,'(a)') '0.75 0.1'                 !2nd stage coh thresh & trim
      write(7,'(a)') '10'                       !coh block size
      write(7,'(a)') '0.0 0.5'                  !lower & upper frequencies
      write(7,'(a)') stat//'/'//stat            !station - root name
      write(7,'(a)') '0'                        !output level
      write(7,'(a)') '0'                        !no freq rej
      write(7,'(a)') '1'                        !1 filter param
      write(7,'(i2)') nwindow                   !nwindow pieces
      write(7,'(a)') '5'                        !AR length

c...Ex
      if( FORMAT_OUTPUT ) then
        write(7,'(a)') 'f'                      !formatted
      else
        write(7,'(a)') 'u'                      !unformatted
        write(7,*) nblock                       !blocking factor
      endif
      write(7,*) delta/30000.                   !low-pass filter
      do iw = 1, nwindow
        write(7,'(a)') stat//'/'//tswindow(iw)//
     &               tswindowr1(iw)(4:8)//'.ex' !ex input file
        write(7,*) 0, nptw(iw)                  !nskip, nread
      enddo
c...Ey
      if( FORMAT_OUTPUT ) then
        write(7,'(a)') 'f'                      !formatted
      else
        write(7,'(a)') 'u'                      !unformatted
        write(7,*) nblock                       !blocking factor
      endif
      write(7,*) delta/30000.                   !low-pass filter
      do iw = 1, nwindow
        write(7,'(a)') stat//'/'//tswindow(iw)//
     &               tswindowr1(iw)(4:8)//'.ey' !ey input file
        write(7,*) 0, nptw(iw)                  !nskip, nread
      enddo

c...Hz
      if( FORMAT_OUTPUT ) then
        write(7,'(a)') 'f'                    !formatted
      else
        write(7,'(a)') 'u'                    !unformatted
        write(7,*) nblock                     !blocking factor
      endif
      write(7,*) 0.0                          !low-pass filter
      do iw = 1, nwindow
        write(7,'(a)') stat//'/'//tswindow(iw)//
     &               tswindowr1(iw)(4:8)//'.hz' !hz input file
        write(7,*) 0, nptw(iw)                  !nskip, nread
      enddo

c...Hx
      if( FORMAT_OUTPUT ) then
        write(7,'(a)') 'f'                    !formatted
      else
        write(7,'(a)') 'u'                    !unformatted
        write(7,*) nblock                     !blocking factor
      endif
      write(7,*) 0.0                          !low-pass filter
      do iw = 1, nwindow
        write(7,'(a)') stat//'/'//tswindow(iw)//
     &               tswindowr1(iw)(4:8)//'.hx' !hx input file
        write(7,*) 0, nptw(iw)                  !nskip, nread
      enddo

c...Hy
      if( FORMAT_OUTPUT ) then
        write(7,'(a)') 'f'                    !formatted
      else
        write(7,'(a)') 'u'                    !unformatted
        write(7,*) nblock                     !blocking factor
      endif
      write(7,*) 0.0                          !low-pass filter
      do iw = 1, nwindow
        write(7,'(a)') stat//'/'//tswindow(iw)//
     &               tswindowr1(iw)(4:8)//'.hy' !hy input file
        write(7,*) 0, nptw(iw)                  !nskip, nread
      enddo

c...Rx1
      if( FORMAT_OUTPUT ) then
        write(7,'(a)') 'f'                    !formatted
      else
        write(7,'(a)') 'u'                    !unformatted
        write(7,*) nblock                     !blocking factor
      endif
      write(7,*) 0.0                          !low-pass filter
      do iw = 1, nwindow
        if( RR ) then
          write(7,'(a)') stat//'/'//tswindow(iw)//
     &                 tswindowr1(iw)(4:8)//'.rx' !rx input file
        else
          write(7,'(a)') stat//'/'//tswindow(iw)//
     &                 tswindowr1(iw)(4:8)//'.hx' !hx input file
        endif
        write(7,*) 0, nptw(iw)                  !nskip, nread
      enddo

c...Ry1
      if( FORMAT_OUTPUT ) then
        write(7,'(a)') 'f'                    !formatted
      else
        write(7,'(a)') 'u'                    !unformatted
        write(7,*) nblock                     !blocking factor
      endif
      write(7,*) 0.0                          !low-pass filter
      do iw = 1, nwindow
        if( RR ) then
          write(7,'(a)') stat//'/'//tswindow(iw)//
     &                 tswindowr1(iw)(4:8)//'.ry' !ry input file
        else
          write(7,'(a)') stat//'/'//tswindow(iw)//
     &                     tswindowr1(iw)(4:8)//'.hy' !hy input file
        endif
        write(7,*) 0, nptw(iw)                  !nskip, nread
      enddo

c...Rx2
      if( FORMAT_OUTPUT ) then
        write(7,'(a)') 'f'                    !formatted
      else
        write(7,'(a)') 'u'                    !unformatted
        write(7,*) nblock                     !blocking factor
      endif
      write(7,*) 0.0                          !low-pass filter
      do iw = 1, nwindow
        if( RR ) then
          write(7,'(a)') stat//'/'//tswindow(iw)//
     &                 tswindowr2(iw)(4:8)//'.rx' !rx input file
        else
          write(7,'(a)') stat//'/'//tswindow(iw)//
     &                 tswindowr2(iw)(4:8)//'.hx' !hx input file
        endif
        write(7,*) 0, nptw(iw)                  !nskip, nread
      enddo

c...Ry2
      if( FORMAT_OUTPUT ) then
        write(7,'(a)') 'f'                    !formatted
      else
        write(7,'(a)') 'u'                    !unformatted
        write(7,*) nblock                     !blocking factor
      endif
      write(7,*) 0.0                          !low-pass filter
      do iw = 1, nwindow
        if( RR ) then
          write(7,'(a)') stat//'/'//tswindow(iw)//
     &                 tswindowr2(iw)(4:8)//'.ry' !ry input file
        else
          write(7,'(a)') stat//'/'//tswindow(iw)//
     &                     tswindowr2(iw)(4:8)//'.hy' !hy input file
        endif
        write(7,*) 0, nptw(iw)                  !nskip, nread
      enddo

      write(7,'(a)') '0 90 0'
      write(7,'(a)') '0 90 0'
      write(7,'(a)') '0 90 0'
      if( MULTI ) then
        write(7,'(a)') '0 90 0'
      endif
      close(unit=7)

c...write out header file to add to start of response file
      open(unit=7,file=stat//'/'//stat//'.blk')
      write(*,'(2a)')'Opening file for header blocks: ',
     &          stat//'/'//stat//'.blk'
      write(7,'(a)') '# ts2chave9: ver='//ver
      write(7,'(a)') '# date: '//date_string
      write(7,'(a)') '#'
      write(7,'(a,i2)') '# no. of windows =', nwindow
      write(7,'(a)') '#'
      do iw = 1, nwindow
      write(7,'(a,i2)') '# window:', iw
      write(7,'(a)') '# tswindow  : '//tswindow(iw)
      write(7,'(a)') '# tswindowr1: '//tswindowr1(iw)
      write(7,'(a)') '# tswindowr2: '//tswindowr2(iw)
      write(7,'(a)') '#'
      write(7,'(a)') '# window start :'//stime(iw)
      write(7,'(a)') '# window end   :'//etime(iw)
      write(7,'(a)') '#'
      enddo
      write(7,'(a,i3)' ) '# azimuth    : ', azimuth
      write(7,'(a)') '#'
      write(7,'(a,f7.1)' ) '# Ex rotation: ', angex
      write(7,'(a,f7.1)' ) '# Ey rotation: ', angey
      write(7,'(a,f7.1)' ) '# Hx rotation: ', anghx
      write(7,'(a,f7.1)' ) '# Hy rotation: ', anghx
      if( RR ) then
        write(7,'(a,f7.1)' ) '# Rx1 rotation: ', angrx1
        write(7,'(a,f7.1)' ) '# Ry1 rotation: ', angrx1
      endif
      if( MULTI ) then
        write(7,'(a,f7.1)' ) '# Rx2 rotation: ', angrx2
        write(7,'(a,f7.1)' ) '# Ry2 rotation: ', angrx2
      endif
      write(7,'(a)') '#'
      write(7,'(a)') '# Acquisition coordinates: '
      write(7,'(a)') '#'
      write(7,'(a)')     '# Local site :'//tswindow(1)(1:6)
      write(7,'(2a)' )   '# coord_sys  : ', azdir1
      write(7,'(a,i3)' ) '# declination: ', decl
      write(7,'(a,i3)' ) '# Ex azimuth : ', azimex
      write(7,'(a,i3)' ) '# Ey azimuth : ', azimey
      write(7,'(a,i3)' ) '# Hx azimuth : ', azimhx
      write(7,'(a,i3)' ) '# Hy azimuth : ', azimhy
      if( RR ) then
        write(7,'(a)')     '#'
        write(7,'(a)')     '# Remote site:'//statr1
        write(7,'(2a)' )   '# coord_sys  : ', azdir2
        write(7,'(a,i3)' ) '# declination: ', decl
        write(7,'(a,i3)' ) '# Rx azimuth : ', azimrx1
        write(7,'(a,i3)' ) '# Ry azimuth : ', azimry1
      endif
      if( MULTI ) then
        write(7,'(a)')     '#'
        write(7,'(a)')     '# Remote site:'//statr2
        write(7,'(2a)' )   '# coord_sys  : ', azdir3
        write(7,'(a,i3)' ) '# declination: ', decl
        write(7,'(a,i3)' ) '# Rx azimuth : ', azimrx2
        write(7,'(a,i3)' ) '# Ry azimuth : ', azimry2
      endif
      write(7,'(a)') '#'

      write(7,'(a  )') '>STATION   ='//stat
      if( RR ) then
        write(7,'(a  )') '>STATION_RR='//statr1
      endif
      write(7,'(a12,f12.1)') '>AZIMUTH   =', float(azimuth)
      write(7,'(a12,f12.4)') '>LATITUDE  =', lat1
      write(7,'(a12,f12.4)') '>LONGITUDE =', long1
      write(7,'(a12,f12.1)') '>ELEVATION =', elev1



      stop 'Done.'
      END
