c  tsactivity: v5.0: 08 April 1999
c
c  1. derives energy histogram of each series and write to screen and file
c     (tsactivity.hist)
c
c  2. requests user for maximum permitted activity level and minimum
c     length of time
c


      implicit none

      include 'version.inc'
      include 'defaults.inc'
      include 'ctrlblk.inc' 
      include 'io.inc' 
      include 'infoblk.inc'
      include 'bdate.inc'

      integer MAXWINDOW
      parameter ( MAXWINDOW = 10 )

      integer narg, getnarg, i, instr, nseg

      real dat(5), delta, binm(5), binp(5), bound, boundl, boundu
      real datmax(5), datmin(5)
      integer in, out, ind, inc, daterr
      integer yy, mm, dd, hh, min, ss
      integer nchan, nmin
      integer nskip, ipt, npt, npttot, nptall
      integer bins(5,-50:50), ibin, ichan, bincum, bincuml
      integer onem, onep, twom, twop, median
      integer nacpt, nstart, nend

      integer tdiff, sdur
      real binw(5)

      character title*20, indat*40, fout*20
      character proj*3, sep*1 
      character*8 tswindow
      character*6 stat
      character*3 statnum
      character*19 stime, etime, nowtim
      character*10 cmdarg
      character*1 mt
      character*13 dur

      logical HIST

      external date

c-------------------------------------------------------------------------------
c     Initialize variables and arrays.

      call dirsep(sep)
      inc = 2
      ind = 4
      do i = 1, 5
        datmax(i) = -1.e32
        datmin(i) =  1.e32
      enddo

c-------------------------------------------------------------------------------
c     get command-line arguments

      narg = getnarg()
      do i = 1, narg
        call getcmdarg( i, cmdarg)
        if( index(cmdarg,'h').ne.0 ) then
          write(*,*)'Permitted options:-'
          write(*,*)'                    -1 -> 3  iprint level'
          stop
        else
          read(cmdarg,'(i2)') iprint
        endif
      enddo

      call iin( 'Give print level (-1/0/1/2/3)',iprint)


c-------------------------------------------------------------------------------

      if( iprint.ge.1 ) then
        write(*,*)' '
        write(*,*)' >>>>>>>>>>>>> TSACTIVITY <<<<<<<<<<<<<<<<<'
        write(*,*)' '
        write(*,*)'           version = ', ver
        write(*,*)'build date = ', bdate
        write(*,*)' '
        write(*,*)'It is assumed that this program is being run from'
        write(*,*)'the database directory of the project '
        write(*,*)'(e.g. /local/mt/lims/nod)  '
        write(*,*)'and that all data files reside in subdirectories'
        write(*,*)'with the respective station names '
        write(*,*)'(e.g. /local/mt/lims/nod/nod001 nod002 etc.)'
        write(*,*)' '
        write(*,*)'windows and hardware database files are required'
        write(*,*)'(e.g. windows.nod & hardware.nod) '
        write(*,*)' '
      end if

c-------------------------------------------------------------------------------

      tswindow = 'tbt101ss'
300   call tin( 'Give window (extension assumed)', tswindow )

      proj = tswindow(1:3)
      stat = tswindow(1:6)
      statnum = stat(4:6)
      title(1:12) = tswindow

      if( iprint.ge.1 ) write(*,*)'Station =>', stat

c-------------------------------------------------------------------------------
c   Get bin widths

      binw(1) = 1
      binw(2) = 1
      binw(3) = 1
      binw(4) = 1
      binw(5) = 1


c-------------------------------------------------------------------------------
c
c Open the output data files
      open(unit=7,file='times.'//statnum)
      write(*,*)'Opened output times file ==>', 'times.'//statnum

c-------------------------------------------------------------------------------
c
c Open the data file and Read in the window and header file information.
c

      form = '?'
      write(*,*)'Opening input file for window ', tswindow
      call ts_open( ind, tswindow, indat, .FALSE., .FALSE. )
      write(*,*)'Opened data file =>',indat

      HIST = .TRUE.
      call lin('Perform histogram', HIST )
      if( .not.HIST ) goto 100

      open(unit=8,file='tsactivity.hist')
      write(*,*)'Opened histrogram output file: tsactivity.hist'

      call ts_rdinfo(ind)

      if( iprint.ge.1 ) then
        write(*,*)'Information block from input file...'
        write(*,*)'STATION   :', stat
        write(*,*)'WINDOW    :', tswindow
        write(*,*)'LATITUDE  :', lat
        write(*,*)'LONGITUDE :', long
        write(*,*)'ELEVATION :', elev
        write(*,*)'COORD_SYS :', azdir
        write(*,*)'FORM      :', form
        write(*,*)'FORMAT    :', format
        write(*,*)'NCHAN     :', nchan
        do i = 1, nchan
          write(*,*)'Channel......:', i
          write(*,*)'CHAN    :', chan(i)
          write(*,*)'AZIM    :', azim(i)
          write(*,*)'GAIN    :', gain(i)
          write(*,*)'UNITS   :', units(i)
        enddo
        write(*,*)'STARTTIME :', starttime
      endif

       call rin( 'Give bin width', binw(1))
       do i = 2, 5
         binw(i) = binw(1)
       enddo

      fout = 'windows.'//proj
      open ( inc, file=fout, status='old', form='formatted', err=9999 )
      call getwindow( inc, tswindow, instr, nchan, stime, etime )
      if( iprint.ge.1 ) then
        write(*,*)' window start and end times:', stime,'-',etime
      endif
      sdur = tdiff( stime, etime )
      close(inc)


      if( nchan.eq.3 ) then
        if( mt.eq.'M' ) then
          write(*,*)'>>>>>Only 3 channels found: GDS processing to',
     &              ' be undertaken'
          mt = 'G'
        endif
      else if( nchan.eq.4 ) then
        if( iprint.ge.1 ) write(*,*)'4 channels found'
      else if( nchan.eq.5 ) then
        if( iprint.ge.1 ) write(*,*)'5 channels found'
      else
        write(*,*)'Wierd number of channels; not 3 or 4 or 5 -- ',
     &            'don''''t know what to do now!'
        stop
      endif
c
c---nchan = total number of channels recorded on the data file.
c   delta is the sampling rate in Hz
c
      if( iprint.ge.1 ) then
        write(*,*) 'Sampling rate in Hz =', delta 
      end if

  900 if( iprint.ge.0 ) then
        write(*,'(2a)') 'Give the required event start time   >',
     &            'yyyy-mm-dd hh:mm:ss'
      endif
      call tin( 'Default is', stime )
      call date( 0, stime, yy, mm, dd, hh, min, ss )
      if( iprint.ge.2 ) then
        write(*,*)'stime=',stime
        write(*,*)' yy, mm, dd, hh, min =>', yy, mm, dd, hh, min, ss
      endif

      call chkdat ( yy, mm, dd, hh, min, ss, daterr )
      if( daterr .gt. 0 ) go to 900


905   if( iprint.ge.0 ) then
        write(*,'(2a)') 'Give the required event end   time   >',
     &            'yyyy-mm-dd hh:mm:ss'
      end if
      call tin( 'Default is', etime )
      call date( 0, etime, yy, mm, dd, hh, min, ss )
      if( iprint.ge.2 ) then
        write(*,*)'etime=',etime
        write(*,*)' yy, mm, dd, hh, min =>', yy, mm, dd, hh, min, ss
      end if

      call chkdat ( yy, mm, dd, hh, min, ss, daterr )
      if( daterr .gt. 0 ) go to 905


      call date( 0, stime, yy, mm, dd, hh, min, ss )


c...sdur is the duration in seconds from the start time to the end
      sdur = tdiff( stime, etime )
      nptall = sdur / delta
      npt    = nptall
      call duration( stime, etime, dur )

      if( iprint.ge.0 ) then
        write(*,*) 'Duration (dddd/hh/mm) : ', dur
        write(*,*) 'No. of points =', nptall
      endif


c-------------------------------------------------------------------------------
c....skip data for data start times < stime
      if( starttime.lt.stime ) then
        nskip = tdiff( starttime, stime ) * delta
        write(*,*)'Skipping', nskip, '  data for local  file'
        call ts_skip( ind, nskip )
      endif

c-------------------------------------------------------------------------------

      do ipt = 1, npt
        call ts_in1(ind, dat)

        if( dat(1).eq.EOF ) goto 30
        if( iprint.ge.3 ) then
          write(*,*) 'Input dat  =>', (dat(i),i=1,nchan)
        endif


c...assign to bins & determine max & min
        do 20 ichan = 1, nchan

          if( dat(ichan).eq.misdat ) goto 20

          if( dat(ichan).gt.datmax(ichan) ) datmax(ichan) = dat(ichan)
          if( dat(ichan).lt.datmin(ichan) ) datmin(ichan) = dat(ichan)

          ibin = nint( dat(ichan)/binw(ichan) )
          if( ibin.le.-50) ibin = -50
          if( ibin.gt.50 ) ibin = 50
          bins(ichan,ibin) = bins(ichan,ibin) + 1
20      continue
      enddo

30    do ibin = -50, 50, 1
        write(*,'(f,5i10)') float(ibin)*binw(1), 
     &                    (bins(i,ibin),i=1,nchan)
        if( HIST ) then
          write(8,*) float(ibin)*binw(1), 
     &                    (bins(i,ibin),i=1,nchan)
        endif
      enddo

c...calculate +/-1 and +/-2 standard errors

      twom = nint(0.025*npt)
      onem = nint(0.16 *npt)
      median = nint(0.5 *npt)
      onep = nint(0.84 *npt)
      twop = nint(0.975*npt)
      write(*,*)'2-, 1-, 1+, 2+ =',twom,onem,onep,twop

      do ichan = 1, nchan
        write(*,*)'Channel ...', ichan
           write(*,*)'Minimum value              =', datmin(ichan)
        bincum = bins(ichan,-50)
        do ibin = -49, 50, 1
          bincuml = bincum
          bincum = bincum + bins(ichan,ibin)
          if( bincuml.le.twom .and. bincum.ge.twom ) then
           write(*,*)'Straddled 2- boundary: bin =',float(ibin)*binw(1)
          else if( bincuml.le.onem .and. bincum.ge.onem ) then
           write(*,*)'Straddled 1- boundary: bin =',float(ibin)*binw(1)
          else if( bincuml.le.median .and. bincum.ge.median ) then
           write(*,*)'Straddled median     : bin =',float(ibin)*binw(1)
           binm(ichan) = float(ibin)*binw(1)
          else if( bincuml.le.onep .and. bincum.ge.onep ) then
           write(*,*)'Straddled 1+ boundary: bin =',float(ibin)*binw(1)
           binp(ichan) = float(ibin)*binw(1)
          else if( bincuml.le.twop .and. bincum.ge.twop ) then
           write(*,*)'Straddled 2+ boundary: bin =',float(ibin)*binw(1)
          endif
        enddo
           write(*,*)'Maximum value              =', datmax(ichan)
      enddo


c...request channel and bounds and minimum no. of points
100   ichan = 1
      call iin('Give channel to use', ichan)
      bound = (binp(ichan)-binm(ichan))/2.
      boundl = -bound
      call rin('Give lower bound to use', boundl)
      boundu = -boundl
      call rin('Give upper bound to use', boundu)

      nmin = 3*60*60/delta
      call iin('Give minimum number of points', nmin)
      dd = nmin*delta/(24*60*60)
      hh = nmin*delta/(   60*60) - dd*24
      mm = nmin*delta/(      60) - (dd*24 + hh)*60
      ss = nmin*delta  - ((dd*24 + hh)*60 + mm)*60
      write(*,'(4(a,i2.2))')'Minimum time (dd:hh:mm:ss) = ',
     &                      dd,':',hh,':',mm,':',ss


c-------------------------------------------------------------------------------
c...write header info to times file


      write(7,'(2a)')'# TS file: ', tswindow
      write(7,'(a,i1)')'# Channel: ', ichan
      write(7,'(2a)')'# Starttime: ', starttime
      write(7,'(2a)')'#   Endtime: ',   endtime
      write(7,'(2a)')'#  Duration: ', dur
      write(7,'(a,f5.1,a,f5.1)')'# Bounds : ', boundl,'  -', boundu
      write(7,'(4(a,i2.2))')'# Minimum time (dd-hh:mm:ss) = ',
     &                      dd,'-',hh,':',mm,':',ss

c-------------------------------------------------------------------------------
c...rewind data file to beginning
      rewind(unit=ind)


c...read over info block
      call ts_rdinfo( ind )

c...set counters to zero
      nseg = 0
      npttot = 0

      do ipt = 1, nptall
        call ts_in1(ind, dat)
        if( dat(1).eq.EOF ) goto 9000

        if( dat(ichan).lt.boundl .or.
     &      dat(ichan).gt.boundu .or.
     &      dat(ichan).eq.misdat  ) then
          nacpt = nend - nstart + 1
          if( nacpt .gt. nmin ) then
            npttot = npttot + nacpt
            nseg = nseg + 1
            stime = nowtim( starttime, 0, 0, 0, nstart*nint(delta) )
            etime = nowtim( starttime, 0, 0, 0, nend*nint(delta) )
            ss = tdiff( stime, etime )
            dd = ss/(24*60*60)
            hh = ss/(   60*60) - dd*24
            mm = ss/(      60) - (dd*24 + hh)*60
            ss = ss  - ((dd*24 + hh)*60 + mm)*60
            write(*,'(3a,4(a,i2.2),a,i5)') stime,' - ', etime,
     &             '   Time:', dd,':',hh,':',mm,':',ss, '   Points:',
     &            nacpt
            write(7,'(a14,a1,a14)')
     &        stime(1:4)//stime(6:7)//stime(9:10)//stime(12:13)//
     &        stime(15:16)//stime(18:19),
     &        '-',
     &        etime(1:4)//etime(6:7)//etime(9:10)//etime(12:13)//
     &        etime(15:16)//etime(18:19)

          endif
          nstart = ipt + 1
        else
          nend = ipt
        endif
      enddo
      write(*,*)'Total number of points    :', nptall
      write(*,*)'No. of points in intervals:', npttot
      write(*,*)'Percentage used           :', 100*npttot/nptall


9000  if( nseg.eq.0 ) then
        write(*,*)'NO SEGMENTS WRITTEN TO times.xxx FILE'
      else
        write(*,*)'No. of segments written to times.xxx file =',
     &             nseg
      endif
      stop 'Done.'

9999  stop 'Error '
      END
