c
c     tsextract
c
c     extracts a section from a ts format file
c
      implicit none

      include 'io.inc'
      include 'ctrlblk.inc'
      include 'infoblk.inc'
      include 'version.inc'
      include 'bdate.inc'

      character*1 sep
      character*10 cmdarg
      integer narg, getnarg

      character tswindow*8, fin*30, fout*30, line*80
      character*19 stime, etime
      character*24 date_string
      integer i, j
      real data(5)

      integer nskip, tdiff, nread

c-------------------------------------------------------------------------------
c     get date

      call fdate(date_string)

c-------------------------------------------------------------------------------
c     Initialize variables and arrays.

      call dirsep(sep)

c-------------------------------------------------------------------------------
c     get command-line arguments

      narg = getnarg()
      do i = 1, narg
        call getcmdarg( i, cmdarg)
        if( index(cmdarg,'h').ne.0 ) then
          write(*,*)'Permitted options:-'
          write(*,*)'                    -1 -> 3  iprint level'
          stop
        else
          read(cmdarg,'(i2)') iprint
        endif
      enddo

      call iin( 'Give print level (-1/0/1/2/3)',iprint)


c-------------------------------------------------------------------------------

      if( iprint.ge.1 ) then
        write(*,*)' '
        write(*,*)' >>>>>>>>>>>>> TSEXTRACT <<<<<<<<<<<<<<<<<'
        write(*,*)' '
        write(*,*)'           version = ', ver
        write(*,*)'build date = ', bdate
        write(*,*)' '
        write(*,*)'It is assumed that this program is being run from'
        write(*,*)'the database directory of the project '
        write(*,*)'(e.g. /local/mt/lims/nod)  '
        write(*,*)'and that all data files reside in subdirectories'
        write(*,*)'with the respective station names '
        write(*,*)'(e.g. /local/mt/lims/nod/nod001 nod002 etc.)'
        write(*,*)' '
        write(*,*)'windows and hardware database files are required'
        write(*,*)'(e.g. windows.nod & hardware.nod) '
        write(*,*)' '
      endif

c-------------------------------------------------------------------------------

      tswindow = ' '
      form = '?'
      call ts_open(ind1,tswindow,fin,.TRUE.,.FALSE.)

      tswindow(7:8) = 'ex'
      call tin( 'Give output window name', tswindow )
      fout = tswindow(1:6)//'/'//tswindow//'.ts'
      open(unit=outd1,file=fout,form='unformatted')
      write(*,*)'Opened UNFORMATTED output file...', fout

c...read in and write out comment block
c
      read(ind1) line
      do while( line(1:1).eq.'#' )
        write(outd1) line
        read(ind1) line
      enddo
c
      call ts_rdinfo(ind1)

      stime = starttime
      call tin( 'Give start time of required extract', stime )
      etime = endtime
      call tin( 'Give end   time of required extract', etime )

      if( tunits.eq.'Hz' ) then
        nskip = tdiff( starttime, stime ) * delta
        nread = tdiff(     stime, etime ) * delta
      else if( tunits.eq.'s' ) then
        nskip = tdiff( starttime, stime ) / delta
        nread = tdiff(     stime, etime ) / delta
      else
        write(*,*)'Time units not recognised >', tunits
        write(*,*)'only "s" or "Hz" permitted'
        stop
      endif

c...read data and skip over nskip entries
      if( nskip.gt.0 ) then
        write(*,*) 'Skipping',nskip,' entries'
        call ts_skip( ind1, nskip )
      endif

      starttime = stime
      endtime   = etime
      call ts_wrtinfo(outd1)

c...read in data
      write(*,*) 'Reading and writing',nread,' entries'
      do j = 1, nread
        if( format.eq.'UNFORMATTED' ) then
          read ( ind1,end=9999) (data(i),i=1,nchan)
          write(outd1)          (data(i),i=1,nchan)
        else if( format.eq.'FREE' ) then
          read ( ind1,*,end=9999) (data(i),i=1,nchan)
          write(outd1,*)          (data(i),i=1,nchan)
        else 
          read ( ind1,format,end=9999) (data(i),i=1,nchan)
          write(outd1,format)          (data(i),i=1,nchan)
        endif
      enddo

9999  stop
      end
