      program tshead_edit
      
      implicit none
      
      include 'infoblk.inc'
      include 'ctrlblk.inc' 
      include 'version.inc' 
      include 'bdate.inc' 

      character*1 sep
      character*10 cmdarg
      integer narg, getnarg
 
      character*24 date_string

      real data(5)

      integer ind, outd, lnblnk, i
      character tswindow*8, fin*40, line*80, line2*80, 
     &          ans*1, value*20


c-------------------------------------------------------------------------------
c     get date

      call fdate(date_string)

c-------------------------------------------------------------------------------
c     Initialize variables and arrays.

      call dirsep(sep)

      ind  = 4
      outd = 7

c-------------------------------------------------------------------------------
c     get command-line arguments

      narg = getnarg()
      do i = 1, narg
        call getcmdarg( i, cmdarg)
        if( index(cmdarg,'h').ne.0 ) then
          write(*,*)'Permitted options:-'
          write(*,*)'                    -1 -> 3  iprint level'
          stop
        else
          read(cmdarg,'(i2)') iprint
        endif
      enddo

      call iin( 'Give print level (-1/0/1/2/3)',iprint)


c-------------------------------------------------------------------------------

      if( iprint.ge.1 ) then
        write(*,*)' '
        write(*,*)' >>>>>>>>>>>>> TSEXTRACT <<<<<<<<<<<<<<<<<'
        write(*,*)' '
        write(*,*)'           version = ', ver
        write(*,*)'build date = ', bdate
        write(*,*)' '
        write(*,*)'It is assumed that this program is being run from'
        write(*,*)'the database directory of the project '
        write(*,*)'(e.g. /local/mt/lims/nod)  '
        write(*,*)'and that all data files reside in subdirectories'
        write(*,*)'with the respective station names '
        write(*,*)'(e.g. /local/mt/lims/nod/nod001 nod002 etc.)'
        write(*,*)' '
        write(*,*)'windows and hardware database files are required'
        write(*,*)'(e.g. windows.nod & hardware.nod) '
        write(*,*)' '
      endif

c-------------------------------------------------------------------------------

      form = '?'
      tswindow='tbt101ss'
      call ts_open(ind,tswindow,fin, .TRUE., .FALSE.)
      line = tswindow//'.ts_edit'


      if( form.eq.'ASCII' ) then
        open(unit=outd,file=line,form='formatted')
        write(*,*)'Output file opened in ASCII mode=>', 
     &              line(1:lnblnk(line))
      elseif( format.eq.'BINARY' ) then
        open(unit=outd,file=line,form='unformatted')
        write(*,*)'Output file opened in BINARY mode=>', 
     &              line(1:lnblnk(line))
      endif

      line = '# tshead_edit'
      write(outd) line
      line = '# date: '//date_string
      write(outd) line
      line = '#'
      write(outd) line
      write(*,*)'Give comments: end input with blank line'
      do while(.TRUE.)
        write(*,'(a,$)')'comment >'
        read(*,'(a)') line
        if(lnblnk(line).eq.0 ) goto 10
        write(outd) '# '//line(1:78)
      enddo
10    line = '#'
      write(outd) line



      read(ind) line
      do while( line(1:1).eq.'#' )
        write(outd) line
        read(ind) line
      enddo

c...first line of info block should be ">INFO_START:"
c   if not, then write it out

      if( line(1:12).eq.'>INFO_START:' ) then
        write(outd) line
        read(ind) line
      else
        write(*,*)'Info block does not start with required flag'
        write(*,*)'>INFO_START added'
        line2 = '>INFO_START:'
        write(outd) line2
      endif


      do while( line(1:1).eq.'>' )

        if( line(1:12).eq.'>INFO_END  :' ) then
          write(outd) line
          goto 2
        endif

        if( index( line, 'NCHAN' ).ne.0 ) then
          read(line(13:),*) nchan
        endif

        write(*,'(2a,$)') 'Input >',line(1:40)
        ans = 'n'
        call tin('Modify', ans )
        if( ans.eq.'y' ) then
          value = line(13:)
          call tin('Give new value', value )
          line(13:) = value
        endif
        write(outd) line
        read(ind,err=1) line
      enddo

1     backspace ind
      write(*,*)'Info block does not end with required flag'
      write(*,*)'>INFO_END added'
      line2 = '>INFO_END  :'
      write(outd) line2

2     do while(.TRUE.)
        read(ind,end=3) (data(i),i=1,nchan)
        write(outd)  (data(i),i=1,nchan)
      enddo

3     stop 'EOF reached'
      end
