c
c     tsfilter
c
c     filters data in a ts format file
c
      implicit none

      include 'ts_include.inc'

      integer MAXP, MAXP2
      parameter ( MAXP  = 500000 )
      parameter ( MAXP2 = 2*MAXP )

      character*1  sep
      character*10 cmdarg
      integer narg, getnarg

      character*6  formi,   formo
      character*15 formati, formato
      character*30 fin, fout
      character*80 line
      character*8 tswindow, tswindowout
      character*19 stime, etime
      character*24 date_string
      character*11 fwin
      integer i, npt, ichan, nchan, instr
      real data(5,MAXP), datout(5,MAXP), worksp(MAXP2), hs(MAXP2)

      integer tdiff

c-------------------------------------------------------------------------------
c     get date

      call fdate(date_string)

c-------------------------------------------------------------------------------
c     Initialize variables and arrays.

      call dirsep(sep)

c-------------------------------------------------------------------------------
c     get command-line arguments

      narg = getnarg()
      do i = 1, narg
        call getcmdarg( i, cmdarg)
        if( index(cmdarg,'h').ne.0 ) then
          write(*,*)'Permitted options:-'
          write(*,*)'                    -1 -> 3  iprint level'
          stop
        else
          read(cmdarg,'(i2)') iprint
        endif
      enddo

      call iin( 'Give print level (-1/0/1/2/3)',iprint)

c-------------------------------------------------------------------------------
c...write banner

      call banner( 'TSHILBERT' )

c-------------------------------------------------------------------------------
c...open window

      tswindow = ' '
      form     = '?'
      call ts_open( ind1, tswindow, fin, .TRUE., .FALSE.)

c...read in info block
      call ts_rdinfo(ind1)
      formi   = form
      formati = format

c-------------------------------------------------------------------------------
c...open widows file and get start and end times

      fwin = 'windows.'//tswindow(1:3)
      goto 405
  400 call tin (' Give the project windows file', fwin )
  405 open ( ind2, file=fwin, status='old', form='formatted', err=410 )
      go to 420
  410 write (*,'(a)') 'tsfilter: Error opening WINDOWS file:'//
     &                '  fwin = ', fwin
      goto 400
  420 continue
 
      call getwindow( ind2, tswindow, instr, nchan, stime, etime )
      write(*,*)'Times from windows file: stime = ', stime
      write(*,*)'                         etime = ', etime

c...derive length of series in points
c   first convert delta to samples/sec
      if( tunits.eq.'Hz' ) then
        continue
      else if( tunits.eq.'s' ) then
        delta = 1. / delta
      else
        write(*,*)'Time units not recognised >', tunits
        write(*,*)'only "s" or "Hz" permitted'
        stop
      endif
      npt = tdiff( stime, etime ) * delta
      write(*,*)'No. of points in series =', npt
      if( npt.gt.MAXP ) then
        write(*,*)' npt > MAXP '
        stop
      endif


c-------------------------------------------------------------------------------
c...open output file - BINARY only !!!

c...set form and format to BINARY and UNFORMATTED
      formo   = 'BINARY'
      formato = 'UNFORMATTED'
      form   = formo
      format = formato

      tswindowout = tswindow(1:6)//'fx'
      write(*,'(a)') 'Opening output file: '// tswindowout
      call ts_open( outd1, tswindowout, fout, .FALSE., .FALSE. )

c...write out comment block
      line = '# tshilbert: '//ver
      write(outd1) line
      line = '# date: '//date_string
      write(outd1) line
      line = '#'
      write(outd1) line
      line = '# Hilbert transformed instantaneous amplitude'
      write(outd1) line
      line = '#'
c...copy comment block from input file
      rewind( ind1 )
      call ts_copycomm( ind1, formi, outd1, formo )

c...read in then write out info block
      form   = formi
      format = formati
      rewind(ind1)
      call ts_rdinfo( ind1 )
      tswindow = tswindow(1:6)//'hx'
      form   = formo
      format = formato
      starttime = stime
      endtime   = etime
      call ts_wrtinfo( outd1 )

c-------------------------------------------------------------------------------
c...read data into loop and perform recursion

c...convert delta to samples/sec
      if( tunits.eq.'Hz' ) then
        continue
      else if( tunits.eq.'s' ) then
        delta = 1. / delta
      else
        write(*,*)'Time units not recognised >', tunits
        write(*,*)'only "s" or "Hz" permitted'
        stop
      endif

      form   = formi
      format = formati
      call ts_read( ind1, stime, etime, data )
      write(*,*)'All data read in'

c-------------------------------------------------------------------------------
c...perform Hilbert transform

c-- perform fft of i/p series --------
      do ichan = 1, nchan
        do i = 1, npt
          worksp( 2*i - 1 ) = data(ichan,i)
          worksp( 2*i     ) = 0.0
        enddo
        call fft( worksp( 1 ), worksp( 2 ), 1, npt, 1, -2 )
c-- set d.c. component to zero ------
        worksp( 1 ) = 0.0
c-- set nyquist component to zero ---
        worksp( npt + 1 ) = 0.0
c-- multiply by i*sgn --------------
        do i = 1, npt, 2
          hs( i    ) = - worksp( i + 1 )
          hs( i + 1) =   worksp( i     )
        enddo
        do i = npt + 1, 2 * npt, 2
          hs( i    ) =   worksp( i + 1 )
          hs( i + 1) = - worksp( i     )
        enddo
c-- perform ifft ----------------
        call fft( hs(1), hs(2), 1, npt, 1, +2 )
c-- take real part alone of ifft ---
        do i = 1, 2 * npt, 2
          hs( i/2 + 1 ) = hs( i )
        enddo

        do i = 1, npt
          datout(ichan,i) = 
     &           sqrt( hs(i)*hs(i) + data(ichan,i)*data(ichan,i) )
        enddo

      enddo

c-------------------------------------------------------------------------------
c...write data out

      form   = formo
      format = formato
      call ts_write( outd1, npt, datout )

      stop


9999  stop
      end
