c  tshistogram: v5.0: 21 March 1998
c
c  derives energy histogram of each series

      implicit none

      include 'version.inc'
      include 'defaults.inc'
      include 'ctrlblk.inc' 
      include 'io.inc' 
      include 'infoblk.inc'
      include 'bdate.inc'

      integer MAXWINDOW
      parameter ( MAXWINDOW = 10 )

      integer narg, getnarg, i, instr

      real dat(5), delta
      integer in, out, ind, inc, daterr
      integer yy, mm, dd, hh, min, ss, dday, dhour, dmin, dsec
      integer nchan
      integer nskip, ipt, npt
      integer bins(5,-50:50), ibin, ichan, bintot, bincum, bincuml
      integer onem, onep, twom, twop

      integer tdiff, sdur
      real binw(5)

      character title*20, indat*40, fout*20
      character proj*3, sep*1 
      character*10 dur
      character*8 tswindow
      character*6 stat
      character*19 stime, etime
      character*10 cmdarg
      character*1 mt

c-------------------------------------------------------------------------------

c     Initialize variables and arrays.

      call dirsep(sep)
      inc = 2
      ind = 4

c-------------------------------------------------------------------------------
c     get command-line arguments

      narg = getnarg()
      do i = 1, narg
        call getcmdarg( i, cmdarg)
        if( index(cmdarg,'h').ne.0 ) then
          write(*,*)'Permitted options:-'
          write(*,*)'                    -1 -> 3  iprint level'
          stop
        else
          read(cmdarg,'(i2)') iprint
        endif
      enddo

      call iin( 'Give print level (-1/0/1/2/3)',iprint)


c-------------------------------------------------------------------------------

      if( iprint.ge.1 ) then
        write(*,*)' '
        write(*,*)' >>>>>>>>>>>>> TSHISTOGRAM <<<<<<<<<<<<<<<<<'
        write(*,*)' '
        write(*,*)'           version = ', ver
        write(*,*)'build date = ', bdate
        write(*,*)' '
        write(*,*)'It is assumed that this program is being run from'
        write(*,*)'the database directory of the project '
        write(*,*)'(e.g. /local/mt/lims/nod)  '
        write(*,*)'and that all data files reside in subdirectories'
        write(*,*)'with the respective station names '
        write(*,*)'(e.g. /local/mt/lims/nod/nod001 nod002 etc.)'
        write(*,*)' '
        write(*,*)'windows and hardware database files are required'
        write(*,*)'(e.g. windows.nod & hardware.nod) '
        write(*,*)' '
      endif

c-------------------------------------------------------------------------------

      tswindow = 'tbt101ss'
300   call tin( 'Give window (extension assumed)', tswindow )

      proj = tswindow(1:3)
      stat = tswindow(1:6)
      title(1:12) = tswindow

      if( iprint.ge.1 ) write(*,*)'Station =>', stat

c-------------------------------------------------------------------------------
c   Get bin widths

      binw(1) = 1
      binw(2) = 1
      binw(3) = 1
      binw(4) = 1
      binw(5) = 1


c-------------------------------------------------------------------------------
c
c Open the output data files
       open(unit=7,file='tshistogram.out',status='unknown')

c-------------------------------------------------------------------------------
c
c Open the data file and Read in the window and header file information.
c

      form = '?'
      write(*,*)'Opening input file for window ', tswindow
      call ts_open( ind, tswindow, indat, .FALSE., .FALSE. )
      write(*,*)'Opened data file =>',indat
      call ts_rdinfo(ind)

      if( iprint.ge.1 ) then
        write(*,*)'Information block from input file...'
        write(*,*)'STATION   :', stat
        write(*,*)'WINDOW    :', tswindow
        write(*,*)'LATITUDE  :', lat
        write(*,*)'LONGITUDE :', long
        write(*,*)'ELEVATION :', elev
        write(*,*)'COORD_SYS :', azdir
        write(*,*)'FORM      :', form
        write(*,*)'FORMAT    :', format
        write(*,*)'NCHAN     :', nchan
        do i = 1, nchan
          write(*,*)'Channel......:', i
          write(*,*)'CHAN    :', chan(i)
          write(*,*)'AZIM    :', azim(i)
          write(*,*)'GAIN    :', gain(i)
          write(*,*)'UNITS   :', units(i)
        enddo
        write(*,*)'STARTTIME :', starttime
      endif

c      do i = 1, 5
c        call rin( 'Give bin width for channel '//chan(i), binw(i))
c      enddo
       call rin( 'Give bin width', binw(1))
       do i = 2, 5
         binw(i) = binw(1)
       enddo

      fout = 'windows.'//proj
      open ( inc, file=fout, status='old', form='formatted', err=9999 )
      call getwindow( inc, tswindow, instr, nchan, stime, etime )
      if( iprint.ge.1 ) then
        write(*,*)' window start and end times:', stime,'-',etime
      endif
      sdur = tdiff( stime, etime )
      close(inc)


      if( nchan.eq.3 ) then
        if( mt.eq.'M' ) then
          write(*,*)'>>>>>Only 3 channels found: GDS processing to',
     &              ' be undertaken'
          mt = 'G'
        endif
      else if( nchan.eq.4 ) then
        if( iprint.ge.1 ) write(*,*)'4 channels found'
      else if( nchan.eq.5 ) then
        if( iprint.ge.1 ) write(*,*)'5 channels found'
      else
        write(*,*)'Wierd number of channels; not 3 or 4 or 5 -- ',
     &            'don''''t know what to do now!'
        stop
      endif
c
c---nchan = total number of channels recorded on the data file.
c   delta is the sampling rate in Hz
c
      if( iprint.ge.1 ) then
        write(*,*) 'Sampling rate in Hz =', delta 
      end if

  900 if( iprint.ge.0 ) then
        write(*,'(2a)') 'Give the required event start time   >',
     &            'yyyy-mm-dd hh:mm:ss'
      endif
      call tin ( 'Default is', stime )
      call date( 0, stime, yy, mm, dd, hh, min, ss )
      if( iprint.ge.2 ) then
        write(*,*)'stime=',stime
        write(*,*)' yy, mm, dd, hh, min =>', yy, mm, dd, hh, min, ss
      endif

      call chkdat ( yy, mm, dd, hh, min, ss, daterr )
      if( daterr .gt. 0 ) go to 900


905   if( iprint.ge.0 ) then
        write(*,'(2a)') 'Give the required event end   time   >',
     &            'yyyy-mm-dd hh:mm:ss'
      end if
      call tin ( 'Default is', etime )
      call date( 0, etime, yy, mm, dd, hh, min, ss )
      if( iprint.ge.2 ) then
        write(*,*)'etime=',etime
        write(*,*)' yy, mm, dd, hh, min =>', yy, mm, dd, hh, min, ss
      end if

      call chkdat ( yy, mm, dd, hh, min, ss, daterr )
      if( daterr .gt. 0 ) go to 905


      call date( 0, stime, yy, mm, dd, hh, min, ss )


c...sdur is the duration in seconds from the start time to the end
      sdur = tdiff( stime, etime )
      npt = sdur / delta

      dday  =  sdur/(60*60*24)
      dhour =  mod(sdur,60*60*24)/(60*60)
      dmin  =  mod(sdur,60*60)/60
      dsec  =  mod(sdur,60)

      if( iprint.ge.0 ) then
        write( dur, '(i4.4,a1,i2.2,a1,i2.2)') 
     &           dday, '/', dhour, '/', dmin
        write(*,*) 'Duration (dddd/hh/mm) : ', dur
        write(*,*) 'No. of points =', npt
      endif


c-------------------------------------------------------------------------------

 
c....skip data for data start times < stime
      if( starttime.lt.stime ) then
        nskip = tdiff( starttime, stime ) * delta
        write(*,*)'Skipping', nskip, '  data for local  file'
        call ts_skip( ind, nskip )
      endif

c-------------------------------------------------------------------------------

      do ipt = 1, npt
        call ts_in1(ind, dat)
        if( dat(1).eq.EOF ) goto 30
        if( iprint.ge.3 ) then
          write(*,*) 'Input dat  =>', (dat(i),i=1,nchan)
        endif

c...assign to bins
        do ichan = 1, nchan
          ibin = nint( dat(ichan)/binw(ichan) )
          if( ibin.le.-50) ibin = -50
          if( ibin.gt.50 ) ibin = 50
          bins(ichan,ibin) = bins(ichan,ibin) + 1
        enddo
      enddo

30    do ibin = -50, 50, 1
        write(7,'(f,5i10)') float(ibin)*binw(1), 
     &                    (bins(i,ibin),i=1,nchan)
      enddo

c...calculate +/-1 and +/-2 standard errors

      twom = nint(0.025*npt)
      onem = nint(0.16 *npt)
      onep = nint(0.84 *npt)
      twop = nint(0.975*npt)
      write(*,*)'2-, 1-, 1+, 2+ =',twom,onem,onep,twop

      do ichan = 1, nchan
      write(*,*)'Channel ...', ichan
      bincum = bins(ichan,-50)
      do ibin = -49, 50, 1
        bincuml = bincum
        bincum = bincum + bins(ichan,ibin)
        if( bincuml.le.twom .and. bincum.ge.twom ) then
          write(*,*)'Straddled 2- boundary: bin =',float(ibin)*binw(1)
        endif
        if( bincuml.le.onem .and. bincum.ge.onem ) then
          write(*,*)'Straddled 1- boundary: bin =',float(ibin)*binw(1)
        endif
        if( bincuml.le.onep .and. bincum.ge.onep ) then
          write(*,*)'Straddled 1+ boundary: bin =',float(ibin)*binw(1)
        endif
        if( bincuml.le.twop .and. bincum.ge.twop ) then
          write(*,*)'Straddled 2+ boundary: bin =',float(ibin)*binw(1)
        endif
      enddo
      enddo


      stop 'Done.'

9999  stop 'Error '
      END
