      subroutine crosscov(f,g, N, c)
      implicit none
      integer N
      real f(N), g(N), c(0:N-1)

c INPUT
c     f = first time series (the first data point is at index 1)
c     g = second time series (the first data point is at index 1)
c     N = length of f and g 
c     note f & g must have zero mean
c OUTPUT
c     c = cross covariance of f with g

c     L=digital lag, of 0,1... N-1
c
c                N-L
c            -1   __
c      c(L)=N    \   f(t+L) * g(t)
c                /__
c                t=1

      integer L, it
      do L=0, N-1
         do it=1, N-L
            c(L) = c(L) + f(it+L)*g(it)
         end do
         c(L)= c(L)/float(N)
      end do

      return
      end

