c=====================================================================
      subroutine set_xscale(tsec,delta,dday, dhour, dmin)
c=====================================================================
      implicit none
      include 'TSMULTIPLOT.h'
      include 'CTRLBLK.inc'
c=====================================================================
      
      real delta
      integer tsec, dday, dhour, dmin
      
      integer ipt
c Select the units for the horizontal time axis.
c
      nday = 0
      nhour = 0
      if( tsec .le. 10 ) then
        tinc = 1.0
        tstart = ss
        hsep = xmax/float(tsec)
        nticks = tsec + 1
        SECOND = .TRUE.
      else if( tsec .le. 100 ) then
        tinc = 10.
        tstart = ss
        hsep = (xmax*tinc)/float( tsec )
        nticks = (tsec/ ifix(tinc) ) + 1
        SECOND = .TRUE.

c  Must start on a minute mark.
      else if( tsec .le. 1000 ) then
        tinc = 1.
        tstart = smin
        hsep = (xmax*60.)/float(tsec)
        nticks = (tsec/60.) + 1
        MINUTE = .TRUE.

c   tlen < 3 hours  MINUTE = .TRUE.  tick every 10 mins
      else if( tsec .le. 10800 ) then
        tinc = 10.
        tstart = smin
        hsep = xmax*60.*tinc/float( tsec )
        nticks = (tsec/(60.*tinc)) + 1
        MINUTE = .TRUE.

c  tlen < 1 day     HOUR = .TRUE.  tick every hour
      else if( tsec .le. 86400 ) then
        nhour = 24*dday + dhour + (smin + dmin)/60
        if( mod(smin+dmin,60).ne.0 ) nhour = nhour+1
        tinc = 1.
        tstart = hh
c        hsep = xmax*3600.*tinc/float( tsec )
        hsep = xmax*tinc/float( nhour )
        nticks = nhour + 1
        HOUR = .TRUE.

c  tlen < 2 days    HOUR6= .TRUE.   tick every 6 hours
      else if( tsec.le.172800 ) then
        nhour = 24*dday + dhour + (smin + dmin)/60
        if( mod(smin+dmin,60).ne.0 ) nhour = nhour+1
        if( mod(nhour,6).ne.0 ) nhour = 6*(nhour/6) + 6
        tinc = 6.
        tstart = 6*(hh/6)
c        hsep = xmax*3600.*tinc/float( tsec )
        hsep = xmax*tinc/float( nhour )
        nticks = nhour/6 + 1
        HOUR6 = .TRUE.

c  tlen > 4 days    DAY  = .TRUE.   tick every day
      else 
        nday = dday + (hh + dhour)/24
        if( mod(hh+dhour,24).ne.0 ) nday = nday+1
        tinc = 1.
        tstart = dd
        nticks = nday + 1
c        hsep = xmax*(24.*60.*60.)*tinc/float( tsec )
        hsep = xmax/float( nday )
        DAY = .TRUE.
        if( iprint.ge.1 ) then
          write(*,*)'nday, nticks, tstart = ', nday, nticks, tstart
        end if
      end if

c     --- Calculate the x-axis scaling factor
c     totn is the total number of entries required to fill the plot.
      totn =  float(tsec) * delta
      xscale = xmax/totn                  !plotting scale in cm/pt
      ntot = ifix(totn)
      if( HOUR ) then
        xscale = xmax/(float(nhour*60*60)*delta)
        xstart = (float(smin)/60.) * xmax/float(nhour)
      else if( HOUR6 ) then
        xscale = xmax/(float(nhour*60*60)*delta)
        xstart = (float(mod(hh,6))+(float(smin)/60.))*xmax/float(nhour)
      else if( DAY ) then
        xscale = xmax/(float(nday*24*60*60)*delta)
        xstart = (float(hh)/24.) * xmax/float(nday)
      end if

      if( iprint.ge.1 ) then
        write(*,*)'Plotting scale (cm/pt) = ', xscale
        write(*,*)'Data start     (cm)    = ', xstart
        if( DAY ) then
          write(*,*)'Plotting scale (cm/day) = ',xmax/float(nday)
        end if
      end if

c     --- Scale the horizontal axis.
      do ipt = 1, ntot
        xp(ipt) = float(ipt-1)*xscale + xstart
      end do

      return 
      end
c=====================================================================
      subroutine plot_frame()
c=====================================================================
      implicit none
      include 'TSMULTIPLOT.h'
c=====================================================================
      integer j, ht, its, nchar
      real x, y, xpp, yp, xn, scvbar, vbar, vbar2, vsep
      character*2 compp
      character*6 tscale
      character*9 tempst
      character*10 mtime, nowtim
      character*17 ttime
      real xorg, yorg, scal, xorg_save, yorg_save
      common /origin/ xorg, yorg, scal
c=====================================================================
c  Open plotting file

c$$$      call opnplt('list')
      call opnplt('sel mx11; ex')
c  Set the scale factor
      call scale(17.0)
c  Shift the origin up and to the right to provide space for axis labels.
      call plot (0.7, 1.2, -3)
       
c---Draw a box

      x = xmax
      y = ymax
      call plot ( x, 0., 2)
      call plot ( x,  y, 2)
      call plot (0.,  y, 2)
      call plot (0., 0., 2)

c---Place time marks on the horizontal axis.

      do 350 j = 1, nticks
        xpp = float( j-1 )*hsep 
        yp = 0.0
        call plot( xpp, yp, 3 )
c        yp = .125
c        call plot( xpp, yp, 2 )
        yp = -.125
        call plot( xpp, yp, 2 )
        yp = -.5
        call plot( xpp, yp, 3 )
        ht = tstart + (j-1)*ifix( tinc )
        if( SECOND ) then
          ht = mod( ht, 60 )
          tscale = 'SECOND'
        else if( MINUTE ) then
          ht = mod( ht, 60 )
          tscale = 'MINUTE'
        else if( HOUR ) then
          ht = mod( ht, 24 )
          tscale = 'HOURS '
        else if( HOUR6 ) then
          ht = mod( ht, 24 )
          tscale = 'HOURS '
        else if( DAY ) then
          mtime = time(1:10)
          mtime = nowtim( mtime, (j-1)*ifix( tinc ), 0, 0 )
          read( mtime(5:6), '(i2.2)' ) ht
          tscale = 'DAYS' 
        end if
        xn = float ( ht )
        call number ( xpp, yp, .30, xn, 0.0, 'i2' )
        yp = 0.0
        call plot( xpp, yp, 3 )
  350 continue
      yp = 0.2
      xpp = xmax - 1.5
      nchar=6
      call symbol( xpp, yp, 0.30, tscale, 0.0, nchar)

c---Plot the start time on the upper left corner.

      xpp = xmax - 3.5
      yp  = ymax +  .20
    2 format(2(i2.2,'-'),i2.2,1x,2(i2.2,':'),i2.2)
      write ( ttime, 2, err= 9001) yy, mm, dd, hh, smin, ss
      xpp = 0.0
      nchar=17
      call symbol( xpp, yp, 0.35, ttime, 0.0,  nchar)

c     Relate the length of the vertical scale bars to the data.
    1 FORMAT (1pe6.1e1,'/')
      yp = -1.0
      nchar=1
      call symbol( xpp, yp, 0.30, '/', 0.0, nchar )
      do its = 1, nts
c        call pcolor( its+1 )
        scvbar = sc(its)/float(nts*2)
        write( tempst, 1 ) scvbar
        nchar=7
        call symbol( 999., 999., 0.30, tempst, 0.0, nchar )
      end do

c     ---  Calculate the vertical separation between channels.
      xorg_save = xorg
      yorg_save = yorg
      vsep = ymax/float (nts + 1)
      do its = 1, nts
c        call pcolor( its+1 )
        call plot (0., vsep, -3)
c  Calculate the length of the vertical scale bars.
        vbar = ymax/float( nts*2 )
        vbar2 = vbar/2.0
c  Plot window and component
        if(icomp(its).le.5) then
           compp = comps( mapcmps(icomp(its), ifiles(its)),
     &          ifiles(its) )
        else
           compp = comps( icomp(its), ifiles(its) )
        endif
        nchar=2
        call symbol( -.7, vbar2-.3, .25, compp, 0.0, nchar )
        nchar=5
        call symbol( -.7, vbar2+0.2, .175, windows(ifiles(its))(4:),
     &       0.0, nchar )
c  Plot the vbars.
        call plot (-.17,  vbar2, 3)
        call plot (-.13,  vbar2, 2)
        call plot (-.15,  vbar2, 3)
        call plot (-.15, -vbar2, 2)
        call plot (-.17, -vbar2, 3)
        call plot (-.13, -vbar2, 2)
        call plot (0., 0., 3)
      end do
c     --- reset origins for plot_ts()
      xorg = xorg_save
      yorg = yorg_save

      return
 9001 write (*, '(a)') ' ERROR converting integers to characters.'
      stop
      end

c=====================================================================
      subroutine plot_ts()
c=====================================================================
      implicit none
      include 'TSMULTIPLOT.h'
c=====================================================================
      integer its, kk, ipt, ipen, ifile, ngaps_tmp(MAXCHAN)
      real yscale, vsep, yplus, yminus, yp, xp
      logical first_point(MAXCHAN)
      real f10, delta
      integer idel, hm(MAXCHAN), icount(MAXCHAN)
      logical plot_it
c=====================================================================
c     ---  Calculate the vertical separation between channels.
      vsep = ymax/float (nts + 1)
      do its = 1, nts
         first_point(its) = .true.
      end do
      do its = 1, nts
c        --- convert array of gaps per file to gaps per trace
         do ifile = 1, nfiles
            if( ifiles(its) .eq. ifile ) then
               ngaps_tmp(its) = ngaps(ifile)
            endif
         end do
c        --- caclulate each trace's first hm (beyond the initial entry)
         f10 = f10s(ifiles(its))
         delta = deltas(ifiles(its))
         if ( delta .gt. 1.0 ) then
            hm(its) = f10 * 60 * ifix (delta) + 1
         else
            idel =  nint (1.0/delta)
            hm(its) = (f10 * 60/idel) + 1
         endif
      end do
c     --- plot the traces
      kk = nts + 1
      do its = 1, nts
         yscale = ymax/sc(its)
c        --- clip data outside vplus-vminus
         kk = kk -1
         yplus = float(kk)*vsep
         yminus = -float(nts+1-kk)*vsep
c        --- reset the origin up vsep units
         call plot (0., vsep, -3)
         icount(its) = 0
c        --- foreach point, from stsec to npts in that trace
         do ipt = 1, ngaps_tmp(its)+npts(ifiles(its))
            plot_it = .false.
            if(ngaps_tmp(its).le.0) then
c              -- the time series is in current duration
               if( use_aux(its) ) then
c                 --- plotting an aux channel, check if hm
                  icount(its) = icount(its) + 1
                  if(icount(its).eq.1) then
c                     --- first datum always contained auxilliary data
                     plot_it = .true.
                  else if( icount(its) .eq. hm(its) ) then
c                    --- dataum falls on a hm (10 minute mark)
                     plot_it = .true.
c                    --- reset next hm (10 min mark) for this time series
                     hm(its) = hm(its)+nint(600.*deltas(ifiles(its)) )
                  end if
               else
c                 --- plot all data for normal channels
                  plot_it= .true.
               endif
            else
c              --- decrement the gaps count until start time
               ngaps_tmp(its) = ngaps_tmp(its) - 1
            endif
            if(plot_it) then
               if(first_point(its)) then
                  ipen = 3
                  first_point(its) = .false.
               else
                  ipen = 2
               endif
               yp = float(ts_data(ipt,its)-avgs(its))
     &              *yscale*cals(icomp(its),ifiles(its))
               yp = min(max(yp,yminus),yplus)
               call plot(xp(ipt),yp,ipen)
            end if
         end do
      end do
c=====================================================================
      return
      end


