c-------------------------------------------------------------------
      subroutine endplt
c-------------------------------------------------------------------
      real      lastx, lasty, psscale
      integer*4 lout, iold, icount
      common /output/ lout, iold, lastx, lasty, psscale, icount
c
c Close the postscript file
c
      write(lout,4)
4     format('s')
      write(lout,1) 
1     format('showpage')
      close(unit=lout)
c
      return
      end 
c-------------------------------------------------------------------
      subroutine opnplt(terminal)
c-------------------------------------------------------------------
c Assumptions: All plotting is in mm. Subroutine SCALE converts from 
c              user units to mm. All postscript output in points.
c
      character terminal*(*), a*1
      real      xorg, yorg, scfact, xmax, ymax, lastx, lasty, psscale
      integer   lout, iold, icount
c
      common /output/ lout, iold, lastx, lasty, psscale, icount
      common /origin/ xorg, yorg, scfact
c
c Dummy use of dead variable TERMINAL - to maintain compatibility with SUNS
c
      a = terminal(1:1)
c
c Set up output for ascii postscript file to unit 1
c
      lout = 1
      iold = 0
c
c Origin is at the lower left corner of the screen
c
      xorg = 0.0
      yorg = 0.0
c
c Estimated size (in mm) of output device (PC screens)
c
      xmax = 250.0
      ymax = 200.0
c
c Scaling set for mm initially
c
      scfact = 1.0
c
c Set up postscript style output
c
      open(unit=lout,file='magplot.ps',status='unknown')
      write(lout,1) 
1     format('%!',/,
     >       '%%Creator: bu2ps FORTRAN plotting package',/,
     >       '%%Pages: 1',/,
     >       '%%EndComments',//,
     >       '/l {lineto} def /m {moveto} def ',
     >       '/srgb {setrgbcolor} def',/,'/font {/Helvetica} def ',
     >       '/s {stroke} def /n {newpath} def',//,'%%EndProlog',/)
      write(lout,2)
2     format('550 40 translate 90 rotate ')
      psscale = 72.0 / 25.4
      icount = 1
c
c Initial color is white.
c
      call pcolor( 1 )
c
      return
      end
c-------------------------------------------------------------------
      subroutine scale(factor)
c-------------------------------------------------------------------
c Convert all user entered units to mm using FACTOR.
c
      real      xorg, yorg, factor, scfact
      common /origin/ xorg, yorg, scfact
c
      scfact = factor
c
      return
      end
c------------------------------------------------------------------
      subroutine pcolor( icol )
c------------------------------------------------------------------
      integer*4 icol, red(16), grn(16), blu(16), lout, i
      integer*4 icount, iold
      real      lastx, lasty, psscale
      common /output/ lout, iold, lastx, lasty, psscale, icount
c
      DATA red /  0, 63, 63, 21,  0, 63, 10, 21,
     >            0,  0, 63, 25, 25,  0, 32, 63/
      DATA grn /  0, 63,  0,  0, 21, 10, 63, 47,
     >           63, 38,  0, 38, 25, 63,  0, 63/
      DATA blu /  0, 63, 63, 63, 63,  0,  0, 16,
     >           43, 63, 42, 63, 63, 63, 63,  0/
c
      i = icol + 1
      if(icol.eq.1) i = 1
      write(lout,1) float(red(i))/63.0, float(grn(i))/63.0, 
     >              float(blu(i))/63.0
1     format(2x,3(f4.2,1x),'srgb')
c
      return
      end
c----------------------------------------------------------------------
      subroutine plot(x,y,jpen)
c----------------------------------------------------------------------
      real    x, y, xx, yy, xorg, yorg, scfact, lastx, lasty, psscale
      integer*4 ipen, jpen, iold, icount
c
      integer lout
      logical plt
      common /output/ lout, iold, lastx, lasty, psscale, icount
      common /origin/ xorg, yorg, scfact
      common /lastcall/ plt
c
      ipen = jpen
      xx = x * scfact + xorg
      yy = y * scfact + yorg
c
c This resets the origin
c
      if(ipen.eq.-3) then
        xorg = xx
        yorg = yy
        ipen = 3
      end if
c
      if(ipen.eq.2) then
c
c The IOLD refers to last call to PLOT. Used to eliminate sequential moves
c that do not draw anything
c
        if(plt.and.iold.eq.3) then
          write(lout,5)
          write(lout,3) lastx, lasty
          icount = 1
        end if
        write(lout,2) xx*psscale, yy*psscale
        icount = icount + 1
        if(icount.gt.1000) then
          write(lout,4)
          write(lout,5)
          write(lout,3) xx*psscale, yy*psscale
          icount = 1
        end if
c
c Move the pen without drawing
c
       else if(ipen.eq.3) then
        if(plt.and.iold.eq.2) write(lout,4)
        lastx = xx * psscale
        lasty = yy * psscale
      end if
      iold = ipen
      plt = .true.
4     format('s')
5     format('n')
2     format(1x,2(f7.2,1x),' l')
3     format(1x,2(f7.2,1x),' m')
      return
      end
c---------------------------------------------------------------------------
      subroutine symbol(x,y,hite,string,theta,nchars)
c---------------------------------------------------------------------------
      character string*(*), iostring*80
      real      x, y, hite, theta, xx, yy, hhite, xorg, yorg, scfact
      real      lastx, lasty, psscale, hiteold/0.0/
      integer   nchars, icount
c
      integer lout, iold
      logical plt
c
      common /output/ lout, iold, lastx, lasty, psscale, icount
      common /origin/ xorg, yorg, scfact
      common /lastcall/ plt
c
      xx = x * scfact + xorg
      yy = y * scfact + yorg
      hhite = hite * scfact
      iostring = string(1:nchars)
      call trunc(iostring,nchars)
      if(nchars.eq.0) return
c
c 999 is a code to continue plotting from end of the last string - 
c coordinates are only needed for the postscript file.
c
c Postscript fonts set in opnplt
c
      if(plt.and.iold.eq.1) write(lout,2)
1     format('s')
      if(hite.ne.hiteold) then
        write(lout,4) nint(hhite*psscale)
4       format('/fontsize ',i2,' def font findfont fontsize ',
     >         'scalefont setfont')
      end if
      if(x.eq.999.0.and.y.eq.999.0) then
        write(lout,5) string(1:nchars)
5       format('currentpoint moveto (',a,') show')
       else
        xx = xx * psscale
        yy = yy * psscale
        if(theta.eq.0.0) then
          write(lout,2) xx, yy, string(1:nchars)
         else
          write(lout,3) xx, yy, theta, string(1:nchars)
        end if
      end if
      hiteold = hite
2     format(1x,2(f7.2,1x),' m (',a,') show')
3     format(1x,2(f7.2,1x),' m gsave ',f5.1,' rotate (',a,
     >       ') show grestore')
      plt = .false.
      return
      end
c---------------------------------------------------------------------------
       subroutine number(x,y,hite,rnumber,theta,fmt)
c---------------------------------------------------------------------------
      character iostring*80, iofmt*20, fmt*(*) 
      real      x, y, hite, theta, rnumber
      integer   nchars
c
      iofmt = fmt
      call shiftup(iofmt)
      call trunc(iofmt,nchars)
c
c Number is just an internal write and a call to symbol. Handle integers.
c
      if(index(iofmt(:nchars),'I').eq.0) then
        write(iostring,'('//iofmt(1:nchars)//')',err=1) rnumber
       else if(index(iofmt(:nchars),'I').ne.0) then
        write(iostring,'('//iofmt(1:nchars)//')',err=1) nint(rnumber)
      end if
      call trunc(iostring,nchars)
      call symbol(x,y,hite,iostring(1:nchars),theta,nchars)
1     return
      end
