      program tssplice
 
c  original:   v4.2: 8 April 1998
c
c  splices together ts files
c  output is automatically UNFORMATTED

      implicit none

      integer NFILES
      parameter (NFILES = 50 )
 
      include 'version.inc'
      include 'ctrlblk.inc' 
      include 'io.inc' 
      include 'infoblk.inc'
      include 'defaults.inc'
      include 'bdate.inc'


      integer narg, getnarg, i, nf, instr, instr1, nchan1, if,
     &        ndrop

      real dat(5)
      real baseline1(3)
      real bl_diff(3)
      real delta1

      integer tdiff, tgap, ngap, ntot, npts(NFILES), ngappts(NFILES)
      integer nsec

      character fwin*11, fout*40, fin(NFILES)*40, win*2, fdummy*40
      character*19 stime(NFILES), etime(NFILES), nowtim, thistime
      character*2 wins(NFILES)
      character proj*3, sep*1, tswindow*8, tunits1*5
      character*10 cmdarg
      character*24 date_string
      character*80 line

c-------------------------------------------------------------------------------
c     initialize

      call fdate(date_string)
      call dirsep(sep)

      iprint = 0

c-------------------------------------------------------------------------------
c     get command-line arguments

      narg = getnarg()
      do i = 1, narg
        call getcmdarg( i, cmdarg)
        if( index(cmdarg,'h').ne.0 ) then
          write(*,*)'Permitted options:-'
          write(*,*)'                    -1  or -2  iprint level'
          stop
        else
          read(cmdarg,'(i2)') iprint
        endif
      enddo

      call iin( 'Give print level (-1/0/1/2/3)', iprint)


c-------------------------------------------------------------------------------

      if( iprint.ge.1 ) then
        write(*,*)' '
        write(*,*)' >>>>>>>>>>>>>>> TSSPLICE <<<<<<<<<<<<<<<<<<<'
        write(*,*)' '
        write(*,*)'           version = ', ver
        write(*,*)'build date = ', ver
        write(*,*)' '
        write(*,*)'It is assumed that this program is being run from'
        write(*,*)'the database directory of the project '
        write(*,*)'(e.g. /local/mt/lims/nod)  '
        write(*,*)'and that all data files reside in subdirectories'
        write(*,*)'with the respective station names '
        write(*,*)'(e.g. /local/mt/lims/nod/nod001 nod002 etc.)'
        write(*,*)' '
        write(*,*)'windows database file is required'
        write(*,*)'(e.g. windows.nod)'
        write(*,*)' '
        write(*,*)'NOTE: ONLY THE TIMES IN THE WINDOWS FILE ARE SPLICED'
        write(*,*)' '
      endif

c------------------------------------------------------------------------------
c...read in name of first data file

      stat = 'sno105'
      call tin('Give station name', stat )
      proj = stat(1:3)

      nf = 1
      win = 'a1'
      call tin( 'Give first window', win )
      tswindow = stat//win
      fin(1)   = tswindow//'.ts'
      wins(1)  = win
      
c...open windows file
      fwin = 'windows.'//proj
      open(unit=ind2,file=fwin,status='old',err=9001)
      
c...get window info for first window
      call getwindow( ind2, tswindow, instr1, nchan1, 
     &                stime(1), etime(1) )
      if( iprint.ge.1 ) then
        write(*,*)'Window file start and end times: ', tswindow,' ',
     &             stime(1),'-',etime(1)
      endif
      
c...read in other filenames
      do while( .TRUE. )
        nf = nf + 1
        win = ' '
        call tin( 'Give next window (<ENTER> to stop)', win )
        if( win(1:1).eq.' ' ) goto 10
        wins(nf)  = win
        tswindow = stat//win
        fin(nf) = tswindow//'.ts'
c...get window info from windows file
        call getwindow( ind2, tswindow, instr, nchan,
     &                   stime(nf), etime(nf) )
c...check same instrument number
        if( instr.ne.instr1 ) then
          write(*,*)'Different instrument number from first file'
          write(*,*)'  instr1 =', instr1, '   instr =', instr
          write(*,*)'Check datafiles...'
          write(*,*)'Program continuing...'
        endif
c...check same number of channels
        if( nchan .ne. nchan1 ) goto 9003
c...check this file starts after previous ended
        if( stime(nf) .lt. etime(nf-1) ) goto 9004

        if( iprint.ge.1 ) then
          write(*,*)'Windows file start and end times: ', tswindow,' ',
     &             stime(nf),'-',etime(nf)
        endif
      enddo
      
10    nf = nf-1
      write(*,*)'No. of files to splice =', nf
      close(unit=ind2)
     
c------------------------------------------------------------------------------
c...open output file

      win = 'as'
      call tin( 'Give output window', win )
      tswindow = stat//win
      form = 'BINARY'
      format = 'UNFORMATTED'
      call ts_open( outd1, tswindow, fout, .FALSE., .FALSE. )
      write(*,'(2a)') 'Opened BINARY output file: ', fout(1:18)

c-------------------------------------------------------------------------------
c...open data files and read in the window and header file information
c
c   keep track of number of data points with ntot
c   keep track of individual no. of data points in each file with npts

      ntot = 0
      do if = 1, nf
        npts(if) = 0
        tswindow = fin(if)(1:8)
        
        form = '?'
        write(*,*)'Opening input file for window ', tswindow
        call ts_open( ind1, tswindow, fdummy, .FALSE., .FALSE. )
        write(*,*)'Opened data file =>', fdummy
        call ts_rdinfo(ind1)

c...set variables from first file

        if( if.eq.1 ) then

c..ts_data common
          delta1  = delta
          tunits1 = tunits
          nchan1  = nchan
          do i = 1, 3
            baseline1(i) = baseline(i)
          enddo

c...write comments and info block out (then read over input info again)

          line = '# time series file from tssplice'
          write(outd1) line
          line = '# date: '//date_string
          write(outd1) line
          line = '#'
          write(outd1) line
          line = '# Files spliced together:'
          write(outd1) line
          do i = 1, nf
            line = '# '//fin(i)(1:8)//'  '//stime(i)//'-'//etime(i)
            write(outd1) line
          enddo
          line = '#'
          write(outd1) line
          line = '# Following comment block from first file...'
          write(outd1) line
          line = '#'
          write(outd1) line          

          rewind(ind1)
          call ts_copycomm(ind1, form, outd1, 'BINARY         ' )
          call ts_rdinfo(ind1)
c...change tswindow
          window = stat//win
c...check whether windows starttime is same as data starttime
c   (this is special case of first file)
          nsec = tdiff( starttime, stime(1) )
          if( nsec.gt.0 ) then
            ndrop = ifix(float(nsec) / delta )
            write(*,*)'Points to be dropped from start: ', ndrop
            write(*,*)'window starttime :', stime(1)
            write(*,*)'data   starttime :', starttime
            do i = 1, ndrop
              call ts_in1(ind1, dat )
            enddo
          elseif( nsec.lt.0 ) then
            write(*,*)'Data start > window start'
            write(*,*)'window starttime :', stime(1)
            write(*,*)'data   starttime :', starttime
            write(*,*)'Window start reset'
            stime(1) = starttime
          else
            continue
          endif
c...change ENDTIME to last endtime
          starttime = stime(1)
          endtime   = etime(nf)
          call ts_wrtinfo( outd1 )
          
        else

c...check that file at same digitizing rate (delta1)
c                      same tunits
c                      same no. of channels
          if( delta.ne.delta1   ) goto 9005
          if( tunits.ne.tunits1 ) goto 9006
          if( nchan.ne.nchan1   ) goto 9003

c...calculate difference in magnetic baselines
          do i = 1, 3
            bl_diff(i) = baseline(i) - baseline1(i)
            write(*,*)'Channel: ', i, '  Baseline difference =', 
     &                 bl_diff(i)
          enddo
          
        endif



c...check whether windows starttime is same as data starttime
        nsec = tdiff( starttime, stime(if) )
        if( iprint.ge.1 ) then
          write(*,*)'starttime: ', starttime
          write(*,*)'stime(if): ', stime(if)
          write(*,*)'nsec     :', nsec
        endif
        if( nsec.gt.0 ) then
          ndrop = ifix(float(nsec) / delta )
          write(*,*)'Points to be dropped from start: ', ndrop
          write(*,*)'window starttime :', stime(if)
          write(*,*)'data   starttime :', starttime
c...drop pts if required
c   (don't need to write missing data markers as this was done at end of
c    data gap)
          do i = 1, ndrop
            call ts_in1(ind1, dat )
            if( dat(1).eq.EOF ) then
              write(*,*)'EOF found before all drop points read in'
              stop
            endif
          enddo
        elseif( nsec.lt.0 ) then
          write(*,*)'Data start > window start'
          write(*,*)'window starttime :', stime(1)
          write(*,*)'data   starttime :', starttime
          write(*,*)'Window start reset'
          stime(if) = starttime
        else
          continue
        endif

c...read in all data and write it out again until EOF found
        do while(.TRUE.)

          call ts_in1(ind1, dat )
          if( dat(1).eq.EOF ) goto 20
          npts(if) = npts(if) + 1

c...add on difference in baselines cf. first file
          if( if.gt.1 ) then
            do i = 1, 3
              dat(i) = dat(i) + bl_diff(i)
            enddo
          endif
            
          format = 'UNFORMATTED'
          call ts_out1(outd1, dat)
          ntot = ntot + 1
        enddo

20      close(unit=ind1)

        if( if.lt.nf ) then
          write(*,*)'No. of points written:', ntot
          if( tunits(1:1).eq.'s' ) then
            nsec = nint( float(ntot-1) * delta )
          else if( tunits(1:2).eq.'Hz' ) then
            nsec = nint( float(ntot-1) / delta )
          else
            write(*,*)'tunits not recognised: ', tunits
          endif
          write(*,*)'No. of secs total    :', nsec
          thistime = nowtim( stime(1), 0, 0, 0,  nsec )
          write(*,*)'Thistime based on pts:', thistime
          write(*,*)'End of previous data :', etime(if)
          write(*,*)'Start of next data   :', stime(if+1)

c...compare "thistime" with expected endtime of data from windows file
c
          if (tdiff(thistime, etime(if)).ne.0 ) then
            write(*,*)'Setting current end to that determined '//
     &                'by points'
          endif
c...calculate time gap & convert to no. of missing points
c   (remember not to count points at end of last data and start of next data)
          tgap = tdiff(thistime, stime(if+1))
          if( tunits.eq.'Hz' ) then
            ngap = ifix(float(tgap) * delta ) - 1
          else
            ngap = ifix(float(tgap) / delta ) - 1
          endif
          write(*,*)'Time (seconds) and point gap =', tgap, ngap
          
          do i = 1, nchan
            dat(i) = misdat
          enddo
            
          format = 'UNFORMATTED'
          do i = 1, ngap
            call ts_out1(outd1, dat )
            ntot = ntot + 1
          enddo
          ngappts(if) = ngap
          
        endif
        
      enddo

      write(*,*)'Total number of data (incl. gaps) written out =',
     &          ntot
      do if = 1, nf
        write(*,*)' File ', if, ' points and gap =', npts(if), 
     &            ngappts(if)
      enddo
      write(*,*)'Start and end of data from windows file: ',
     &          stime(1),'-',etime(nf)
      write(*,*)'Duration (in s) based on these times = ',
     &          tdiff( stime(1), etime(nf) )
      write(*,*)'Duration (in s) based on no. points  = ',
     &          ntot*ifix(delta)




c--Write start and end times into windows file
c
      fout = 'windows.'//proj
      window = stat//win
405   open( outd2, file=fout, status='old', form='formatted', err=406 )
      write(*,'(4a)')'Opened old project windows.',proj,' file to ',
     &                  'add window info:'
c...read to end of windows file      
      do while( .TRUE. )
        read( outd2,*,end=407 )
      enddo
      write(*,*)'Should never get this message !!!'
      stop
406   open( outd2, file=fout, status='new', form='formatted', err=9999 )      
      write(*,'(3a)')'Opened new project windows.',proj,
     &                  ' file to add window info:'

407   write(*,'(a8,1x,i3.3,1x,i1,1x,a19,a1,a19,3x,f9.6,a,10(a2,1x))')
     &            window, instrument, nchan, stime(1), '-', 
     &            etime(nf), 1./delta,
     &            ' splice: ',(wins(i),i=1,nf)
      write(outd2,'(a8,1x,i3.3,1x,i1,1x,a19,a1,a19,3x,f9.6,a,
     &      10(a2,1x))')
     &            window, instrument, nchan, stime(1), '-', 
     &            etime(nf), 1./delta,
     &            ' splice: ',(wins(i),i=1,nf)
      close(unit=outd2)
      stop 'Done.'

      
9001  write(*,*)'FATAL ERROR: cannot open windows file > windows'//proj
      write(*,*)'This file must exist and contain windows information',
     &           ' for each file to be spliced'
      goto 9999

9002  write(*,*)'FATAL ERROR: File entered not from same station as',
     &           ' first file'
      write(*,*)'This version splices data from one station only'
      write(*,*)'To request changes, contact Alan Jones'
      goto 9999
      
9003  write(*,*)'FATAL ERROR: Different number of channels in this ',
     &           'file from first'
      write(*,*)'  nchan1 =', nchan1, '    nchan =', nchan
      goto 9999

9004  write(*,*)'FATAL ERROR: start time of this file is BEFORE end ',
     &           'of previous file'
      write(*,*)'  stime(nf) =', stime(nf),'   etime(nf-1) =', 
     &           etime(nf-1)   
      goto 9999

9005  write(*,*)'FATAL ERROR: digitizing rate different from first',
     &           ' file'
      write(*,*)'   delta1 =', delta1, '   delta =', delta
      goto 9999


9006  write(*,*)'FATAL ERROR: time units different from first',
     &           ' file'
      write(*,*)'   tunits1 =', tunits1, '   tunits =', tunits
      goto 9999
      
9999  stop 'Program terminated with error condition'      
      end
